/********************************************************************************/
/* File:   daxerrno.hpp                                                         */
/* Class:  exception error numbers                                              */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _daxerrno_hpp_
#define _daxerrno_hpp_
#ifndef DAX_ADD_READONLY

// Exception used by generated code

const short DAX_ADD_READONLY   =101;  // Add used on a readonly table/view
const short DAX_ADD_SQLERR     =102;  // SQL error occurred on add
const short DAX_UPD_READONLY   =103;  // Update used on a readonly table/view
const short DAX_UPD_SQLERR     =104;  // SQL error occurred on update
const short DAX_DEL_READONLY   =105;  // Delete used ona readonly table/view
const short DAX_DEL_SQLERR     =106;  // SQL error occurred on delete
const short DAX_RET_SQLERR     =107;  // SQL error occurred on retrieve
const short DAX_REF_SQLERR     =108;  // SQL error occurred on refresh
const short DAX_SEL_SQLERR     =109;  // SQL error occurred on select
const short DAX_ADD_NONNULL    =110;  // Add with non-nullable column not mapped
const short DAX_NUL_NONNULL    =111;  // Cannot SetToNull non-nullable column
const short DAX_DFT_READONLY   =112;  // Cannot SetReadOnly to false on a readonly table/view
const short DAX_SYS_LOCK       =113;  // Error occurred during system semaphore/locking call
const short DAX_ADD_NULL_DATAID=114;  // Add with a null DataId
const short DAX_UPD_NULL_DATAID=115;  // Update with a null DataId
const short DAX_RET_NULL_DATAID=116;  // Retrieve with a null DataId
const short DAX_DEL_NULL_DATAID=117;  // Delete with a null DataId

#endif
#endif



