/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <iptr.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)

template < class Element >
IBoolean IABag < Element >::
operator == (IABag < Element > const& collection) const
{ if (numberOfElements () != collection.numberOfElements ())
    return False;

  IAutoPointer < ICursor > cursor1 (newCursor (), IINIT);
  IBoolean result = True;
  for (cursor1->setToFirst ();
       cursor1->isValid ();
       setToNextDifferentElement (*cursor1)) {
    if (collection.numberOfOccurrences (elementAt (*cursor1)) !=
        numberOfOccurrences (elementAt (*cursor1))) {
      result = False;
      break;
    }
  }
  return result;
}

template < class Element >
IBoolean IABag < Element >::
operator != (IABag < Element > const& collection) const
{ return ! operator == (collection);
}

#pragma info (restore)
