/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IABAG_H
#define _IABAG_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element >
class IABag : public virtual IAEqualityCollection < Element > {
public:

  virtual
  void     addUnion         (IABag < Element > const&,
                             IABag < Element > const&) = 0;

  virtual
  void     addIntersection  (IABag < Element > const&,
                             IABag < Element > const&) = 0;

  virtual
  void     addDifference    (IABag < Element > const&,
                             IABag < Element > const&) = 0;

  virtual
  void     differenceWith   (IABag < Element > const&) = 0;

  virtual
  void     intersectionWith (IABag < Element > const&) = 0;

  virtual
  IBoolean locateNext       (Element const&, ICursor&) const = 0;

  virtual
  INumber  numberOfDifferentElements () const = 0;

  virtual
  INumber  numberOfOccurrences (Element const&) const = 0;

  virtual
  IBoolean operator ==      (IABag < Element > const&) const;

  virtual
  IBoolean operator !=      (IABag < Element > const&) const;

  virtual
  INumber  removeAllOccurrences (Element const&) = 0;

  virtual
  IBoolean setToNextDifferentElement (ICursor&) const = 0;

  virtual
  void     unionWith        (IABag < Element > const&) = 0;

};

#ifndef __TEMPINC__
#include <iabag.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
