/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <iptr.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)

template <class Element>
IACollection <Element> ::~IACollection ()
{
}

template <class Element>
void IACollection < Element >::
addAllFrom (IACollection < Element > const& collection)
{ ICHECK (! isIdentical (collection),
          IIdenticalCollectionException, IIdenticalCollectionText)
  IAutoPointer < ICursor > cursor (collection.newCursor (), IINIT);
  forCursor (*cursor) {
    add (collection.elementAt (*cursor));
  }
};

template <class Element>
void IACollection < Element >::
copy (IACollection < Element > const& collection)
{ if (! isIdentical (collection)) {
    removeAll ();
    addAllFrom (collection);
  }
};

template <class Element>
void* IACollection < Element >::
identity () const
{ return (void*) this;
}

#pragma info (restore)
