/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IAEQSEQ_H
#define _IAEQSEQ_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>
#include <iasqntl.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element >
class IAEqualitySequence :
  public virtual IAEqualityCollection < Element >,
  public virtual IASequentialCollection < Element > {
public:

  virtual
  long     compare        (IAEqualitySequence < Element > const&,
                           long (*comparisonFunction)
                            (Element const&, Element const&)) const;

  virtual
  IBoolean locateFirst    (Element const&, ICursor&) const = 0;

  virtual
  IBoolean locateLast     (Element const&, ICursor&) const = 0;

  virtual
  IBoolean locateNext     (Element const&, ICursor&) const = 0;

  virtual
  IBoolean locatePrevious (Element const&, ICursor&) const = 0;

  virtual
  INumber  numberOfOccurrences (Element const&) const = 0;

  virtual
  IBoolean operator ==    (IAEqualitySequence < Element > const&) const;

  virtual
  IBoolean operator !=    (IAEqualitySequence < Element > const&) const;

  virtual
  INumber  removeAllOccurrences (Element const&) = 0;

};

#ifndef __TEMPINC__
#include <iaeqseq.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
