/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <iptr.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)

template < class Element >
IBoolean IAEqualityCollection < Element >::
isContained (Element const& element, void* env)
{ return (*(IAEqualityCollection
             < Element >**) env)->contains (element);
}

template < class Element >
IBoolean IAEqualityCollection < Element >::
isNotContained (Element const& element, void* env)
{ return ! (*(IAEqualityCollection
               < Element >**) env)->contains (element);
}

template <class Element>
IBoolean IAEqualityCollection < Element >::
containsAllFrom (IACollection < Element > const& collection) const
{ IBoolean result = True;
  IAutoPointer < ICursor > cursor (collection.newCursor (), IINIT);
  forCursor (*cursor) {
    if (! contains (collection.elementAt (*cursor))) {
      result = False;
      break;
    }
  }
  return result;
};

#pragma info (restore)
