/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IAEQUAL_H
#define _IAEQUAL_H

#include <iglobals.h>
#include <icursor.h>
#include <iacllct.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element >
class IAEqualityCollection : public virtual IACollection < Element > {
public:

  virtual
  IBoolean contains             (Element const&) const = 0;

  virtual
  IBoolean containsAllFrom      (IACollection <Element> const&) const;

  virtual
  IBoolean locate               (Element const&, ICursor&) const = 0;

  virtual
  IBoolean locateOrAdd          (Element const&) = 0;

  virtual
  IBoolean locateOrAdd          (Element const&, ICursor&) = 0;

  virtual
  IBoolean locateNext           (Element const&, ICursor&) const = 0;

  virtual
  INumber  numberOfOccurrences  (Element const&) const = 0;

  virtual
  IBoolean remove               (Element const&) = 0;

  virtual
  INumber  removeAllOccurrences (Element const&) = 0;

protected:

  static
  IBoolean isContained          (Element const&, void* env);

  static
  IBoolean isNotContained       (Element const&, void* env);

};

#ifndef __TEMPINC__
#include <iaequal.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
