/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IAKEYSET_H
#define _IAKEYSET_H

#include <iglobals.h>
#include <icursor.h>
#include <iakey.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key >
class IAKeySet : public virtual IAKeyCollection < Element, Key > {
protected:

  IBoolean locateNextElementWithKey    (Key const&, ICursor&) const;

  INumber  numberOfDifferentKeys       () const;

  INumber  numberOfElementsWithKey     (Key const&) const;

  INumber  removeAllElementsWithKey    (Key const&);

  IBoolean setToNextWithDifferentKey   (ICursor&) const;

};

#ifndef __TEMPINC__
#include <iakeyset.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
