/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IAKSSET_H
#define _IAKSSET_H

#include <iglobals.h>
#include <icursor.h>
#include <iaksrt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key >
class IAKeySortedSet :
  public virtual IAKeySortedCollection < Element, Key > {
public:

  virtual
  long     compare        (IAKeySortedSet < Element, Key > const&,
                           long (*comparisonFunction)
                            (Element const&, Element const&)) const;

protected:

  INumber  numberOfElementsWithKey   (Key const&) const;

  INumber  removeAllElementsWithKey  (Key const&);

  INumber  numberOfDifferentKeys     () const;

  IBoolean setToNextWithDifferentKey (ICursor&) const;

};

#ifndef __TEMPINC__
#include <iaksset.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
