/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IAMAP_H
#define _IAMAP_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqkey.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key >
class IAMap :
  public virtual IAEqualityKeyCollection < Element, Key > {
public:

  virtual
  void     addDifference    (IAMap < Element, Key > const&,
                             IAMap < Element, Key > const&) = 0;

  virtual
  void     addIntersection  (IAMap < Element, Key > const&,
                             IAMap < Element, Key > const&) = 0;

  virtual
  void     addUnion         (IAMap < Element, Key > const&,
                             IAMap < Element, Key > const&) = 0;

  virtual
  void     differenceWith   (IAMap < Element, Key > const&) = 0;

  virtual
  void     intersectionWith (IAMap < Element, Key > const&) = 0;

  virtual
  IBoolean operator ==      (IAMap < Element, Key > const&) const;

  virtual
  IBoolean operator !=      (IAMap < Element, Key > const&) const;

  virtual
  void     unionWith        (IAMap < Element, Key > const&) = 0;

protected:

  IBoolean locateNext       (Element const&, ICursor&) const;

  IBoolean locateNextElementWithKey (Key const&, ICursor&) const;

  INumber  removeAllOccurrences (Element const&);

  INumber  numberOfDifferentKeys () const;

  INumber  numberOfElementsWithKey (Key const&) const;

  INumber  numberOfOccurrences (Element const&) const;

  INumber  removeAllElementsWithKey (Key const&);

  IBoolean setToNextWithDifferentKey (ICursor&) const;

};

#ifndef __TEMPINC__
#include <iamap.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
