/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IAORDER_H
#define _IAORDER_H

#include <iglobals.h>
#include <icursor.h>
#include <iacllct.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element >
class IAOrderedCollection : public virtual IACollection < Element > {
public:

  virtual
  Element const&
           firstElement     () const = 0;

  virtual
  IBoolean isFirst          (ICursor const&) const = 0;

  virtual
  IBoolean isLast           (ICursor const&) const = 0;

  virtual
  Element const&
           lastElement      () const = 0;

  virtual
  Element const&
           elementAtPosition (IPosition) const = 0;

  virtual
  IBoolean setToLast        (ICursor&) const = 0;

  virtual
  void     removeAtPosition (IPosition) = 0;

  virtual
  void     removeFirst      () = 0;

  virtual
  void     removeLast       () = 0;

  virtual
  void     setToPosition    (IPosition, ICursor&) const = 0;

#ifndef __BIN_COMPAT_BASE_43__
  virtual
  IPosition     position    (ICursor const&) const = 0;
#endif

  virtual
  IBoolean setToPrevious    (ICursor&) const = 0;

};

#pragma info (restore)
#pragma pack ()

#endif
