/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)

template < class Element, class Key >
INumber IARelation < Element, Key >::
numberOfOccurrences (Element const& element) const
{ if (contains (element))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
IBoolean IARelation < Element, Key >::
locateNext (Element const&, ICursor& cursor) const
{ elementAt (cursor); // just for precondition checking
  cursor.invalidate ();
  return False;
}

template < class Element, class Key >
INumber IARelation < Element, Key >::
removeAllOccurrences (Element const& element)
{ if (remove (element))
    return 1;
  else
    return 0;
}

template < class Element, class Key >
IBoolean IARelation < Element, Key >::
operator == (IARelation < Element, Key > const& collection) const
{ if (numberOfElements () != collection.numberOfElements ())
    return False;

  return containsAllFrom (collection);

}

template < class Element, class Key >
IBoolean IARelation < Element, Key >::
operator != (IARelation < Element, Key > const& collection) const
{ return ! operator == (collection);
}

#pragma info (restore)
