/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IAREL_H
#define _IAREL_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqkey.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key >
class IARelation :
  public virtual IAEqualityKeyCollection < Element, Key > {
public:

  virtual
  void     addDifference    (IARelation < Element, Key > const&,
                             IARelation < Element, Key > const&) = 0;

  virtual
  void     addIntersection  (IARelation < Element, Key > const&,
                             IARelation < Element, Key > const&) = 0;

  virtual
  void     addUnion         (IARelation < Element, Key > const&,
                             IARelation < Element, Key > const&) = 0;

  virtual
  void     differenceWith   (IARelation < Element, Key > const&) = 0;

  virtual
  void     intersectionWith (IARelation < Element, Key > const&) = 0;

  virtual
  IBoolean operator ==      (IARelation < Element, Key > const&) const;

  virtual
  IBoolean operator !=      (IARelation < Element, Key > const&) const;

  virtual
  void     unionWith        (IARelation < Element, Key > const&) = 0;

protected:

  IBoolean locateNext       (Element const&, ICursor&) const;

  INumber  numberOfOccurrences (Element const&) const;

  INumber  removeAllOccurrences (Element const&);

};

#ifndef __TEMPINC__
#include <iarel.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
