/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IASET_H
#define _IASET_H

#include <iglobals.h>
#include <icursor.h>
#include <iaequal.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element >
class IASet : public virtual IAEqualityCollection < Element > {
public:

  virtual
  void     addDifference        (IASet < Element > const&,
                                 IASet < Element > const&) = 0;

  virtual
  void     addIntersection      (IASet < Element > const&,
                                 IASet < Element > const&) = 0;

  virtual
  void     addUnion             (IASet < Element > const&,
                                 IASet < Element > const&) = 0;

  virtual
  void     differenceWith       (IASet < Element > const&) = 0;

  virtual
  void     intersectionWith     (IASet < Element > const&) = 0;

  virtual
  IBoolean operator ==          (IASet < Element > const&) const;

  virtual
  IBoolean operator !=          (IASet < Element > const&) const;

  virtual
  void     unionWith            (IASet < Element > const&) = 0;

protected:

  IBoolean locateNext           (Element const&, ICursor&) const;

  INumber  numberOfOccurrences  (Element const&) const;

  INumber  removeAllOccurrences (Element const&);

};

#ifndef __TEMPINC__
#include <iaset.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
