/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IASQNTL_H
#define _IASQNTL_H

#include <iglobals.h>
#include <icursor.h>
#include <iaorder.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element >
class IASequentialCollection :
  public virtual IAOrderedCollection < Element > {
public:

  virtual
  void     addAsFirst       (Element const&) = 0;

  virtual
  void     addAsFirst       (Element const&, ICursor&) = 0;

  virtual
  void     addAsLast        (Element const&) = 0;

  virtual
  void     addAsLast        (Element const&, ICursor&) = 0;

  virtual
  void     addAsNext        (Element const&, ICursor&) = 0;

  virtual
  void     addAsPrevious    (Element const&, ICursor&) = 0;

  virtual
  void     addAtPosition    (IPosition, Element const&) = 0;

  virtual
  void     addAtPosition    (IPosition, Element const&, ICursor&) = 0;

  virtual
  void     sort             (long (*comparisonFunction)
                              (Element const&, Element const&)) = 0;

};

#pragma info (restore)
#pragma pack ()

#endif
