/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IASRTMAP_H
#define _IASRTMAP_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqksrt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key >
class IASortedMap :
  public virtual IAEqualityKeySortedCollection < Element, Key > {
public:

  virtual
  void     addDifference    (IASortedMap < Element, Key > const&,
                             IASortedMap < Element, Key > const&) = 0;

  virtual
  void     addIntersection  (IASortedMap < Element, Key > const&,
                             IASortedMap < Element, Key > const&) = 0;

  virtual
  void     addUnion         (IASortedMap < Element, Key > const&,
                             IASortedMap < Element, Key > const&) = 0;

  virtual
  long     compare          (IASortedMap < Element, Key > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  virtual
  void     differenceWith   (IASortedMap < Element, Key > const&) = 0;

  virtual
  void     intersectionWith (IASortedMap < Element, Key > const&) = 0;

  virtual
  IBoolean operator ==      (IASortedMap < Element, Key > const&) const;

  virtual
  IBoolean operator !=      (IASortedMap < Element, Key > const&) const;

  virtual
  void     unionWith        (IASortedMap < Element, Key > const&) = 0;

protected:

  INumber  numberOfOccurrences (Element const&) const;

  INumber  removeAllOccurrences (Element const&);

  INumber  numberOfElementsWithKey (Key const&) const;

  INumber  removeAllElementsWithKey (Key const&);

  INumber  numberOfDifferentKeys () const;

  IBoolean setToNextWithDifferentKey (ICursor&) const;

};

#ifndef __TEMPINC__
#include <iasrtmap.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
