/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IASRTREL_H
#define _IASRTREL_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqksrt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key >
class IASortedRelation :
  public virtual IAEqualityKeySortedCollection < Element, Key > {
public:

  virtual
  void     addDifference    (IASortedRelation < Element, Key > const&,
                             IASortedRelation < Element,
                                                Key > const&) = 0;

  virtual
  void     addIntersection  (IASortedRelation < Element, Key > const&,
                             IASortedRelation < Element,
                                                Key > const&) = 0;

  virtual
  void     addUnion         (IASortedRelation < Element, Key > const&,
                             IASortedRelation < Element,
                                                Key > const&) = 0;

  virtual
  long     compare          (IASortedRelation < Element, Key > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  virtual
  void     differenceWith   (IASortedRelation < Element,
                                                Key > const&) = 0;

  virtual
  void     intersectionWith (IASortedRelation < Element,
                                                Key > const&) = 0;

  virtual
  IBoolean operator ==      (IASortedRelation < Element,
                                                Key > const&) const;

  virtual
  IBoolean operator !=      (IASortedRelation < Element,
                                                Key > const&) const;

  virtual
  void     unionWith        (IASortedRelation < Element,
                                                Key > const&) = 0;

protected:

  INumber  numberOfOccurrences (Element const&) const;

  INumber  removeAllOccurrences (Element const&);

};

#ifndef __TEMPINC__
#include <iasrtrel.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
