/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IASRTSET_H
#define _IASRTSET_H

#include <iglobals.h>
#include <icursor.h>
#include <iaeqsrt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element >
class IASortedSet :
  public virtual IAEqualitySortedCollection < Element > {
public:

  virtual
  void     addDifference    (IASortedSet < Element > const&,
                             IASortedSet < Element > const&) = 0;

  virtual
  void     addIntersection  (IASortedSet < Element > const&,
                             IASortedSet < Element > const&) = 0;

  virtual
  void     addUnion         (IASortedSet < Element > const&,
                             IASortedSet < Element > const&) = 0;

  virtual
  long     compare          (IASortedSet < Element > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  virtual
  void     differenceWith   (IASortedSet < Element > const&) = 0;

  virtual
  void     intersectionWith (IASortedSet < Element > const&) = 0;

  virtual
  IBoolean operator ==      (IASortedSet < Element > const&) const;

  virtual
  IBoolean operator !=      (IASortedSet < Element > const&) const;

  virtual
  void     unionWith        (IASortedSet < Element > const&) = 0;

protected:

  INumber  numberOfOccurrences (Element const&) const;

  INumber  removeAllOccurrences (Element const&);

};

#ifndef __TEMPINC__
#include <iasrtset.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
