/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)

#ifdef ICL_NO_INLINE
#define inline
#include <ibagks.inl>
#undef inline
#endif


template <class Element, class ElementOps, class Base >
IBoolean IWBagOnKeySetCursor <Element, ElementOps, Base >::
setToFirst ()
{ ivOccurrence = 1;
  return ivBaseCursor.setToFirst ();
}

template <class Element, class ElementOps, class Base >
IBoolean IWBagOnKeySetCursor <Element, ElementOps, Base >::
setToNext ()
{ ICHECK (isValid (), ICursorInvalidException, IInvalidCursorText)
  if (ivOccurrence == ivBaseCursor.element().ivOccurrences) {
    ivOccurrence = 1;
    return ivBaseCursor.setToNext ();
  }
  else {
    ivOccurrence++;
    return True;
  }
}

template <class Element, class ElementOps, class Base >
IBoolean IWBagOnKeySetCursor <Element, ElementOps, Base >::
isValid () const
{ return ivBaseCursor.isValid ();
}

template <class Element, class ElementOps, class Base >
void IWBagOnKeySetCursor <Element, ElementOps, Base >::
invalidate ()
{ ivBaseCursor.invalidate ();
}

template <class Element, class ElementOps, class Base >
void IWBagOnKeySetCursor <Element, ElementOps, Base >::
copy (ICursor const& cursor)
{ operator= ((IWBagOnKeySetCursor
               < Element, ElementOps, Base > const&) cursor);
}

template <class Element, class ElementOps, class Base >
IBoolean IWBagOnKeySetCursor <Element, ElementOps, Base >::
operator== (ICursor const& cursor) const
{ return operator== ((IWBagOnKeySetCursor
                       < Element, ElementOps, Base > const&) cursor);
}

template <class Element, class ElementOps, class Base >
Element const& IWBagOnKeySetCursor <Element, ElementOps, Base >::
element () const
{ return ivBaseCursor.element ().ivElem;
}


template <class Element, class ElementOps, class Base>
IBoolean IWBagOnKeySet <Element, ElementOps, Base>::
removePredicate (IBKeyElm < Element > const& element, void* env)
{ RemoveEnv* re = (RemoveEnv*)env;
  IBoolean result = (*re->predicate) (element.ivElem, re->env);
  if (result)
    re->removeCount += element.ivOccurrences;
  return result;
}

template <class Element, class ElementOps, class Base>
IBoolean IWBagOnKeySet <Element, ElementOps, Base>::
cleanupPredicate (IBKeyElm < Element > const& element, void* env)
{ return element.ivOccurrences == 0;
}

#pragma info (restore)
