/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IBEXCTXT_H
#define _IBEXCTXT_H

#include <ibexcdef.h>
#include <imsgtext.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

class ICollectionExceptionText  {
/***********************************************************************
*  This class loads exception text from a resource file.               *
*                                                                      *
*  Typically an instance of this class is created when an error        *
*  condition has been detected, and an exception is going to be thrown.*
*  The exception text can be used to construct an IException subclass  *
*  instance.                                                           *
*                                                                      *
* EXAMPLE:                                                             *
*                                                                      *
*    if (errorCondition)                                               *
*    {                                                                 *
*       ICollectionExceptionText myTxt ( messageIdForErrorCondition ); *
*       IInvalidRequest exc (myTxt, idForErrorCondition, 0);           *
*       ITHROW(exc);                                                   *
*    }                                                                 *
*                                                                      *
***********************************************************************/

public:

  ICollectionExceptionText  ( unsigned long resourceId );

  ~ICollectionExceptionText ( );

/*-------------------------------- ACCESSORS ---------------------------
| The following conversion operator and function provide means of      |
| getting the exception text from instances of this class:             |
|   const char* - Returns the exception text.                          |
|   text        - Returns the exception text.                          |
----------------------------------------------------------------------*/

  operator const char*  () const;

const char*
  text ( ) const;

private:

IMessageText  * ivMsgTxt;

};

#include <ibexctxt.inl>

#pragma info (restore)
#pragma pack ()

#endif
