#ifndef _ICCONST_
#define _ICCONST_
/*******************************************************************************
* FILE NAME: icconst.h                                                         *
*                                                                              *
* DESCRIPTION:                                                                 *
*   User Interface resource identifier macro constants.                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <icconsta.h>

// Identifiers for class library errors.

#define IC_ASSERTPARM                          1
#define IC_MEMBER_ACCESS_ERROR                 2
#define IC_UNEXPECTED_ERROR                    3
#define IC_HEAP_EXHAUSTED                      4

#define IC_THIS_PLATFORM_NOT_SUPPORTED        10  // Unsupported function on this platform.

#define IC_RELEASEPSFAIL                      30  // Release PS failed.
#define IC_INVALIDCHARCODE                    31  // Character code is not valid for this keyboard event.
#define IC_INVALIDSCANCODE                    32  // Scan code is not valid for this keyboard event.
#define IC_INVALIDVIRTUALKEY                  33  // Virtual key is not valid for this keyboard event.
#define IC_PRESPARAMNOTFOUND                  34  // Presentation parameter value not found.
#define IC_INVALIDCOLORINDEX                  35  // Invalid color index specified.
#define IC_INVALIDEVENT                       36  // Event (message) is invalid for this function.
#define IC_DBCSCHARASSERT                     37  // DBCS string cannot be represend as SBCS.
#define IC_DBCSSCANCODEASSERT                 38  // Scan code not valid for DBCS input.
#define IC_INVALIDENUMVALUE                   39  // Uninitialized enumerator value found.
#define IC_NOMARKEDTEXT                       40  // No marked text to copy, cut, clear, or delete.
#define IC_CLIPBOARDEMPTY                     41  // No data in the copyboard for pasting.
#define IC_HANDLERNOTFOUND                    42  // removeHandler and handler not found.
#define IC_INVALIDSTYLE                       43  // Incompatible styles specified.
#define IC_INVALIDSIZE                        44
#define IC_FRAME_EXTENSION_NOT_FOUND          45
#define IC_INVALID_THREAD_ID                  46
#define IC_THREAD_STARTED                     47
#define IC_SUSPEND_PM_THREAD                  48
#define IC_SEMAPHORES_EXHAUSTED               49
#define IC_VIEWPORT_INVALID_SCROLL            50
#define IC_CNROBJ_INVALID_OBJECTCOPY          53
#define IC_CNROBJ_INVALID_CREATE              54
#define IC_MULTICELLCANVAS_CELL_OVERLAP       55
#define IC_DISPATCHTO_INVALID_HANDLER         56  // Attempt to dispatch to a "dead" handler.
#define IC_INVALIDSIZE_LIMIT                  57
#define IC_NULL_IREFERENCE                    58
#define IC_XMCREATE_FAILURE                   59
#define IC_XMSTRING_INIT_FAILURE              60  // Failure on XmStringInitContext.
#define IC_INVALIDHANDLE                      61  // IWindow::handle.
#define IC_NO_WINDOW_WITHID                   62  // IWindow::startHandlingEvents.
#define IC_PARENT_IS_NOT_IWINDOW              63  // IRadioButton::selectedIndex, others?
#define IC_CONTROL_NOT_FOUND                  64  // Cannot find a desired window handle (e.g. by name, using XtNameToWidget).
#define IC_WRONG_CONTROL_TYPE                 65  // Window handle is not of the (desired) type (e.g. you need an XmText, or WC_ENTRYFIELD).
#define IC_THREAD_VARIABLE_LIMIT_EXCEEDED     66  // setVariable limit of 16 exceeded.
#define IC_VECTOR_FONT_ONLY_FUNCTION          67  // Function only valid for vector fonts.
#define IC_CNRALLOCATOR_LIMIT_EXCEEDED        68
#define IC_CNRALLOCATOR_INVALIDNUMVALUE       69
#define IC_MUST_HAVE_TITLE_TEXT               70

#define IC_HELPERRORMSGBOX_TITLE              80
#define IC_HMERR_LOAD_DLL                     81
#define IC_HMERR_NO_FRAME_WND_IN_CHAIN        82
#define IC_HMERR_INVALID_ASSOC_APP_WND        83
#define IC_HMERR_INVALID_ASSOC_HELP_INST      84
#define IC_HMERR_INVALID_QUERY_APP_WND        85
#define IC_HMERR_HELPTABLE_UNDEFINE           86
#define IC_HMERR_HELP_INSTANCE_UNDEFINE       87
#define IC_HMERR_HELPITEM_NOT_FOUND           88
#define IC_HMERR_INDEX_NOT_FOUND              89
#define IC_HMERR_CONTENT_NOT_FOUND            90
#define IC_HMERR_OPEN_LIB_FILE                91
#define IC_HMERR_READ_LIB_FILE                92
#define IC_HMERR_CLOSE_LIB_FILE               93
#define IC_HMERR_INVALID_LIB_FILE             94
#define IC_HMERR_NO_MEMORY                    95
#define IC_HMERR_FREE_MEMORY                  96
#define IC_HMERR_PANEL_NOT_FOUND              97
#define IC_HMERR_DATABASE_NOT_OPEN            98
#define IC_HMERR_UNKNOWN                      99
#define IC_THREAD_NOT_PROCESSING_MSGS        100
#define IC_FRAME_EXTENSION_IN_USE            101
#define IC_HMERR_FONT_ERROR                  102
#define IC_FONT_ACCESS_ERROR                 103
#define IC_NOSTATUSTEXTLINE                  104

#define IC_DDE_SERVER_IN_CONVERSATION        121
#define IC_DDE_CLIENT_NOT_IN_CONVERSATION    122
#define IC_DDE_SERVER_NOT_IN_CONVERSATION    123
#define IC_DDE_WINDDEINITIATE                124
#define IC_DDE_WINDDEPOSTMESSAGE_USER        125
#define IC_DDE_HOTLINK_ACTIVE                128
#define IC_DDE_HOTLINK_PENDING               129
#define IC_DDE_NO_HOTLINK                    130
#define IC_DDE_NO_HOTLINKS                   131
#define IC_DDE_NO_HOTLINKS_ITEM              132
#define IC_DDE_END_HOTLINK_PENDING           133
#define IC_DDE_END_HOTLINKS_ITEM_PENDING     134
#define IC_DDE_END_HOTLINKS_PENDING          135
#define IC_DDE_SYNCHRONIZATION               136
#define IC_SLDR_RECT_TOO_SMALL               137  /* ISlider */
#define IC_INVALID_RANGE_OPERATION           138  /* ISpinButton */
#define IC_INVALID_TEXT_OPERATION            139  /* ISpinButton */
#define IC_SET_SPIN_ARRAY_FAIL               140  /* ISpinButton */
#define IC_SETMENUITEM_FAIL                  141  /* IMenu */
#define IC_INVALID_MENUITEM                  142  /* IMenu */
#define IC_NO_SYSTEMMENU                     143  /* ISystemMenu */
#define IC_NO_FRAME_MENUBAR                  144  /* IMenuBar */
#define IC_NO_BITMAP_HANDLE                  145  /* IMenu */
#define IC_VALUE_OUT_OF_RANGE                146  /* ISpinButton */
#define IC_NO_MENU_SELECTED                  147  /* IMenu */
#define IC_ADD_SUBMENU_FAIL                  148  /* IMenu */
#define IC_NO_TITLEBAR                       149  /* ITitle */
#define IC_SLDR_SET_CTLDATA                  150
#define IC_SLDR_GET_CTLDATA                  151
#define IC_NO_SUBMENU                        152
#define IC_NO_HELP_COVERPAGE                 153
#define IC_INVALID_INDEX                     154  /* IListBox and IComboBox */
#define IC_UNKNOWN_RENDERING_FORMAT          155
#define IC_UNKNOWN_RENDERING_MECHANISM       156
#define IC_RFPROCESS_FOR_SAME_PROCESS        157
#define IC_RENDER_AT_SOURCE_FAILED           158
#define IC_DRAGTRANSFER_INVALID              159
#define IC_NO_SOURCE_OBJECT_SUPPLIED         160
#define IC_INDEX_OUT_OF_RANGE                161
#define IC_TARGET_ITEM_PROVIDER_FAILED       162
#define IC_DRAGITEM_INVALID                  163
#define IC_CLIPBOARD_LOCKED                  164 /* ITextControl */
#define IC_CLIPBOARD_TRUNCATE                165 /* ITextControl */
#define IC_INVALID_FRAME_SHELL               166 /* IFrame       */
#define IC_SLDR_INVALID_TICK_COUNT           167 /* ISlider */
#define IC_SLDR_INVALID_TICK_NUMBER          168 /* ISlider */
#define IC_SLDR_INVALID_PIXEL                169 /* ISlider */

#define IC_APPLICATION_INITIALIZE            170 /* IThread */
#define IC_MODIFIER_MISMATCH                 171 /* IThread */

#define IC_INVALID_TIMER_ID                  172 /* ITimer */
#define IC_TIMER_STARTED                     173 /* ITimer */
#define IC_TIMER_ID_UNAVAILABLE              174 /* ITimer */

#define IC_INVALID_CLASS                     180 /* Controls (see also IC_WRONG_CONTROL_TYPE) */
#define IC_INVALID_VISIBLECOUNT              181 /* IScrollBar */
#define IC_NAME_NOT_FOUND                    182 /* Widget Name not found. */
#define IC_TEXT_NOT_FOUND                    183 /* IListBox and IComboBox */
#define IC_EMPTY_LIST                        184 /* IListBox and IComboBox */
#define IC_GUI_ERROR                         185 /* Default Error message for IGUIErrorInfo. */
#define IC_SYSTEM_ERROR                      186 /* Default Error message for ISystemErrorInfo. */
#define IC_NUMSPIN_WRAP_INVALID              190 /* INumericSpinButton */
#define IC_TXTSPIN_WRAP_INVALID              191 /* ITextSpinButton */
#define IC_SPINTO_TEXT_INVALID               192 /* ITextSpinButton */
#define IC_NO_SELECTION                      193 /* IListBox and IComboBox */
#define IC_SINGLE_SELECT_LIST                194 /* IListBox and IComboBox */

#define IC_LABEL_ABORT                       201 /* IMessageBox "Abort"  */
#define IC_LABEL_RETRY                       202 /* IMessageBox "Retry"  */
#define IC_LABEL_IGNORE                      203 /* IMessageBox "Ignore" */
#define IC_LABEL_ENTER                       204 /* IMessageBox "Enter"  */
#define IC_LABEL_HELP                        205 /* IFontDialog "Help"   */
#define IC_LABEL_APPLY                       206 /* IFontDialog "Apply"  */
#define IC_LABEL_RESET                       207 /* IFontDialog "Reset"  */
#define IC_LABEL_OK                          208 /* IFontDialog "OK"     */
#define IC_LABEL_CANCEL                      209 /* IFontDialog "Cancel" */

#define IC_INVALID_PICTURE_ID                210 /* IPictureVerifyHandler */
#define IC_INVALID_PICTURE_QUOTE             211 /* IPictureVerifyHandler */
#define IC_INVALID_PICTURE_RANGE             212 /* IPictureVerifyHandler */


#define IC_MAPPOINT_FAILED                   250 /* Could not map point. */
#define IC_LABEL_YES                         251 /* IMessageBox "Yes"    */
#define IC_LABEL_NO                          252 /* IMessageBox "No"     */
#define IC_LABEL_FONTDLG_SEL                 253 /* IFontDialog Selection label. */
#define IC_LABEL_FONTDLG_POINTSEL            254 /* IFontDialog point size label. */

#define IC_NOCLIPBOARDDATA                   255
#define IC_REGISTERCLIPBOARDFORMATFAILED     256
#define IC_CLIPBOARDFORMATNOTFOUND           257

// The following identifiers are used for exception handling in the GBM
// image handling code.

#define IC_GBM_UNKNOWN_ERROR                 258
#define IC_GBM_OPEN_FAILED                   259
#define IC_GBM_CREATE_FAILED                 260
#define IC_GBM_NO_SUPPORT                    261
#define IC_GBM_HDC_FAILED                    262
#define IC_GBM_HPS_FAILED                    263
#define IC_GBM_METAFILE_FAILED               264
#define IC_GBM_BITMAP_FAILED                 265
#define IC_GBM_NEED_CLIPPED                  266
#define IC_GBM_NOT_SUPPORTED                 267
#define IC_GBM_BAD_OPTION                    268
#define IC_GBM_NOT_FOUND                     269
#define IC_GBM_BAD_MAGIC                     270
#define IC_GBM_BAD_SIZE                      271
#define IC_GBM_READ_FAILED                   272
#define IC_GBM_WRITE_FAILED                  273
#define IC_GBM_BMP_PLANES                    274
#define IC_GBM_BMP_BITCOUNT                  275
#define IC_GBM_BMP_CBFIX                     276
#define IC_GBM_BMP_COMP                      277
#define IC_GBM_BMP_OFFSET                    278
#define IC_GBM_GIF_BPP                       279
#define IC_GBM_GIF_TERM                      280
#define IC_GBM_GIF_CODE_SIZE                 281
#define IC_GBM_GIF_CORRUPT                   282
#define IC_GBM_IAX_SIZE                      283
#define IC_GBM_KPS_OPEN                      284
#define IC_GBM_KPS_CREATE                    285
#define IC_GBM_LBM_FORM                      286
#define IC_GBM_LBM_ILBM                      287
#define IC_GBM_LBM_BMHD_2                    288
#define IC_GBM_LBM_BMHD_0                    289
#define IC_GBM_LBM_BMHD_SIZE                 290
#define IC_GBM_LBM_BPP                       291
#define IC_GBM_LBM_CMAP_SIZE                 292
#define IC_GBM_LBM_COMP                      293
#define IC_GBM_LBM_CAMG_SIZE                 294
#define IC_GBM_LBM_SHAM_VER                  295
#define IC_GBM_PCX_BAD_VERSION               296
#define IC_GBM_PCX_BAD_ENCMODE               297
#define IC_GBM_PCX_BAD_BITS                  298
#define IC_GBM_PCX_BAD_TRAILER               299
#define IC_GBM_PGM_BAD_M                     300
#define IC_GBM_PSEG_NOT_5A                   301
#define IC_GBM_PSEG_BAD_RECORD               302
#define IC_GBM_PSEG_SIZE                     303
#define IC_GBM_PSEG_INV_WIDTH                304
#define IC_GBM_PSEG_INV_DEFCEL               305
#define IC_GBM_PSEG_INV_CEL                  306
#define IC_GBM_PSEG_INV_CELPOS               307
#define IC_GBM_PSEG_UNEX_REC                 308
#define IC_GBM_SPR_FIRST                     309
#define IC_GBM_SPR_MODE                      310
#define IC_GBM_SPR_OFFSET                    311
#define IC_GBM_SPR_PAL8                      312
#define IC_GBM_TGA_BAD_BPP                   313
#define IC_GBM_TGA_BAD_TYPE                  314
#define IC_GBM_TGA_BAD_PAL                   315
#define IC_GBM_TIF_VERSION                   316
#define IC_GBM_TIF_N_TAGS                    317
#define IC_GBM_TIF_TAG_TYPE                  318
#define IC_GBM_TIF_HEADER                    319
#define IC_GBM_TIF_MISSING_TAG               320
#define IC_GBM_TIF_SPP_BIT                   321
#define IC_GBM_TIF_BPS_BIT                   322
#define IC_GBM_TIF_SPP_RGB                   323
#define IC_GBM_TIF_BPS_RGB                   324
#define IC_GBM_TIF_SPP_PAL                   325
#define IC_GBM_TIF_BPS_PAL                   326
#define IC_GBM_TIF_SPP_CMYK                  327
#define IC_GBM_TIF_BPS_CMYK                  328
#define IC_GBM_TIF_COMP_1D_MH                329
#define IC_GBM_TIF_COMP_T4                   330
#define IC_GBM_TIF_COMP_T6                   331
#define IC_GBM_TIF_COMP                      332
#define IC_GBM_TIF_COLORMAP                  333
#define IC_GBM_TIF_CORRUPT                   334
#define IC_GBM_TIF_PREDICTOR                 335
#define IC_GBM_TIF_PHOTO_TRANS               336
#define IC_GBM_TIF_PHOTO_Y_Cb_Cr             337
#define IC_GBM_TIF_PHOTO                     338
#define IC_GBM_TIF_FILLORDER                 339
#define IC_GBM_TIF_PLANARCONFIG_1            340
#define IC_GBM_TIF_PLANARCONFIG_12           341
#define IC_GBM_TIF_INKSET                    342
#define IC_GBM_TIF_ORIENT                    343
#define IC_GBM_TIF_INDEX                     344
#define IC_GBM_VID_BAD_W                     345
#define IC_GBM_XBM_EXP_ID                    346
#define IC_GBM_XBM_UNEXP_EOF                 347
#define IC_GBM_XBM_EXP_CHAR                  348
#define IC_GBM_XBM_EXP_LSQR                  349
#define IC_GBM_XBM_EXP_RSQR                  350
#define IC_GBM_XBM_EXP_EQUALS                351
#define IC_GBM_XBM_EXP_LCUR                  352
#define IC_GBM_XBM_EXP_RCUR                  353
#define IC_GBM_XBM_EXP_COMMA                 354
#define IC_GBM_XBM_EXP_NUMBER                355
#define IC_GBM_XBM_EXP_SEMI                  356

#define IC_TOOLBAR_POINTER_TOP               357
#define IC_TOOLBAR_POINTER_BOTTOM            358
#define IC_TOOLBAR_POINTER_LEFT              359
#define IC_TOOLBAR_POINTER_RIGHT             360
#define IC_TOOLBAR_POINTER_TOP_2             361
#define IC_TOOLBAR_POINTER_BOTTOM_2          362
#define IC_TOOLBAR_POINTER_LEFT_2            363
#define IC_TOOLBAR_POINTER_RIGHT_2           364

// Window identifiers for frames and standard frame components.
#define IC_DEFAULT_FRAME_ID                 1000
#define IC_FRAME_MENU_ID                    (0x8005)  /* FID_MENU */
#define IC_FRAME_CLIENT_ID                  (0x8008)  /* FID_CLIENT */

// The IC_ID_BASE constant is defined both here and in ibase.hpp.
// It is defined here to allow its use in resource files or other
// places where a C++ header cannot be used.
#ifndef IC_ID_BASE
  #define IC_ID_BASE            ( 0x7000 )
#endif

// The following identifiers are defined and may be used when constructing
// IToolBarButtons for standard operations.
#define IC_ID_OPEN         (IC_ID_BASE + 0x0001)
#define IC_ID_SAVE         (IC_ID_BASE + 0x0002)
#define IC_ID_PRINT        (IC_ID_BASE + 0x0003)
#define IC_ID_LOCATE       (IC_ID_BASE + 0x0004)
#define IC_ID_CUT          (IC_ID_BASE + 0x0005)
#define IC_ID_COPY         (IC_ID_BASE + 0x0006)
#define IC_ID_PASTE        (IC_ID_BASE + 0x0007)
#define IC_ID_HELP         (IC_ID_BASE + 0x0008)
#define IC_ID_BOLD         (IC_ID_BASE + 0x0009)
#define IC_ID_ITALIC       (IC_ID_BASE + 0x000A)
#define IC_ID_UNDERSCORE   (IC_ID_BASE + 0x000B)
#define IC_ID_SETTINGS     (IC_ID_BASE + 0x000C)
#define IC_ID_COPYTO       (IC_ID_BASE + 0x000D)

// The following identifiers are defined and used by the class libary
// when constructing special IToolBarButtons.
#define IC_ID_DEFAULT      (IC_ID_BASE + 0x0101)
#define IC_ID_OWNERMOVE    (IC_ID_BASE + 0x0102)
#define IC_ID_NOOWNERMOVE  (IC_ID_BASE + 0x0103)
#define IC_ID_SHOWHIDE     (IC_ID_BASE + 0x0105)
#define IC_ID_SHOW         (IC_ID_BASE + 0x0106)
#define IC_ID_HIDE         (IC_ID_BASE + 0x0107)

#define IC_SMALLSYSTEMMENU (IC_ID_BASE + 0x0111) /* Small system menu for floating toolbars. */
#define IC_FADEICON        (IC_ID_BASE + 0x0112) /* Fade icon for drag. */
#define IC_FF              (IC_ID_BASE + 0x0113) /* IAnimatedButton "FastForward" */
#define IC_REWIND          (IC_ID_BASE + 0x0114) /* IAnimatedButton "Rewind" */
#define IC_RECORD          (IC_ID_BASE + 0x0115) /* IAnimatedButton "Record" */
#define IC_PAUSE           (IC_ID_BASE + 0x0116) /* IAnimatedButton "Pause" */
#define IC_TRKR            (IC_ID_BASE + 0x0117) /* IAnimatedButton "Track Reverse" */
#define IC_TRKA            (IC_ID_BASE + 0x0118) /* IAnimatedButton "Track Advance" */
#define IC_STOP            (IC_ID_BASE + 0x0119) /* IAnimatedButton "Stop" */
#define IC_STEPF           (IC_ID_BASE + 0x011A) /* IAnimatedButton "StepForward" */
#define IC_STEPB           (IC_ID_BASE + 0x011B) /* IAnimatedButton "StepBackward" */
#define IC_EJECT           (IC_ID_BASE + 0x011C) /* IAnimatedButton "Eject" */
#define IC_SCANF1          (IC_ID_BASE + 0x011D) /* IAnimatedButton "ScanForward1" */
#define IC_SCANF2          (IC_ID_BASE + 0x011E) /* IAnimatedButton "ScanForward2" */
#define IC_SCANF3          (IC_ID_BASE + 0x011F) /* IAnimatedButton "ScanForward3" */
#define IC_SCANF4          (IC_ID_BASE + 0x0120) /* IAnimatedButton "ScanForward4" */
#define IC_SCANF5          (IC_ID_BASE + 0x0121) /* IAnimatedButton "ScanForward5" */
#define IC_SCANF6          (IC_ID_BASE + 0x0122) /* IAnimatedButton "ScanForward6" */
#define IC_SCANB1          (IC_ID_BASE + 0x0123) /* IAnimatedButton "ScanBackward1" */
#define IC_SCANB2          (IC_ID_BASE + 0x0124) /* IAnimatedButton "ScanBackward2" */
#define IC_SCANB3          (IC_ID_BASE + 0x0125) /* IAnimatedButton "ScanBackward3" */
#define IC_SCANB4          (IC_ID_BASE + 0x0126) /* IAnimatedButton "ScanBackward4" */
#define IC_SCANB5          (IC_ID_BASE + 0x0127) /* IAnimatedButton "ScanBackward5" */
#define IC_SCANB6          (IC_ID_BASE + 0x0128) /* IAnimatedButton "ScanBackward6" */
#define IC_PLAY1           (IC_ID_BASE + 0x0129) /* IAnimatedButton "Play1" */
#define IC_PLAY2           (IC_ID_BASE + 0x012A) /* IAnimatedButton "Play2" */
#define IC_PLAY3           (IC_ID_BASE + 0x012B) /* IAnimatedButton "Play3" */
#define IC_PLAY4           (IC_ID_BASE + 0x012C) /* IAnimatedButton "Play4" */
#define IC_PLAY5           (IC_ID_BASE + 0x012D) /* IAnimatedButton "Play5" */
#define IC_MUTE            (IC_ID_BASE + 0x012E) /* IAnimatedButton "Mute" */
#define IC_VOLUP           (IC_ID_BASE + 0x012F) /* IAnimatedButton "Volume Up" */
#define IC_VOLDN           (IC_ID_BASE + 0x0130) /* IAnimatedButton "Volume Down" */

// Window identifiers for the child windows of an IViewPort.
#define IC_VIEWPORT_VERTSCROLLBAR   ( IC_ID_BASE + 201 )
#define IC_VIEWPORT_HORZSCROLLBAR   ( IC_ID_BASE + 202 )
#define IC_VIEWPORT_VIEWRECTANGLE   ( IC_ID_BASE + 203 )

#endif /* _ICCONST_ */
