#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )

#ifndef __iconv_h
   #define __iconv_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   #ifndef  _LNK_CONV
         #define  _LNK_CONV   _Optlink
   #endif

   /********************************************************************/
   /*  <iconv.h> header file                                           */
   /*                                                                  */
   /*  IBM VisualAge C++ for OS/2, Version 3.00                        */
   /*  (C) Copyright IBM Corp. 1991, 1995.                             */
   /*  - Licensed Material - Program-Property of IBM                   */
   /*  - All rights reserved                                           */
   /*                                                                  */
   /********************************************************************/

   #include <errno.h>

   #ifndef __size_t
      #define __size_t 1
      typedef unsigned int size_t;
   #endif

   #ifndef __lc_object
      #define __lc_object 1
      typedef struct {
         unsigned short type_id,
                        magic;
         unsigned long  version;
         size_t         size;
      } _LC_object_t;
   #endif

   /* definition of iconv_t type. */

   typedef struct  __iconv_rec     iconv_rec, *iconv_t;
   struct __iconv_rec {
      _LC_object_t hdr;
      void        *data;
      iconv_t     (*open)(const unsigned char *to, const unsigned char *from);
      int         (*exec)(iconv_t cd, unsigned char **inbuf, size_t *inbytesleft,
                          unsigned char **outbuf, size_t *outbytesleft, int *errnoptr);
      int         (*close)(iconv_t cd, int *errnoptr);
   };

   typedef struct _LC_core_iconv_type _LC_core_iconv_t;
   struct _LC_core_iconv_type {

      _LC_object_t      hdr;

      /* implementation initialization */
      void             *data;
      _LC_core_iconv_t *(*init)();
      int              (*exec)();
      int              (*close)();
   };

   /* methods */

   extern iconv_t _LNK_CONV iconv_open(const char *, const char *);
   extern size_t  _LNK_CONV iconv(iconv_t, char **, size_t *, char **, size_t *);
   extern int     _LNK_CONV iconv_close(iconv_t);

   #define iconv(cd, ibuf, ilen, obuf, olen) __iconv(cd, ibuf, \
                                                     ilen, obuf, olen)
   #define __iconv(cd, ibuf, ilen, obuf, olen) \
         ((*(cd)->exec)(cd, ibuf, ilen, obuf, olen, &errno))

   #define _LC_ICONV     12

   #ifdef __cplusplus
      }
   #endif

#endif

#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
