/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _ICURSOR_H
#define _ICURSOR_H

#include <iglobals.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

class ICursor {
public:

  virtual
          ~ICursor ();

  virtual
  IBoolean setToFirst () = 0;

  virtual
  IBoolean setToNext () = 0;

  virtual
  IBoolean isValid () const = 0;

  virtual
  void     invalidate () = 0;

  virtual
  void     copy (ICursor const&) = 0;

  virtual
  IBoolean operator == (ICursor const&) const = 0;

  IBoolean operator != (ICursor const& cursor) const
           { return ! operator== (cursor);
           }

};

template < class Element >
class IElementCursor : public ICursor {
public:

  virtual
  Element const&
           element () const = 0;

};

template < class Element >
class IOrderedCursor : public IElementCursor < Element > {
public:

  virtual
  IBoolean setToLast () = 0;

  virtual
  IBoolean setToPrevious () = 0;

};

#define forCursor(c) \
  for ((c).setToFirst (); (c).isValid (); (c).setToNext ())

#pragma info (restore)
#pragma pack ()

#endif
