#ifndef _IDBCSBUF_INL_
#define _IDBCSBUF_INL_ 0
/*******************************************************************************
* FILE NAME: idbcsbuf.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in idbcsbuf.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IDBCSBUF_
  #undef  _IDBCSBUF_INL_
  #define _IDBCSBUF_INL_ 1
  #include <idbcsbuf.hpp>
#endif

#if _IDBCSBUF_INL_
  #define inline
#endif

inline size_t IDBCSBuffer :: charLength ( char const* p )
  {
#ifdef   IC_PM
  return ( IBuffer::dbcsTable[ *p ] == 0 ? 1 : 2 );
#endif   //IC_PM
#ifdef   IC_MOTIF
  if ( *p == 0 )
     return 1;
  else
     return mblen ( p, MB_LEN_MAX );
#endif   //IC_MOTIF
#ifdef IC_WIN
#ifdef UNICODE // Temp for now
  return 2;
#else
  return 1;
#endif
#endif
  }

inline size_t IDBCSBuffer :: charLength ( unsigned pos ) const
  {
  return charLength ( contents() + pos - 1 );
  }

inline size_t IDBCSBuffer :: maxCharLength ( )
  {
  return MB_CUR_MAX;
  }

inline IBase::Boolean IDBCSBuffer :: isSBC ( char const* p )
  {
  return ( charLength ( p ) == 1 );
  }

#ifdef   IC_PM
inline IBase::Boolean IDBCSBuffer :: isDBCS1 ( unsigned pos ) const
  {
  return dbcsTable[ (unsigned) ( this->contents()[ pos-1 ] ) ];
  }

inline IBase::Boolean IDBCSBuffer :: isPrevDBCS ( unsigned pos ) const
  {
  return ( pos < 3 ) ?
    false
  :
    this->charType( pos-1 ) == IStringEnum::dbcs2;
  }
#endif   //IC_PM
#endif // _IDBCSBUF_INL_
