/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IDEQSEQ_H
#define _IDEQSEQ_H

#include <iglobals.h>
#include <icursor.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#ifdef ICL_NO_INLINE
#define inline
#endif

template < class Element, class ElementOps, class Base >
class IWDequeOnSeq;

template < class Element, class ElementOps, class Base >
class IWDequeOnSeqCursor :
    public Base::Cursor
{
public:

           IWDequeOnSeqCursor
                     (IWDequeOnSeq
                       < Element, ElementOps, Base > const& c)
           : Base::Cursor (c.ivBase)
           {
           }

};


template < class Element, class ElementOps, class Base >
class IWDequeOnSeq {
protected:

  Base ivBase;

public:


  typedef IWDequeOnSeqCursor < Element, ElementOps, Base > Cursor;

  inline   IWDequeOnSeq     (INumber numberOfElements = 100);

  inline   IWDequeOnSeq     (IWDequeOnSeq < Element,
                                            ElementOps, Base > const&);

  inline  ~IWDequeOnSeq             ();

  inline
  IBoolean add              (Element const&);

  inline
  IBoolean add              (Element const&, ICursor&);

  inline
  void     addAllFrom       (IWDequeOnSeq < Element,
                                            ElementOps, Base > const&);

  inline
  void     addAsFirst       (Element const&);

  inline
  void     addAsFirst       (Element const&, ICursor&);

  inline
  void     addAsLast        (Element const&);

  inline
  void     addAsLast        (Element const&, ICursor&);

  inline
  IBoolean allElementsDo    (IBoolean (*function)
                              (Element const&, void*),
                             void* additionalArgument = 0) const;

  inline
  IBoolean allElementsDo    (IConstantIterator <Element>&) const;

  inline
  Element const&
           anyElement       () const;

  inline
  long     compare          (IWDequeOnSeq < Element,
                                            ElementOps, Base > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  inline
  Element const&
           elementAt        (ICursor const&) const;

  inline
  Element const&
           elementAtPosition (IPosition) const;

  inline
  Element const&
           firstElement     () const;

  inline
  IBoolean isBounded        () const;

  inline
  IBoolean isEmpty          () const;

  inline
  IBoolean isFirst          (ICursor const&) const;

  inline
  IBoolean isLast           (ICursor const&) const;

  inline
  IBoolean isFull           () const;

  inline
  Element const&
           lastElement      () const;

  inline
  INumber  maxNumberOfElements () const;

  inline
  Cursor*  newCursor        () const;

  inline
  INumber  numberOfElements () const;

  inline
  IWDequeOnSeq < Element, ElementOps, Base >&
           operator =       (IWDequeOnSeq < Element,
                                            ElementOps, Base > const&);

  inline
  void     removeAll        ();

  inline
  void     removeFirst      ();

  inline
  void     removeLast       ();

  inline
  IBoolean setToFirst       (ICursor&) const;

  inline
  IBoolean setToLast        (ICursor&) const;

  inline
  IBoolean setToNext        (ICursor&) const;

  inline
  void     setToPosition    (IPosition, ICursor&) const;

#ifndef __BIN_COMPAT_BASE_43__
  inline
  IPosition     position    (ICursor const&) const;
#endif

  inline
  IBoolean setToPrevious    (ICursor&) const;

  friend class IWDequeOnSeqCursor < Element, ElementOps, Base >;

  inline
  IBoolean isConsistent     () const;

protected:

  // used for cfront support:
  inline
  IOrderedCursor < Element >&
            baseCursor (ICursor&) const;

  inline
  IOrderedCursor < Element > const&
            baseCursor (ICursor const&) const;

};


#define IDefineGDequeOnGSequence(GSeq, GDeque) \
template < class Element, class ElementOps > \
class GDeque : \
  public IWDequeOnSeq < Element, ElementOps, \
                        GSeq < Element, ElementOps > > { \
public: \
  GDeque (INumber n = 100) : \
    IWDequeOnSeq < Element, ElementOps, \
                   GSeq < Element, ElementOps > > (n) {} \
};



#ifdef ICL_NO_INLINE
#undef inline
#else
#include <ideqseq.inl>
#endif

#if ! defined (__TEMPINC__)
#include <ideqseq.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
