/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>


// *************************** IWDequeOnSeq ****************************

template <class Element, class ElementOps, class Base>
inline IOrderedCursor < Element >&
IWDequeOnSeq <Element, ElementOps, Base>::
baseCursor (ICursor& cursor) const
{
  return (Cursor&) cursor;
}

template <class Element, class ElementOps, class Base>
inline IOrderedCursor < Element > const&
IWDequeOnSeq <Element, ElementOps, Base>::
baseCursor (ICursor const& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class ElementOps, class Base >
inline IWDequeOnSeq < Element, ElementOps, Base >::
IWDequeOnSeq (INumber n)
: ivBase (n)
{
}

template < class Element, class ElementOps, class Base >
inline IWDequeOnSeq < Element, ElementOps, Base >::
IWDequeOnSeq (IWDequeOnSeq < Element,
                             ElementOps, Base > const& collection)
: ivBase (collection.ivBase)
{
}

template < class Element, class ElementOps, class Base >
inline IWDequeOnSeq < Element, ElementOps, Base >&
IWDequeOnSeq < Element, ElementOps, Base >::
operator= (IWDequeOnSeq < Element, ElementOps, Base > const& collection)
{ ivBase.operator= (collection.ivBase);
  return *this;
}

template < class Element, class ElementOps, class Base >
inline IWDequeOnSeq < Element, ElementOps, Base >::
~IWDequeOnSeq ()
{
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
add (Element const& element)
{ return ivBase.add (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
add (Element const& element, ICursor &cursor)
{ return ivBase.add (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
addAllFrom (IWDequeOnSeq < Element,
                           ElementOps, Base > const& collection)
{ ivBase.addAllFrom (collection.ivBase);
}

template < class Element, class ElementOps, class Base >
inline Element const& IWDequeOnSeq < Element, ElementOps, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline Element const& IWDequeOnSeq < Element, ElementOps, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWDequeOnSeq < Element, ElementOps, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWDequeOnSeq < Element, ElementOps, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class ElementOps, class Base >
inline IWDequeOnSeqCursor < Element, ElementOps, Base >*
IWDequeOnSeq < Element, ElementOps, Base >::
newCursor () const
{ Cursor* result = new Cursor (*this);
  ICHECK (result != 0,
          IOutOfCollectionMemory, IOutOfCollectionMemoryText)
  return result;
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
removeFirst ()
{ ivBase.removeFirst ();
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
removeLast ()
{ ivBase.removeLast ();
}

template < class Element, class ElementOps, class Base >
inline Element const& IWDequeOnSeq < Element, ElementOps, Base >::
firstElement () const
{ return ivBase.firstElement ();
}

template < class Element, class ElementOps, class Base >
inline Element const& IWDequeOnSeq < Element, ElementOps, Base >::
lastElement () const
{ return ivBase.lastElement ();
}

template < class Element, class ElementOps, class Base >
inline Element const& IWDequeOnSeq < Element, ElementOps, Base >::
elementAtPosition (IPosition position) const
{ return ivBase.elementAtPosition (position);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
setToLast (ICursor &cursor) const
{ return ivBase.setToLast (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
setToPrevious (ICursor &cursor) const
{ return ivBase.setToPrevious (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
setToPosition (IPosition position, ICursor &cursor) const
{ ivBase.setToPosition (position, baseCursor (cursor));
}

#ifndef __BIN_COMPAT_BASE_43__
template < class Element, class ElementOps, class Base >
inline IPosition IWDequeOnSeq < Element, ElementOps, Base >::
position (ICursor const& cursor) const
{ return ivBase.position (baseCursor (cursor));
}
#endif

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
isFirst (ICursor const& cursor) const
{ return ivBase.isFirst (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWDequeOnSeq < Element, ElementOps, Base >::
isLast (ICursor const& cursor) const
{ return ivBase.isLast (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline long IWDequeOnSeq < Element, ElementOps, Base >::
compare (IWDequeOnSeq < Element, ElementOps, Base > const& collection,
         long (*comparisonFunction)
           (Element const&, Element const&)) const
{ return ivBase.compare (collection.ivBase, comparisonFunction);
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
addAsFirst (Element const& element)
{ ivBase.addAsFirst (element);
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
addAsFirst (Element const& element, ICursor &cursor)
{ ivBase.addAsFirst (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
addAsLast (Element const& element)
{ ivBase.addAsLast (element);
}

template < class Element, class ElementOps, class Base >
inline void IWDequeOnSeq < Element, ElementOps, Base >::
addAsLast (Element const& element, ICursor &cursor)
{ ivBase.addAsLast (element, baseCursor (cursor));
}
