#ifndef _IDSCONCV_
#define _IDSCONCV_

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ICANVAS_
#include <icanvas.hpp>
#endif

#ifndef _IOBSERVR_
#include <iobservr.hpp>
#endif

class IPushButton;
class IEntryField;
class IStaticText;
class ICheckBox;
class IMessageBox;
#ifndef _IDSMCON_HPP_
#include "idsmcon.hpp"
#endif

#ifndef _IRECT_
#include <irect.hpp>
#endif

class IDSConnectCanvasConn4;
class IDSConnectCanvasConn5;
class IDSConnectCanvasConn6;
class IDSConnectCanvasConn11;
class IDSConnectCanvasConn12;
class IDSConnectCanvasConn13;
class IDSConnectCanvasConn14;
class IDSConnectCanvasConn7;
class IDSConnectCanvasConn8;
class IDSConnectCanvasConn9;
class IDSConnectCanvasConn10;
class IDSConnectCanvasConn21;
class IDSConnectCanvasConn22;
class IDSConnectCanvasConn23;
class IDSConnectCanvasConn24;
#include "IDSCONCV.h"


/*----------------------------------------------------------------------------*/
/* Align classes on four byte boundary.                                       */
/*----------------------------------------------------------------------------*/
#pragma pack(4)

//*************************************************************
// Class definition for IDSConnectCanvas
//*************************************************************
class EXPORT IDSConnectCanvas : public ICanvas, public IObserver {
public:
//*************************************************************
// Constructors / destructors
//*************************************************************
   IDSConnectCanvas(
      unsigned long id = WND_IDSConnectCanvas,
      IWindow * parent = IWindow::desktopWindow(),
      IWindow * owner = 0,
      const IRectangle & rect = defaultFramingSpec(),
      const ICanvas::Style & style = ICanvas::defaultStyle());

   virtual  ~IDSConnectCanvas();

//*************************************************************
// public member functions
//*************************************************************
   static IRectangle defaultFramingSpec();
   virtual IDSConnectCanvas & initializePart();
   IDSConnectCanvas * getCanvas() { return this; };
   IDatastore *  getDatastore() const { return iDatastore; };

//*************************************************************
// public member data
//*************************************************************
   static INotificationId readyId;
   static INotificationId datastoreAuthentication;
   static INotificationId datastoreDatastoreName;
   static INotificationId datastoreIsConnected;
   static INotificationId datastoreShareModeExclusive;
   static INotificationId datastoreConnected;
   static INotificationId datastoreDisconnected;
   static INotificationId datastoreTransacted;
   static INotificationId datastoreUserName;

protected:
//*************************************************************
// protected member functions
//*************************************************************
   virtual Boolean makeConnections();
   IObserver & dispatchNotificationEvent(const INotificationEvent & anEvent);

private:
//*************************************************************
// private member data
//*************************************************************
   IPushButton * iPushButton1;
   IPushButton * iPushButton2;
   IPushButton * iPushButton3;
   IPushButton * iPushButton4;
   IEntryField * iEntryField1;
   IEntryField * iEntryField2;
   IEntryField * iEntryField3;
   IStaticText * iStaticText1;
   IStaticText * iStaticText2;
   IStaticText * iStaticText3;
   ICheckBox * iCheckBox1;
   IMessageBox * iDatastoreMessages;
   IDatastore * iDatastore;
   IDSConnectCanvasConn4 * conn4;
   IDSConnectCanvasConn5 * conn5;
   IDSConnectCanvasConn6 * conn6;
   IDSConnectCanvasConn11 * conn11;
   IDSConnectCanvasConn12 * conn12;
   IDSConnectCanvasConn13 * conn13;
   IDSConnectCanvasConn14 * conn14;
   IDSConnectCanvasConn7 * conn7;
   IDSConnectCanvasConn8 * conn8;
   IDSConnectCanvasConn9 * conn9;
   IDSConnectCanvasConn10 * conn10;
   IDSConnectCanvasConn21 * conn21;
   IDSConnectCanvasConn22 * conn22;
   IDSConnectCanvasConn23 * conn23;
   IDSConnectCanvasConn24 * conn24;


};   //IDSConnectCanvas


/*----------------------------------------------------------------------------*/
/* Resume compiler default packing.                                           */
/*----------------------------------------------------------------------------*/
#pragma pack()

#endif
