/********************************************************************************/
/* File:   idsexc.hpp                                                           */
/* Class:  exception classes                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _IDSEXC_HPP_
#define _IDSEXC_HPP_

#include <iexcbase.hpp>
#include <sqlca.h>
#include <daxerrno.hpp>

IEXCLASSDECLARE(IDatastoreAdaptorException, IException);

   IEXCLASSDECLARE(IDatastoreConnectionInUse, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IDatastoreIdInvalid, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IDatastoreTypeInvalid,IDatastoreAdaptorException);
   IEXCLASSDECLARE(ITransactionStateInvalid, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IDatastoreConnectionNotOpen, IDatastoreAdaptorException);
   IEXCLASSDECLARE(ICompletionTypeInvalid, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IPidStringInvalid, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IAuthorizationInvalid, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IDatastoreConnectionFailed, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IConnectFailed, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IConnectRejected, IDatastoreAdaptorException);
   IEXCLASSDECLARE(IDisconnectError, IDatastoreAdaptorException);

   IEXCLASSDECLARE(IDatastoreAccessError, IException);

   IEXCLASSDECLARE (IValueTypeInvalid, IException);
   IEXCLASSDECLARE (IOptionInvalid, IException);
   IEXCLASSDECLARE (IValueInvalid, IException);

   IEXCLASSDECLARE (IDataIdInvalid, IException);
   IEXCLASSDECLARE (IPropertyIdInvalid, IException);

   IEXCLASSDECLARE (IObjectTypeInvalid, IException);
   IEXCLASSDECLARE (IPIDInvalid, IException);
   IEXCLASSDECLARE (IDataObjectAlreadyExists, IException);
   IEXCLASSDECLARE (IDataObjectNotFound, IException);
   IEXCLASSDECLARE (ISchemaMappingDefinitionError, IException);
   IEXCLASSDECLARE (IDataObjectInvalid, IException);
   IEXCLASSDECLARE (IDataObjectMappingInconsistent, IException);
   IEXCLASSDECLARE (IDataTypeNotSupported, IException);

   IEXCLASSDECLARE (IDSPositionInvalid, IException);
   IEXCLASSDECLARE (IDSCursorInvalid, IException);

   IEXCLASSDECLARE (IDatastoreLogonFailed, IException);
   IEXCLASSDECLARE (IDatastoreLogoffFailed, IException);

class _Export IDSAccessError : public IException {
public:
  IDSAccessError(
        const char* a,
        unsigned long b = 0,
        Severity c = IException::unrecoverable,
        struct sqlca* sqlca_p=0
        );
  virtual const char* name() const;
  virtual ~IDSAccessError();
  IDSAccessError(const IDSAccessError &);
  struct sqlca const& getSqlca() const;
private:
  struct sqlca isqlca;
  operator = ( const IDSAccessError & );
};


#endif



