/********************************************************************************/
/* File:  idsm.hpp                                                              */
/* Class: IDatastoreMgr                                                         */
/*                                                                              */
/* Abstract class IDatastoreMgr                                                 */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _IDSM_HPP_
#define _IDSM_HPP_

#include <istring.hpp>
#include <istdntfy.hpp>
#include "dax.hpp"
#include "idaxbs.h"
#include "idsexc.hpp"

class IDatastoreConnection;
class IDataObject;
class IUserEnvironment;
class IPidDsm;
class IDSCursor;



class  EXPORT  IDatastoreMgr : public IStandardNotifier
{

public:

  virtual ~IDatastoreMgr(){;}
  virtual void
    connect             ( IDatastoreConnection &,
                          const IString& datastoreId,
                          const IString& userName,
                          const IString& authentication )
               throw    (IConnectFailed,
                         IDatastoreConnectionInUse,
                         IDatastoreAccessError,
                         IDatastoreLogonFailed,
                         IDatastoreLogoffFailed,
                         IDatastoreIdInvalid) = 0;

  virtual void
    disconnect          ( IDatastoreConnection & )
              throw     (IDatastoreConnectionNotOpen,
                         IDatastoreLogoffFailed,
                         IDisconnectError)=0;

  virtual void
    transact            ( const IUserEnvironment &,
                          short tct )
              throw     (ICompletionTypeInvalid,
                         IDatastoreAccessError,
                         IDatastoreConnectionNotOpen)=0;

  virtual IString
    getDatastoreId      ( const IString& datastoreType,
                          const IString& datastoreName,
                          const IString& serverName)
              throw     (IDatastoreTypeInvalid)=0;


};

#endif
