/********************************************************************************/
/* File:  idsmsql.hpp                                                           */
/* Class: IDatastoreMgrSQL                                                      */
/*                                                                              */
/* Implementation of Datastore Manager for SQL databases                        */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _IDSMSQL_HPP_
#define _IDSMSQL_HPP_

#include <istring.hpp>

#include "dax.hpp"
#include "idsm.hpp"

class IDatastoreConnection;
class IUserEnvironment;
class DatastoreMgrSQL_Proxy;


class EXPORT IDatastoreMgrSQL : public IDatastoreMgr
{

public:
  IDatastoreMgrSQL ();
  virtual ~IDatastoreMgrSQL();

  void
    connect             ( IDatastoreConnection &,
                          const IString& datastoreId,
                          const IString& userName,
                          const IString& authentication );

  void
    connect             ( IDatastoreConnection *,
                          const IString datastoreId,
                          const IString userName,
                          const IString authentication );
  void
    disconnect          ( IDatastoreConnection & );

  void
    disconnect          ( IDatastoreConnection * );

  void
    transact            ( const IUserEnvironment &,
                          short tct );
  void
    transact            ( const IUserEnvironment *,
                          short tct );

  IString
    getDatastoreId      ( const IString& datastoreType,
                          const IString& datastoreName,
                          const IString& serverName);

/*============================ PRIVATE DATA MEMBERS ===================================*/

private:
  DatastoreMgrSQL_Proxy* dsmP;

};

#endif

