/********************************************************************************/
/* File:   idtaobj.hpp                                                          */
/* Class:  IDataObject                                                          */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _IDTAOBJ_HPP_
#define _IDTAOBJ_HPP_

#include <istring.hpp>
#include "dax.hpp"
#include <istdntfy.hpp>

class IPid;

class EXPORT IDataObject : public IStandardNotifier
{

public:

  virtual ~IDataObject(){;}
  IDataObject():_pid(0), _objectType(""){;}
  IPid* pid() const;
  void setPid(IPid* aPid);
  IString objectType() const;
  void setObjectType(const IString& anObjectType);

private:

IPid* _pid;
IString _objectType;

};

// #include "idtaobj.inl"
inline IPid* IDataObject::pid() const { return _pid;}
inline void IDataObject::setPid(IPid* aPid) { _pid = aPid;}
inline IString IDataObject::objectType() const { return _objectType;}
inline void IDataObject::setObjectType(const IString& anObjectType)
                                      { _objectType=anObjectType;}
#endif

