/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IESSEQ_H
#define _IESSEQ_H

#include <iglobals.h>
#include <icursor.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#ifdef ICL_NO_INLINE
#define inline
#endif

template < class Element, class ElementOps, class Base >
class IWEqSeqOnSeq;

template < class Element, class ElementOps, class Base >
class IWEqSeqOnSeqCursor :
  public Base::Cursor
{
public:

           IWEqSeqOnSeqCursor
                     (IWEqSeqOnSeq
                       < Element, ElementOps, Base > const& c)
           : Base::Cursor (c.ivBase)
           {
           }

};

template < class Element, class ElementOps, class Base >
class IWEqSeqOnSeq {
protected:

  Base ivBase;

public:


  typedef IWEqSeqOnSeqCursor < Element,
                               ElementOps, Base > Cursor;

  friend class IWEqSeqOnSeqCursor < Element, ElementOps, Base >;

  inline   IWEqSeqOnSeq     (INumber numberOfElements = 100);

  inline   IWEqSeqOnSeq     (IWEqSeqOnSeq < Element,
                                            ElementOps, Base > const&);

  inline  ~IWEqSeqOnSeq     ();

  inline
  IBoolean add              (Element const&);

  inline
  IBoolean add              (Element const&, ICursor&);

  inline
  void     addAllFrom       (IWEqSeqOnSeq < Element,
                                            ElementOps, Base > const&);

  inline
  void     addAsFirst       (Element const&);

  inline
  void     addAsFirst       (Element const&, ICursor&);

  inline
  void     addAsLast        (Element const&);

  inline
  void     addAsLast        (Element const&, ICursor&);

  inline
  void     addAsNext        (Element const&, ICursor&);

  inline
  void     addAsPrevious    (Element const&, ICursor&);

  inline
  void     addAtPosition    (IPosition, Element const&);

  inline
  void     addAtPosition    (IPosition, Element const&, ICursor&);

  inline
  IBoolean allElementsDo    (IBoolean (*function) (Element&, void*),
                             void* additionalArgument = 0);

  inline
  IBoolean allElementsDo    (IIterator <Element>&);

  inline
  IBoolean allElementsDo    (IBoolean (*function)
                              (Element const&, void*),
                             void* additionalArgument = 0) const;

  inline
  IBoolean allElementsDo    (IConstantIterator <Element>&) const;

  inline
  Element const&
           anyElement       () const;

  inline
  long     compare          (IWEqSeqOnSeq < Element,
                                            ElementOps, Base > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  inline
  IBoolean contains         (Element const&) const;

  inline
  IBoolean containsAllFrom  (IWEqSeqOnSeq
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  Element const&
           elementAt        (ICursor const&) const;

  inline
  Element& elementAt        (ICursor const&);

  inline
  Element const&
           elementAtPosition (IPosition) const;

  inline
  Element const&
           firstElement     () const;

  inline
  IBoolean isBounded        () const;

  inline
  IBoolean isEmpty          () const;

  inline
  IBoolean isFirst          (ICursor const&) const;

  inline
  IBoolean isFull           () const;

  inline
  IBoolean isLast           (ICursor const&) const;

  inline
  Element const&
           lastElement      () const;

  inline
  IBoolean locate           (Element const&, ICursor&) const;

  inline
  IBoolean locateOrAdd      (Element const&);

  inline
  IBoolean locateOrAdd      (Element const&, ICursor&);

  inline
  IBoolean locateFirst      (Element const&, ICursor&) const;

  inline
  IBoolean locateLast       (Element const&, ICursor&) const;

  inline
  IBoolean locateNext       (Element const&, ICursor&) const;

  inline
  IBoolean locatePrevious   (Element const&, ICursor&) const;

  inline
  INumber  maxNumberOfElements () const;

  inline
  Cursor*  newCursor        () const;

  inline
  INumber  numberOfElements () const;

  inline
  INumber  numberOfOccurrences (Element const&) const;

  inline
  IWEqSeqOnSeq < Element, ElementOps, Base >&
           operator =       (IWEqSeqOnSeq < Element,
                                            ElementOps, Base > const&);

  inline
  IBoolean operator ==      (IWEqSeqOnSeq
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  IBoolean operator !=      (IWEqSeqOnSeq
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  IBoolean remove           (Element const&);

  inline
  void     removeAt         (ICursor&);

  inline
  void     removeAll        ();

  inline
  INumber  removeAll        (IBoolean (*property)
                              (Element const&, void*),
                             void* additionalArgument = 0);

  inline
  INumber  removeAllOccurrences (Element const&);

  inline
  void     removeAtPosition (IPosition);

  inline
  void     removeFirst      ();

  inline
  void     removeLast       ();

  inline
  void     replaceAt        (ICursor const&, Element const&);

  inline
  IBoolean setToFirst       (ICursor&) const;

  inline
  IBoolean setToLast        (ICursor&) const;

  inline
  IBoolean setToNext        (ICursor&) const;

  inline
  IBoolean setToPrevious    (ICursor&) const;

  inline
  void     setToPosition    (IPosition, ICursor&) const;

#ifndef __BIN_COMPAT_BASE_43__
  inline
  IPosition     position    (ICursor const&) const;
#endif

  inline
  void     sort             (long (*comparisonFunction)
                              (Element const&, Element const&));

  inline
  IBoolean isConsistent     () const;

protected:

  ElementOps ivElementOps;

  struct EnvForIsEqual {
    ElementOps const* ops;
    Element const* elem;
  };

  static
  IBoolean  isEqual        (Element const&, void* env);

  // used for cfront support:
  inline
  IOrderedCursor < Element >&
            baseCursor (ICursor&) const;

  inline
  IOrderedCursor < Element > const&
            baseCursor (ICursor const&) const;

};


#define IDefineGEqualitySequenceOnGSequence(GSeq, GEqSeq) \
template < class Element, class ElementOps > \
class GEqSeq : \
  public IWEqSeqOnSeq < Element, ElementOps, \
                        GSeq < Element, ElementOps > > { \
public: \
  GEqSeq (INumber n = 100) : \
    IWEqSeqOnSeq < Element, ElementOps, \
                   GSeq < Element, ElementOps > > (n) {} \
};



#ifdef ICL_NO_INLINE
#undef inline
#else
#include <iesseq.inl>
#endif

#if ! defined (__TEMPINC__)
#include <iesseq.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
