#ifndef _IFILEHDR_
  #define _IFILEHDR_
/*******************************************************************************
* FILE NAME: ifilehdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the declaration of the classes:                         *
*     IFileDialogHandler                                                       *
*     IFileDialogEvent                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ievent.hpp>
#include <ihandler.hpp>

class IFileDialog;
class IString;

#pragma pack(4)

class IFileDialogEvent : public IEvent {
typedef IEvent
  Inherited;

public:
/*------------------------------- Constructors -------------------------------*/
  IFileDialogEvent ( IEvent& event );
virtual
  ~IFileDialogEvent ( );

/*--------------------------- File Name Accessors ----------------------------*/
IString
  fileName         ( ) const;
unsigned long
  fileLength       ( ) const;
};


class IFileDialogHandler : public IHandler {
typedef IHandler
  Inherited;
 
public:
/*------------------------------- Constructors -------------------------------*/
  IFileDialogHandler( );
virtual
  ~IFileDialogHandler ( );

/*---------------------------- Window Attachment -----------------------------*/
virtual IFileDialogHandler
  &handleEventsFor       ( IFileDialog* fileDialog ),
  &stopHandlingEventsFor ( IFileDialog* fileDialog );

protected:
/*----------------------------- Dispatch Events ------------------------------*/
virtual Boolean
  dispatchHandlerEvent ( IEvent& event );

/*---------------------------- File Dialog Events ----------------------------*/
virtual Boolean
  filter          ( IFileDialogEvent& event   ),
  filterName      ( const IString& fileName,
                    IFileDialog* dialog       ),
  validate        ( IFileDialogEvent& event   ),
  validateName    ( const IString& fileName,
                    IFileDialog* dialog       ),
  modelessResults ( IFileDialog* endingDialog );

private:

/*------------------------------ Hidden functions ---------------------------*/
virtual IHandler
 &handleEventsFor       ( IWindow* window  ),
 &stopHandlingEventsFor ( IWindow* window  );
}; 

#pragma pack()

#endif /* _IFILEHDR_ */
