#ifndef _IFONTDLG_INL_
#define _IFONTDLG_INL_ 0
/*******************************************************************************
* FILE NAME: ifontdlg.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ifontdlg.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IFONTDLG_
  #undef  _IFONTDLG_INL_
  #define _IFONTDLG_INL_ 1
  #include <ifontdlg.hpp>
#endif


#if _IFONTDLG_INL_
  #define inline
#endif



inline IFontDialog::IFontDialog(IWindow*     parent,
                                IWindow*     owner,
                                const Style& style )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   Settings tempSettings;
   initialize(parent, owner, style, (IHandler*)0, tempSettings );
}

inline IFontDialog::IFontDialog(IWindow*        parent,
                                IWindow*        owner,
                                const Settings& settings,
                                const Style&    style )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, (IHandler*)0, settings );
}

inline IFontDialog::IFontDialog(IWindow*    parent,
                                IWindow*    owner,
                                const Style&    style,
                                const Settings& settings )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, (IHandler*)0, settings );

}

inline IFontDialog::IFontDialog(IWindow*        parent,
                                IWindow*        owner,
                                IHandler*       handler,
                                const Style&    style,
                                const Settings& settings )
             : IFrameWindow(IFrameWindow::deferCreation)
{
   initialize(parent, owner, style, handler, settings );
}


inline void  IFontDialog::setDefaultStyle(const IFontDialog::Style& newDefault)
{
  currentDefaultStyle = newDefault;
}

#endif // _IFONTDLG_INL_

