#ifndef _IHANDLE_INL_
#define _IHANDLE_INL_ 0
/*******************************************************************************
* FILE NAME: ihandle.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ihandle.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _IHANDLE_
  #undef  _IHANDLE_INL_
  #define _IHANDLE_INL_ 1
  #include <ihandle.hpp>
#endif

#if _IHANDLE_INL_
  #define inline
#endif


#ifdef IC_MOTIF
inline IWindowHandle :: IWindowHandle ( _WidgetRec * value )
  : IHandle( (Value)value )
  {
  }
inline IWindowHandle :: IWindowHandle ( int value )
  : IHandle( value )
  {
  }
#endif

inline IWindowHandle :: IWindowHandle ( Value value )
  : IHandle( value )
  {
  }

inline IAnchorBlockHandle :: IAnchorBlockHandle ( Value value )
  : IHandle( value )
  {
  }

inline IModuleHandle :: IModuleHandle ( Value value )
  : IHandle( value )
  {
  }

inline IStringHandle :: IStringHandle ( Value value )
  : IHandle( value )
  {
  }

#ifdef IC_MOTIF
inline IPresSpaceHandle :: IPresSpaceHandle ( _XGC * value )
  : IHandle( (Value)value )
  {
  }
inline IPresSpaceHandle :: IPresSpaceHandle ( int value )
  : IHandle( value )
  {
  }
#endif

inline IPresSpaceHandle :: IPresSpaceHandle ( Value value )
  : IHandle( value )
  {
  }

#ifdef IC_MOTIF
inline IProfileHandle :: IProfileHandle ( _XrmHashBucketRec * value )
  : IHandle( (Value)value )
  {
  }

inline IProfileHandle :: IProfileHandle ( int value )
  : IHandle( value )
  {
  }
#endif // IC_MOTIF

inline IProfileHandle :: IProfileHandle ( Value value )
  : IHandle( value )
  {
  }

inline IMessageQueueHandle :: IMessageQueueHandle ( Value value )
  : IHandle( value )
  {
  }

inline IAccelTblHandle :: IAccelTblHandle ( Value value )
  : IHandle( value )
  {
  }

inline IProcessId :: IProcessId ( Value value )
  : IHandle( value )
  {
  }

inline IThreadId :: IThreadId ( Value value )
  : IHandle( value )
  {
  }

inline IEnumHandle :: IEnumHandle ( Value value )
  : IHandle( value )
  {
  }

inline IRegionHandle :: IRegionHandle ( Value value )
  : IHandle( value )
  {
  }

#ifdef IC_MOTIF
inline IContextHandle :: IContextHandle (  _XtAppStruct * value )
  : IHandle( (Value)value )
  {
  }

inline IDisplayHandle :: IDisplayHandle ( _XDisplay * value )
  : IHandle( (Value) value )
  {
  }
#endif

#ifdef IC_WIN
inline IMenuHandle :: IMenuHandle ( Value value )
  : IMenuHandle::Inherited( value )
  {
  }
#endif // IC_WIN

#endif // _IHANDLE_INL_
