/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IHEAPSEQ_H
#define _IHEAPSEQ_H

#include <iglobals.h>
#include <icursor.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#ifdef ICL_NO_INLINE
#define inline
#endif

template < class Element, class ElementOps, class Base >
class IWHeapOnSeq;

template < class Element, class ElementOps, class Base >
class IWHeapOnSeqCursor :
  public Base::Cursor
{
public:

           IWHeapOnSeqCursor
                      (IWHeapOnSeq
                        < Element, ElementOps, Base > const& c)
           : Base::Cursor (c.ivBase)
           {
           }

};


template < class Element, class ElementOps, class Base >
class IWHeapOnSeq {

  Base ivBase;

public:


  typedef IWHeapOnSeqCursor < Element, ElementOps, Base > Cursor;

  inline   IWHeapOnSeq      (INumber numberOfElements = 100);

  inline   IWHeapOnSeq      (IWHeapOnSeq < Element,
                                           ElementOps, Base > const&);

  inline  ~IWHeapOnSeq      ();

  inline
  IBoolean add              (Element const&);

  inline
  IBoolean add              (Element const&, ICursor&);

  inline
  void     addAllFrom       (IWHeapOnSeq < Element,
                                           ElementOps, Base > const&);

  inline
  IBoolean allElementsDo    (IBoolean (*function) (Element&, void*),
                             void* additionalArgument = 0);

  inline
  IBoolean allElementsDo    (IIterator <Element>&);

  inline
  IBoolean allElementsDo    (IBoolean (*function)
                              (Element const&, void*),
                             void* additionalArgument = 0) const;

  inline
  IBoolean allElementsDo    (IConstantIterator <Element>&) const;

  inline
  Element const&
           elementAt        (ICursor const&) const;

  inline
  Element& elementAt        (ICursor const&);

  inline
  Element const&
           anyElement       () const;

  inline
  IBoolean isBounded        () const;

  inline
  IBoolean isEmpty          () const;

  inline
  IBoolean isFull           () const;

  inline
  INumber  maxNumberOfElements () const;

  inline
  Cursor*  newCursor        () const;

  inline
  INumber  numberOfElements () const;

  inline
  IWHeapOnSeq < Element, ElementOps, Base >&
           operator =       (IWHeapOnSeq < Element,
                                           ElementOps, Base > const&);

  inline
  void     removeAll        ();

  inline
  INumber  removeAll        (IBoolean (*property)
                              (Element const&, void*),
                             void* additionalArgument = 0);

  inline
  void     removeAt         (ICursor&);

  inline
  void     replaceAt        (ICursor const&, Element const&);

  inline
  IBoolean setToFirst       (ICursor&) const;

  inline
  IBoolean setToNext        (ICursor&) const;

  friend class IWHeapOnSeqCursor < Element, ElementOps, Base >;


  inline
  IBoolean isConsistent     () const;

protected:

  // used for cfront support:
  inline
  IElementCursor < Element >&
            baseCursor (ICursor&) const;

  inline
  IElementCursor < Element > const&
            baseCursor (ICursor const&) const;

};


#define IDefineGHeapOnGSequence(GSeq, GHeap) \
template < class Element, class ElementOps > \
class GHeap : \
  public IWHeapOnSeq < Element, ElementOps, \
                       GSeq < Element, ElementOps > > { \
public: \
  GHeap (INumber n = 100) : \
    IWHeapOnSeq < Element, ElementOps, \
                  GSeq < Element, ElementOps > > (n) {} \
};



#ifdef ICL_NO_INLINE
#undef inline
#else
#include <iheapseq.inl>
#endif

#if ! defined (__TEMPINC__)
#include <iheapseq.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
