/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>


// **************************** IWHeapOnSeq ****************************

template <class Element, class ElementOps, class Base>
inline IElementCursor < Element >&
IWHeapOnSeq <Element, ElementOps, Base>::
baseCursor (ICursor& cursor) const
{
  return (Cursor&) cursor;
}

template <class Element, class ElementOps, class Base>
inline IElementCursor < Element > const&
IWHeapOnSeq <Element, ElementOps, Base>::
baseCursor (ICursor const& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class ElementOps, class Base >
inline IWHeapOnSeq < Element, ElementOps, Base >::
IWHeapOnSeq (INumber n)
: ivBase (n)
{
}

template < class Element, class ElementOps, class Base >
inline IWHeapOnSeq < Element, ElementOps, Base >::
IWHeapOnSeq (IWHeapOnSeq < Element,
                           ElementOps, Base > const& collection)
: ivBase (collection.ivBase)
{
}

template < class Element, class ElementOps, class Base >
inline IWHeapOnSeq < Element, ElementOps, Base >&
IWHeapOnSeq < Element, ElementOps, Base >::
operator= (IWHeapOnSeq < Element, ElementOps, Base > const& collection)
{ ivBase.operator= (collection.ivBase);
  return *this;
}

template < class Element, class ElementOps, class Base >
inline IWHeapOnSeq < Element, ElementOps, Base >::
~IWHeapOnSeq ()
{
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
add (Element const& element)
{ return ivBase.add (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
add (Element const& element, ICursor &cursor)
{ return ivBase.add (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline void IWHeapOnSeq < Element, ElementOps, Base >::
addAllFrom (IWHeapOnSeq < Element, ElementOps, Base > const& collection)
{ ivBase.addAllFrom (collection.ivBase);
}

template < class Element, class ElementOps, class Base >
inline Element const& IWHeapOnSeq < Element, ElementOps, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline Element& IWHeapOnSeq < Element, ElementOps, Base >::
elementAt (ICursor const& cursor)
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline Element const& IWHeapOnSeq < Element, ElementOps, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class ElementOps, class Base >
inline void IWHeapOnSeq < Element, ElementOps, Base >::
removeAt (ICursor& cursor)
{ ivBase.removeAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline INumber IWHeapOnSeq < Element, ElementOps, Base >::
removeAll (IBoolean (*predicate) (Element const&, void*), void* env)
{ return ivBase.removeAll (predicate, env);
}

template < class Element, class ElementOps, class Base >
inline void IWHeapOnSeq < Element, ElementOps, Base >::
replaceAt (ICursor const& cursor, Element const& element)
{ ivBase.replaceAt (baseCursor (cursor), element);
}

template < class Element, class ElementOps, class Base >
inline void IWHeapOnSeq < Element, ElementOps, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWHeapOnSeq < Element, ElementOps, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWHeapOnSeq < Element, ElementOps, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class ElementOps, class Base >
inline IWHeapOnSeqCursor < Element, ElementOps, Base >*
IWHeapOnSeq < Element, ElementOps, Base >::
newCursor () const
{ Cursor* result = new Cursor (*this);
  ICHECK (result != 0,
          IOutOfCollectionMemory, IOutOfCollectionMemoryText)
  return result;
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element &, void*),
               void* environment)
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
allElementsDo (IIterator <Element>& iterator)
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWHeapOnSeq < Element, ElementOps, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

