/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>

//
// IBSTKeySortedSetImplInode
//

inline IBSTKeySortedSetImplInode::
IBSTKeySortedSetImplInode ()
{ ivm = 0;
}

inline IBSTKeySortedSetImplInode::
IBSTKeySortedSetImplInode(IBSTKeySortedSetImplInode const& inode)
{ ivm = inode.ivm;
}

//
// IBSTKeySortedSetImpl
//

inline IBSTKeySortedSetImpl::
IBSTKeySortedSetImpl (INumber order)
{ ivTreeOrder  = order;
  ivRoot       = 0;
  ivHeight     = 0;
  ivNoElements = 0;
}

inline IBoolean IBSTKeySortedSetImpl::
add (void const* element)
{ IBSTKeySortedSetImplLnode* dummy;

  return add(element, dummy);
}

inline void IBSTKeySortedSetImpl::
addAllFrom (IBSTKeySortedSetImpl const& tree)
{ if (tree.ivRoot != 0) {
    IBSTKeySortedSetImplLnode* dummy;

    addAllFromSubtree(tree.ivRoot, dummy);
  }
}

inline void const* IBSTKeySortedSetImpl::
elementAt (IBSTKeySortedSetImplLnode* const& cursor) const
{ return getLnodeElement (cursor);
}

inline void* IBSTKeySortedSetImpl::
elementAt (IBSTKeySortedSetImplLnode* const& cursor)
{ return getLnodeElement (cursor);
}

inline void const* IBSTKeySortedSetImpl::
anyElement () const
{ return firstElement();
}

inline void IBSTKeySortedSetImpl::
replaceAt (IBSTKeySortedSetImplLnode* const& cursor,
           void const* element)
{ replaceLnodeElement (cursor, element);
}

inline void IBSTKeySortedSetImpl::
removeAll ()
{ if (ivRoot != 0) {
    removeAllSubtree(ivRoot);
    ivRoot       = 0;
    ivHeight     = 0;
    ivNoElements = 0;
  }
  else {
    IASSERT(ivNoElements == 0);
  }
}

inline IBoolean IBSTKeySortedSetImpl::
isBounded () const
{ return False;
}

inline INumber IBSTKeySortedSetImpl::
maxNumberOfElements () const
{ IASSERT(False);

  return 0;
}

inline INumber IBSTKeySortedSetImpl::
numberOfElements () const
{ return ivNoElements;
}

inline IBoolean IBSTKeySortedSetImpl::
isEmpty () const
{ return ivRoot == 0;
}

inline IBoolean IBSTKeySortedSetImpl::
isFull () const
{ return False;
}

inline void const* IBSTKeySortedSetImpl::
firstElement () const
{ IBSTKeySortedSetImplLnode* cursor;

  IBoolean b = setToFirst(cursor);
  IASSERT (b);

  return elementAt (cursor);
}

inline IBoolean IBSTKeySortedSetImpl::
isUnderflown (IBSTKeySortedSetImplInode const* inode) const
{ return inode->ivm < (ivTreeOrder + 1) / 2;
}
