/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>


// ***************************** IWKeySetOnKSSet **********************

template <class Element, class Key, class ElementOps, class Base>
inline IElementCursor < Element >&
IWKeySetOnKSSet <Element, Key, ElementOps, Base>::
baseCursor (ICursor& cursor) const
{
  return (Cursor&) cursor;
}

template <class Element, class Key, class ElementOps, class Base>
inline IElementCursor < Element > const&
IWKeySetOnKSSet <Element, Key, ElementOps, Base>::
baseCursor (ICursor const& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class Key, class ElementOps, class Base >
inline IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
IWKeySetOnKSSet (INumber n)
: ivBase (n)
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
IWKeySetOnKSSet (IWKeySetOnKSSet
                  < Element, Key, ElementOps, Base > const& collection)
: ivBase (collection.ivBase)
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IWKeySetOnKSSet < Element, Key, ElementOps, Base >&
IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
operator= (IWKeySetOnKSSet < Element, Key,
                             ElementOps, Base > const& collection)
{ ivBase.operator= (collection.ivBase);
  return *this;
}

template < class Element, class Key, class ElementOps, class Base >
inline IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
~IWKeySetOnKSSet ()
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
add (Element const& element)
{ return ivBase.add (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
add (Element const& element, ICursor &cursor)
{ return ivBase.add (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
addAllFrom (IWKeySetOnKSSet
             < Element, Key, ElementOps, Base > const& collection)
{ ivBase.addAllFrom (collection.ivBase);
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline Element& IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
elementAt (ICursor const& cursor)
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
removeAt (ICursor& cursor)
{ ivBase.removeAt (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
removeAll (IBoolean (*predicate) (Element const&, void*), void* env)
{ return ivBase.removeAll (predicate, env);
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
replaceAt (ICursor const& cursor, Element const& element)
{ ivBase.replaceAt (baseCursor (cursor), element);
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IWKeySetOnKSSetCursor < Element, Key, ElementOps, Base >*
IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
newCursor () const
{ Cursor* result = new Cursor (*this);
  ICHECK (result != 0,
          IOutOfCollectionMemory, IOutOfCollectionMemoryText)
  return result;
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element &, void*),
               void* environment)
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
allElementsDo (IIterator <Element>& iterator)
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

template < class Element, class Key, class ElementOps, class Base >
inline Key const& IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
key (Element const& element) const
{ return ivBase.key (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
containsElementWithKey (Key const& key) const
{ return ivBase.containsElementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
containsAllKeysFrom (IWKeySetOnKSSet
                      < Element, Key, ElementOps, Base > const& c) const
{ return ivBase.containsAllKeysFrom (c.ivBase);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
locateElementWithKey (Key const& key, ICursor &cursor) const
{ return ivBase.locateElementWithKey (key, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
replaceElementWithKey (Element const& element)
{ return ivBase.replaceElementWithKey (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
replaceElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.replaceElementWithKey (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
locateOrAddElementWithKey (Element const& element)
{ return ivBase.locateOrAddElementWithKey (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
locateOrAddElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.locateOrAddElementWithKey
           (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
addOrReplaceElementWithKey (Element const& element)
{ return ivBase.addOrReplaceElementWithKey (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
addOrReplaceElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.addOrReplaceElementWithKey
           (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
removeElementWithKey (Key const& key)
{ return ivBase.removeElementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
elementWithKey (Key const& key) const
{ return ivBase.elementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline Element& IWKeySetOnKSSet < Element, Key, ElementOps, Base >::
elementWithKey (Key const& key)
{ return ivBase.elementWithKey (key);
}

