#ifndef _IMMCDXA_
   #define _IMMCDXA_
/*******************************************************************************
* FILE NAME: immcdxa.hpp                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMMCDXA                                                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <immremed.hpp>
#include <istring.hpp>

#pragma pack(4)


class IMMCDXA : public IMMRemovableMedia {
typedef IMMRemovableMedia
  Inherited;
public:
/*----------------------------- Constructors ---------------------------------*/
  IMMCDXA ( Boolean openNow = true,
            unsigned long instance = 0,
            Boolean openShareable = true);

virtual
  ~IMMCDXA();

/*-------------------------------- UPC ---------------------------------------*/
IString
  upc    (CallType call = wait) const;

protected:
/*----------------------------- Constructors ---------------------------------*/
  IMMCDXA ( unsigned long deviceIdentifier,
            const IString& newAlias = IString());

/*-------------------------------- Implementation ----------------------------*/
virtual Boolean
  isOpenStringValid(const IString& deviceName) const;

}; // IMMCDXA


#pragma pack()

#endif /* _IMMCDXA_ */
