#ifndef _IMMREMED_
   #define _IMMREMED_
/*******************************************************************************
* FILE NAME:  immremed.hpp                                                     *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMMRemovableMedia                                                        *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <immplayd.hpp>
#include <istring.hpp>
#include <inotify.hpp>

class IMMRemovableMediaHandler;
class IMMRemovableMediaData;

#pragma pack(4)


class IMMRemovableMedia : public IMMPlayableDevice {
typedef IMMPlayableDevice
  Inherited;
public:
/*----------------------------- Constructors ---------------------------------*/
virtual
  ~IMMRemovableMedia();

/*-------------------------------- Door and Presence -------------------------*/
virtual IMMRemovableMedia
  &closeDoor     (CallType call = wait),
  &lockDoor      (Boolean lock = true, CallType call = wait),
  &openDoor      (Boolean open = true, CallType call = wait),
  &unlockDoor    (CallType call = wait);

Boolean
  isMediaPresent (CallType call = wait) const;


/*----------------------- Notification Event Descriptions --------------------*/
static INotificationId const
  mediaLoadedId;

protected:
/*----------------------------- Constructors ---------------------------------*/
  IMMRemovableMedia (const IString& deviceName,
                      Boolean openNow,
                      unsigned long instance,
                      Boolean openShareable);

  IMMRemovableMedia (unsigned long deviceIdentifier,
                      const IString& newAlias = IString());

private:
/*--------------------------------- Private ----------------------------------*/
IMMRemovableMediaData
  *fRemovableMediaData;

friend class IMMRemovableMediaHandler;
}; // IMMRemvableMedia


#pragma pack()

#endif /* _IMMREMED_ */
