#ifndef _IMMREMHD_
   #define _IMMREMHD_
/*******************************************************************************
* FILE NAME: immremhd.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMMRemovableMediaHandler                                                 *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <immdvhdr.hpp>

class ITimer;
class IMMRemovableMedia;

#pragma pack(4)


class IMMRemovableMediaHandler : public IMMDeviceHandler {
typedef IMMDeviceHandler
  Inherited;
public:

/*----------------------------- Constructors ---------------------------------*/
  IMMRemovableMediaHandler();
virtual
  ~IMMRemovableMediaHandler();

/*-------------------------------- Media Loading -----------------------------*/
virtual IMMRemovableMediaHandler
  &mediaLoaded    (),
  &mediaUnloaded  ();

/*---------------------------- Device Attachment -----------------------------*/
virtual IMMRemovableMediaHandler
 &handleEventsFor ( IMMDevice* device );

/*-------------------------------- Event Processing --------------------------*/
virtual Boolean
  passDevice      (const IMMPassDeviceEvent& event);

private:
/*--------------------------------- Private ----------------------------------*/

/*----------------------------- Hidden Functions -----------------------------*/
virtual IMMRemovableMediaHandler
 &handleEventsFor( IWindow* window );

ITimer
  *fMediaTimer;
void
  checkMedia      (unsigned long timerId);
Boolean
  fDiscIsInDrive;

IMMDevice*
  fDevice;

}; // IMMRemovableMediaHandler


#pragma pack()

#endif /* _IMMREMHD_ */
