#ifndef _IMOUSHDR_
#define _IMOUSHDR_
/*******************************************************************************
* FILE NAME: imoushdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMouseHandler                                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ihandler.hpp>
#include <imousevt.hpp>

#pragma pack(4)


class IMouseHandler : public IHandler {
typedef IHandler
  Inherited;
public:
/*------------------------------- Constructors -------------------------------*/
  IMouseHandler ( );
virtual
 ~IMouseHandler ( );

protected:
/*---------------------------- Event Dispatching -----------------------------*/
virtual Boolean
  dispatchHandlerEvent ( IEvent& event );

/*----------------------------- Event Processing -----------------------------*/
virtual Boolean
  mouseClicked       ( IMouseClickEvent&   event ),
  mouseMoved         ( IMouseEvent&        event ),
  mousePointerChange ( IMousePointerEvent& event );
}; // IMouseHandler


#pragma pack()

#endif /* _IMOUSHDR_ */
