/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>


// **************************** IWPQueOnKSBag **************************

template <class Element, class Key, class ElementOps, class Base>
inline IOrderedCursor < Element >&
IWPQueOnKSBag <Element, Key, ElementOps, Base>::
baseCursor (ICursor& cursor) const
{
  return (Cursor&) cursor;
}

template <class Element, class Key, class ElementOps, class Base>
inline IOrderedCursor < Element > const&
IWPQueOnKSBag <Element, Key, ElementOps, Base>::
baseCursor (ICursor const& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class Key, class ElementOps, class Base >
inline IWPQueOnKSBag < Element, Key, ElementOps, Base >::
IWPQueOnKSBag (INumber n)
: ivBase (n)
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IWPQueOnKSBag < Element, Key, ElementOps, Base >::
IWPQueOnKSBag (IWPQueOnKSBag
                < Element, Key, ElementOps, Base > const& collection)
: ivBase (collection.ivBase)
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IWPQueOnKSBag < Element, Key, ElementOps, Base >&
IWPQueOnKSBag < Element, Key, ElementOps, Base >::
operator= (IWPQueOnKSBag < Element, Key,
                           ElementOps, Base > const& collection)
{ ivBase.operator= (collection.ivBase);
  return *this;
}

template < class Element, class Key, class ElementOps, class Base >
inline IWPQueOnKSBag < Element, Key, ElementOps, Base >::
~IWPQueOnKSBag ()
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
add (Element const& element)
{ return ivBase.add (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
add (Element const& element, ICursor &cursor)
{ return ivBase.add (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
addAllFrom (IWPQueOnKSBag < Element, Key,
                            ElementOps, Base > const& collection)
{ ivBase.addAllFrom (collection.ivBase);
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const& IWPQueOnKSBag < Element, Key, ElementOps, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const& IWPQueOnKSBag < Element, Key, ElementOps, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWPQueOnKSBag < Element, Key, ElementOps, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWPQueOnKSBag < Element, Key, ElementOps, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IWPQueOnKSBagCursor < Element, Key, ElementOps, Base >*
IWPQueOnKSBag < Element, Key, ElementOps, Base >::
newCursor () const
{ Cursor* result = new Cursor (*this);
  ICHECK (result != 0,
          IOutOfCollectionMemory, IOutOfCollectionMemoryText)
  return result;
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

template < class Element, class Key, class ElementOps, class Base >
inline Key const& IWPQueOnKSBag < Element, Key, ElementOps, Base >::
key (Element const& element) const
{ return ivBase.key (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
containsElementWithKey (Key const& key) const
{ return ivBase.containsElementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
containsAllKeysFrom (IWPQueOnKSBag
                      < Element, Key, ElementOps, Base > const& c) const
{ return ivBase.containsAllKeysFrom (c.ivBase);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
locateElementWithKey (Key const& key, ICursor &cursor) const
{ return ivBase.locateElementWithKey (key, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
locateOrAddElementWithKey (Element const& element)
{ return ivBase.locateOrAddElementWithKey (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
locateOrAddElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.locateOrAddElementWithKey
           (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const& IWPQueOnKSBag < Element, Key, ElementOps, Base >::
elementWithKey (Key const& key) const
{ return ivBase.elementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWPQueOnKSBag < Element, Key, ElementOps, Base >::
numberOfElementsWithKey (Key const& key) const
{ return ivBase.numberOfElementsWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
locateNextElementWithKey (Key const& key, ICursor& cursor) const
{ return ivBase.locateNextElementWithKey (key, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWPQueOnKSBag < Element, Key, ElementOps, Base >::
numberOfDifferentKeys () const
{ return ivBase.numberOfDifferentKeys ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
setToNextWithDifferentKey (ICursor& cursor) const
{ return ivBase.setToNextWithDifferentKey (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
removeFirst ()
{ ivBase.removeFirst ();
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const& IWPQueOnKSBag < Element, Key, ElementOps, Base >::
firstElement () const
{ return ivBase.firstElement ();
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const& IWPQueOnKSBag < Element, Key, ElementOps, Base >::
lastElement () const
{ return ivBase.lastElement ();
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const& IWPQueOnKSBag < Element, Key, ElementOps, Base >::
elementAtPosition (IPosition position) const
{ return ivBase.elementAtPosition (position);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
setToLast (ICursor &cursor) const
{ return ivBase.setToLast (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
setToPrevious (ICursor &cursor) const
{ return ivBase.setToPrevious (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
setToPosition (IPosition position, ICursor &cursor) const
{ ivBase.setToPosition (position, baseCursor (cursor));
}

#ifndef __BIN_COMPAT_BASE_43__
template < class Element, class Key, class ElementOps, class Base >
inline IPosition IWPQueOnKSBag < Element, Key, ElementOps, Base >::
position (ICursor const& cursor) const
{ return ivBase.position (baseCursor (cursor));
}
#endif

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
isFirst (ICursor const& cursor) const
{ return ivBase.isFirst (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWPQueOnKSBag < Element, Key, ElementOps, Base >::
isLast (ICursor const& cursor) const
{ return ivBase.isLast (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline long IWPQueOnKSBag < Element, Key, ElementOps, Base >::
compare (IWPQueOnKSBag < Element, Key,
                         ElementOps, Base > const& collection,
         long (*comparisonFunction)
           (Element const&, Element const&)) const
{ return ivBase.compare (collection.ivBase, comparisonFunction);
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
enqueue (Element const& element)
{ ivBase.add (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
enqueue (Element const& element, ICursor& cursor)
{ ivBase.add (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
dequeue ()
{ ivBase.removeFirst ();
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWPQueOnKSBag < Element, Key, ElementOps, Base >::
dequeue (Element& element)
{ element = ivBase.firstElement ();
  ivBase.removeFirst ();
}

