/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IQKSSET_H
#define _IQKSSET_H

#include <irksset.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack(4)

template < class Element, class Key, class Base >
class IQKeySortedSet : public virtual IRKeySortedSet < Element, Key, Base >
{
public:

  Base ivBase;

  IQKeySortedSet (INumber n = 100)
  : ivBase (n), IRKeySortedSet < Element, Key, Base > (ivBase)
  {
  }

  IQKeySortedSet (IQKeySortedSet < Element, Key, Base > const& c)
  : ivBase (c.ivBase), IRKeySortedSet < Element, Key, Base > (ivBase)
  {
  }

  IQKeySortedSet < Element, Key, Base >&
           operator= (IQKeySortedSet < Element, Key, Base > const& c)
  { ivBase = c.ivBase;
    return *this;
  }
};

#pragma info (restore)
#pragma pack()

#endif
