/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IQPRIOQU_H
#define _IQPRIOQU_H

#include <irprioqu.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack(4)

template < class Element, class Key, class Base >
class IQPriorityQueue : public virtual IRPriorityQueue < Element, Key, Base >
{
public:

  Base ivBase;

  IQPriorityQueue (INumber n = 100)
  : ivBase (n), IRPriorityQueue < Element, Key, Base > (ivBase)
  {
  }

  IQPriorityQueue (IQPriorityQueue < Element, Key, Base > const& c)
  : ivBase (c.ivBase), IRPriorityQueue < Element, Key, Base > (ivBase)
  {
  }

  IQPriorityQueue < Element, Key, Base >&
           operator= (IQPriorityQueue < Element, Key, Base > const& c)
  { ivBase = c.ivBase;
    return *this;
  }
};

#pragma info (restore)
#pragma pack()

#endif
