/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _IQSRTMAP_H
#define _IQSRTMAP_H

#include <irsrtmap.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack(4)

template < class Element, class Key, class Base >
class IQSortedMap : public virtual IRSortedMap < Element, Key, Base >
{
public:

  Base ivBase;

  IQSortedMap (INumber n = 100)
  : ivBase (n), IRSortedMap < Element, Key, Base > (ivBase)
  {
  }

  IQSortedMap (IQSortedMap < Element, Key, Base > const& c)
  : ivBase (c.ivBase), IRSortedMap < Element, Key, Base > (ivBase)
  {
  }

  IQSortedMap < Element, Key, Base >&
           operator= (IQSortedMap < Element, Key, Base > const& c)
  { ivBase = c.ivBase;
    return *this;
  }
};

#pragma info (restore)
#pragma pack()

#endif
