/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)

#ifdef ICL_NO_INLINE
#define inline
#include <isbkss.inl>
#undef inline
#endif

// ************************** IWSrtBagOnKSSetCursor ********************

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
setToFirst ()
{ ivOccurrence = 1;
  return ivBaseCursor.setToFirst ();
}

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
setToNext ()
{ ICHECK (isValid (), ICursorInvalidException, IInvalidCursorText)
  if (ivOccurrence == ivBaseCursor.element().ivOccurrences) {
    ivOccurrence = 1;
    return ivBaseCursor.setToNext ();
  }
  else {
    ivOccurrence++;
    return True;
  }
}

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
setToLast ()
{ IBoolean result = ivBaseCursor.setToLast ();
  if (result)
    ivOccurrence = ivBaseCursor.element ().ivOccurrences;
  return result;
}

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
setToPrevious ()
{ ICHECK (isValid (), ICursorInvalidException, IInvalidCursorText)
  if (ivOccurrence == 1) {
    ivOccurrence = 1;
    IBoolean result = ivBaseCursor.setToPrevious ();
    if (result)
      ivOccurrence = ivBaseCursor.element ().ivOccurrences;
    return result;
  }
  else {
    ivOccurrence--;
    return True;
  }
}

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
isValid () const
{ return ivBaseCursor.isValid ();
}

template <class Element, class ElementOps, class Base>
void IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
invalidate ()
{ ivBaseCursor.invalidate ();
}

template <class Element, class ElementOps, class Base>
void IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
copy (ICursor const& cursor)
{ operator= ((IWSrtBagOnKSSetCursor
                < Element, ElementOps, Base> const&) cursor);
}

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
operator== (ICursor const& cursor) const
{ return operator== ((IWSrtBagOnKSSetCursor
                        < Element, ElementOps, Base> const&) cursor);
}

template <class Element, class ElementOps, class Base>
Element const& IWSrtBagOnKSSetCursor <Element, ElementOps, Base>::
element () const
{ return ivBaseCursor.element ().ivElem;
}


// ************************** IWSrtBagOnKSSet **************************

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSet <Element, ElementOps, Base>::
removePredicate (ISBKSElm < Element > const& element, void* env)
{ RemoveEnv* re = (RemoveEnv*)env;
  IBoolean result = (*re->predicate) (element.ivElem, re->env);
  if (result)
    re->removeCount += element.ivOccurrences;
  return result;
}

template <class Element, class ElementOps, class Base>
IBoolean IWSrtBagOnKSSet <Element, ElementOps, Base>::
cleanupPredicate (ISBKSElm < Element > const& element, void* env)
{ return element.ivOccurrences == 0;
}

#pragma info (restore)
