/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _ISETKSS_H
#define _ISETKSS_H

#include <iglobals.h>
#include <icursor.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#ifdef ICL_NO_INLINE
#define inline
#endif

template < class Element, class ElementOps, class Base >
class IWSetOnKSSet;

template < class Element, class ElementOps, class Base >
class IWSetOnKSSetCursor :
  public Base::Cursor
{
public:

           IWSetOnKSSetCursor
                      (IWSetOnKSSet
                        < Element, ElementOps, Base > const& c)
           : Base::Cursor (c.ivBase)
           {
           }

};

template < class Element, class ElementOps, class Base >
class IWSetOnKSSet {
protected:

  Base ivBase;

public:


  typedef IWSetOnKSSetCursor < Element, ElementOps, Base > Cursor;

  inline   IWSetOnKSSet     (INumber numberOfElements = 100);

  inline   IWSetOnKSSet     (IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline  ~IWSetOnKSSet     ();

  inline
  IBoolean add              (Element const&);

  inline
  IBoolean add              (Element const&, ICursor&);

  inline
  void     addAllFrom       (IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  void     addDifference    (IWSetOnKSSet
                              < Element, ElementOps, Base > const&,
                             IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  void     addIntersection  (IWSetOnKSSet
                              < Element, ElementOps, Base > const&,
                             IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  void     addUnion         (IWSetOnKSSet
                              < Element, ElementOps, Base > const&,
                             IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  IBoolean allElementsDo    (IBoolean (*function) (Element&, void*),
                             void* additionalArgument = 0);

  inline
  IBoolean allElementsDo    (IIterator <Element>&);

  inline
  IBoolean allElementsDo    (IBoolean (*function)
                              (Element const&, void*),
                             void* additionalArgument = 0) const;

  inline
  IBoolean allElementsDo    (IConstantIterator <Element>&) const;

  inline
  Element const&
           anyElement       () const;

  inline
  IBoolean contains         (Element const&) const;

  inline
  IBoolean containsAllFrom  (IWSetOnKSSet
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  void     differenceWith   (IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  Element const&
           elementAt        (ICursor const&) const;

  inline
  Element& elementAt        (ICursor const&);

  inline
  void     intersectionWith (IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  IBoolean isBounded        () const;

  inline
  IBoolean isEmpty          () const;

  inline
  IBoolean isFull           () const;

  inline
  IBoolean locate           (Element const&, ICursor&) const;

  inline
  IBoolean locateOrAdd      (Element const&);

  inline
  IBoolean locateOrAdd      (Element const&, ICursor&);

  inline
  INumber  maxNumberOfElements () const;

  inline
  INumber  numberOfElements () const;

  inline
  Cursor* newCursor        () const;

  inline
  IWSetOnKSSet < Element, ElementOps, Base >&
           operator =       (IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  IBoolean operator ==      (IWSetOnKSSet
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  IBoolean operator !=      (IWSetOnKSSet
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  IBoolean remove           (Element const&);

  inline
  void     removeAll        ();

  inline
  INumber  removeAll        (IBoolean (*property)
                              (Element const&, void*),
                             void* additionalArgument = 0);

  inline
  void     removeAt         (ICursor&);

  inline
  void     replaceAt        (ICursor const&, Element const&);

  inline
  IBoolean setToFirst       (ICursor&) const;

  inline
  IBoolean setToNext        (ICursor&) const;

  inline
  void     unionWith        (IWSetOnKSSet
                              < Element, ElementOps, Base > const&);

  friend class IWSetOnKSSetCursor < Element, ElementOps, Base >;

  inline
  IBoolean isConsistent     () const;

protected:

  static
  IBoolean isContained      (Element const&, void* env);

  static
  IBoolean isNotContained   (Element const&, void* env);

  // used for cfront support:
  inline
  IElementCursor < Element >&
            baseCursor (ICursor&) const;

  inline
  IElementCursor < Element > const&
            baseCursor (ICursor const&) const;

};


#define IDefineGSetOnGKeySortedSet(GKSSet, GSet) \
template < class Element, class ElementOps > \
class GSet : \
  public IWSetOnKSSet \
           < Element, ElementOps, \
             GKSSet < Element, Element, \
                      IOpsWithKey < Element, ElementOps > > > { \
public: \
  GSet (INumber n = 100) : \
    IWSetOnKSSet \
      < Element, ElementOps, \
        GKSSet < Element, Element, \
                 IOpsWithKey < Element, ElementOps > > > (n) {} \
};



#ifdef ICL_NO_INLINE
#undef inline
#else
#include <isetkss.inl>
#endif

#if ! defined ( __TEMPINC__ )
#include <isetkss.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
