/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>


// **************************** IWSetOnKSSet ***************************

template <class Element, class ElementOps, class Base>
inline IElementCursor < Element >&
IWSetOnKSSet <Element, ElementOps, Base>::
baseCursor (ICursor& cursor) const
{
  return (Cursor&) cursor;
}

template <class Element, class ElementOps, class Base>
inline IElementCursor < Element > const&
IWSetOnKSSet <Element, ElementOps, Base>::
baseCursor (ICursor const& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class ElementOps, class Base >
inline IWSetOnKSSet < Element, ElementOps, Base >::
IWSetOnKSSet (INumber n)
: ivBase (n)
{
}

template < class Element, class ElementOps, class Base >
inline IWSetOnKSSet < Element, ElementOps, Base >::
IWSetOnKSSet (IWSetOnKSSet < Element,
                             ElementOps, Base > const& collection)
: ivBase (collection.ivBase)
{
}

template < class Element, class ElementOps, class Base >
inline IWSetOnKSSet < Element, ElementOps, Base >&
IWSetOnKSSet < Element, ElementOps, Base >::
operator= (IWSetOnKSSet < Element, ElementOps, Base > const& collection)
{ ivBase.operator= (collection.ivBase);
  return *this;
}

template < class Element, class ElementOps, class Base >
inline IWSetOnKSSet < Element, ElementOps, Base >::
~IWSetOnKSSet ()
{
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
add (Element const& element)
{ return ivBase.add (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
add (Element const& element, ICursor &cursor)
{ return ivBase.add (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
addAllFrom (IWSetOnKSSet < Element,
                           ElementOps, Base > const& collection)
{ ivBase.addAllFrom (collection.ivBase);
}

template < class Element, class ElementOps, class Base >
inline Element const& IWSetOnKSSet < Element, ElementOps, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline Element& IWSetOnKSSet < Element, ElementOps, Base >::
elementAt (ICursor const& cursor)
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline Element const& IWSetOnKSSet < Element, ElementOps, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
removeAt (ICursor& cursor)
{ ivBase.removeAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline INumber IWSetOnKSSet < Element, ElementOps, Base >::
removeAll (IBoolean (*predicate) (Element const&, void*), void* env)
{ return ivBase.removeAll (predicate, env);
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
replaceAt (ICursor const& cursor, Element const& element)
{ ivBase.replaceAt (baseCursor (cursor), element);
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWSetOnKSSet < Element, ElementOps, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWSetOnKSSet < Element, ElementOps, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class ElementOps, class Base >
inline IWSetOnKSSetCursor < Element, ElementOps, Base >*
IWSetOnKSSet < Element, ElementOps, Base >::
newCursor () const
{ Cursor* result = new Cursor (*this);
  ICHECK (result != 0,
          IOutOfCollectionMemory, IOutOfCollectionMemoryText)
  return result;
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element &, void*),
               void* environment)
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IIterator <Element>& iterator)
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
contains (Element const& element) const
{ return ivBase.containsElementWithKey (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
containsAllFrom (IWSetOnKSSet
                  < Element, ElementOps, Base > const& collection) const
{ return ivBase.containsAllKeysFrom (collection.ivBase);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
locate (Element const& element, ICursor &cursor) const
{ return ivBase.locateElementWithKey (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
locateOrAdd (Element const& element)
{ return ivBase.locateOrAddElementWithKey (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
locateOrAdd (Element const& element, ICursor &cursor)
{ return ivBase.locateOrAddElementWithKey
           (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
remove (Element const& element)
{ return ivBase.removeElementWithKey (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
operator== (IWSetOnKSSet < Element,
                           ElementOps, Base > const& collection) const
{ return numberOfElements() == collection.numberOfElements() &&
         containsAllFrom (collection);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSetOnKSSet < Element, ElementOps, Base >::
operator!= (IWSetOnKSSet < Element,
                           ElementOps, Base > const& collection) const
{ return ! operator== (collection);
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
unionWith (IWSetOnKSSet < Element, ElementOps, Base > const& collection)
{ if (this != &collection)
    addAllFrom (collection);
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
intersectionWith (IWSetOnKSSet < Element,
                                 ElementOps, Base > const& collection)
{ if (this != &collection)
  { IWSetOnKSSet <Element, ElementOps, Base> const* env = &collection;
    removeAll (isNotContained, &env);
  }
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
differenceWith (IWSetOnKSSet < Element,
                               ElementOps, Base > const& collection)
{ if (this == &collection)
    removeAll ();
  else
  { IWSetOnKSSet <Element, ElementOps, Base> const* env = &collection;
    removeAll (isContained, &env);
  }
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
addUnion (IWSetOnKSSet < Element, ElementOps, Base > const& collection1,
          IWSetOnKSSet < Element, ElementOps, Base > const& collection2)
{ unionWith (collection1);
  unionWith (collection2);
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
addIntersection (IWSetOnKSSet < Element,
                                ElementOps, Base > const& collection1,
                 IWSetOnKSSet < Element,
                                ElementOps, Base > const& collection2)
{ if (this == &collection1 || this == &collection2)
    return;
  Cursor cursor (collection1);
  forCursor (cursor) {
    if (collection2.contains (collection1.elementAt (cursor)))
      add (collection1.elementAt (cursor));
  }
}

template < class Element, class ElementOps, class Base >
inline void IWSetOnKSSet < Element, ElementOps, Base >::
addDifference (IWSetOnKSSet < Element,
                              ElementOps, Base > const& collection1,
               IWSetOnKSSet < Element,
                              ElementOps, Base > const& collection2)
{ if (this == &collection1)
    return;
  else if (this == &collection2)
    unionWith (collection1);
  else {
    Cursor cursor (collection1);
    forCursor (cursor) {
      if (! collection2.contains (collection1.elementAt (cursor)))
        add (collection1.elementAt (cursor));
    }
  }
}
