/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _ISMKSS_H
#define _ISMKSS_H

#include <iglobals.h>
#include <icursor.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#ifdef ICL_NO_INLINE
#define inline
#endif

template < class Element, class Key, class ElementOps, class Base >
class IWSrtMapOnKSSet;

template < class Element, class Key, class ElementOps, class Base >
class IWSrtMapOnKSSetCursor :
  public Base::Cursor
{
public:

           IWSrtMapOnKSSetCursor
                     (IWSrtMapOnKSSet
                       < Element, Key, ElementOps, Base > const& c)
           : Base::Cursor (c.ivBase)
           {
           }

};

template < class Element, class Key, class ElementOps, class Base >
class IWSrtMapOnKSSet {

protected:

  Base ivBase;

public:


  typedef IWSrtMapOnKSSetCursor < Element, Key,
                                  ElementOps, Base > Cursor;

  inline   IWSrtMapOnKSSet  (INumber numberOfElements = 100);

  inline   IWSrtMapOnKSSet  (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline  ~IWSrtMapOnKSSet  ();

  inline
  IBoolean add              (Element const&);

  inline
  IBoolean add              (Element const&, ICursor&);

  inline
  void     addAllFrom       (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline
  void     addDifference    (IWSrtMapOnKSSet
                              < Element, Key, ElementOps, Base > const&,
                             IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline
  void     addIntersection  (IWSrtMapOnKSSet
                              < Element, Key, ElementOps, Base > const&,
                             IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline
  IBoolean addOrReplaceElementWithKey (Element const&);

  inline
  IBoolean addOrReplaceElementWithKey (Element const&, ICursor&);

  inline
  void     addUnion         (IWSrtMapOnKSSet
                              < Element, Key, ElementOps, Base > const&,
                             IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline
  IBoolean allElementsDo    (IBoolean (*function) (Element&, void*),
                             void* additionalArgument = 0);

  inline
  IBoolean allElementsDo    (IIterator <Element>&);

  inline
  IBoolean allElementsDo    (IBoolean (*function)
                              (Element const&, void*),
                             void* additionalArgument = 0) const;

  inline
  IBoolean allElementsDo    (IConstantIterator <Element>&) const;

  inline
  Element const&
           anyElement       () const;

  inline
  long     compare          (IWSrtMapOnKSSet
                              < Element, Key, ElementOps, Base > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  inline
  IBoolean contains         (Element const&) const;

  inline
  IBoolean containsAllFrom  (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&) const;

  inline
  IBoolean containsAllKeysFrom
                            (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&) const;

  inline
  IBoolean containsElementWithKey (Key const&) const;

  inline
  void     differenceWith   (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline
  Element const&
           elementAt        (ICursor const&) const;

  inline
  Element& elementAt        (ICursor const&);

  inline
  Element const&
           elementAtPosition (IPosition) const;

  inline
  Element const&
           elementWithKey   (Key const&) const;

  inline
  Element& elementWithKey   (Key const&);

  inline
  Element const&
           firstElement     () const;

  inline
  void     intersectionWith (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline
  IBoolean isBounded        () const;

  inline
  IBoolean isEmpty          () const;

  inline
  IBoolean isFirst          (ICursor const&) const;

  inline
  IBoolean isFull           () const;

  inline
  IBoolean isLast           (ICursor const&) const;

  inline
  Key const&
           key              (Element const&) const;

  inline
  Element const&
           lastElement      () const;

  inline
  IBoolean locate           (Element const&, ICursor&) const;

  inline
  IBoolean locateElementWithKey (Key const&, ICursor&) const;

  inline
  IBoolean locateNext       (Element const&, ICursor&) const;

  inline
  IBoolean locateNextElementWithKey (Key const&, ICursor&) const;

  inline
  IBoolean locateOrAdd      (Element const&);

  inline
  IBoolean locateOrAdd      (Element const&, ICursor&);

  inline
  IBoolean locateOrAddElementWithKey (Element const&);

  inline
  IBoolean locateOrAddElementWithKey (Element const&, ICursor&);

  inline
  INumber  maxNumberOfElements () const;

  inline
  Cursor*  newCursor        () const;

  inline
  INumber  numberOfElements () const;

  inline
  IWSrtMapOnKSSet < Element, Key, ElementOps, Base >&
           operator =       (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  inline
  IBoolean operator ==      (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&) const;

  inline
  IBoolean operator !=      (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&) const;

  inline
  IBoolean remove           (Element const&);

  inline
  void     removeAll        ();

  inline
  INumber  removeAll        (IBoolean (*property)
                              (Element const&, void*),
                             void* additionalArgument = 0);

  inline
  void     removeAt         (ICursor&);

  inline
  void     removeAtPosition (IPosition);

  inline
  IBoolean removeElementWithKey (Key const&);

  inline
  void     removeFirst      ();

  inline
  void     removeLast       ();

  inline
  void     replaceAt        (ICursor const&, Element const&);

  inline
  IBoolean replaceElementWithKey (Element const&);

  inline
  IBoolean replaceElementWithKey (Element const&, ICursor&);

  inline
  IBoolean setToFirst       (ICursor&) const;

  inline
  IBoolean setToLast        (ICursor&) const;

  inline
  IBoolean setToNext        (ICursor&) const;

  inline
  void     setToPosition    (IPosition, ICursor&) const;

#ifndef __BIN_COMPAT_BASE_43__
  inline
  IPosition     position    (ICursor const&) const;
#endif

  inline
  IBoolean setToPrevious    (ICursor&) const;

  inline
  void     unionWith        (IWSrtMapOnKSSet
                              < Element, Key,
                                ElementOps, Base > const&);

  friend class IWSrtMapOnKSSetCursor < Element, Key, ElementOps, Base >;

  inline
  IBoolean isConsistent     () const;

protected:

  ElementOps ivElementOps;

  static
  IBoolean isContained    (Element const&, void* env);

  static
  IBoolean isNotContained (Element const&, void* env);

  // used for cfront support:
  inline
  IOrderedCursor < Element >&
            baseCursor (ICursor&) const;

  inline
  IOrderedCursor < Element > const&
            baseCursor (ICursor const&) const;

};


#define IDefineGSortedMapOnGKeySortedSet(GKSSet, GSrtMap) \
template < class Element, class Key, class ElementOps > \
class GSrtMap : \
  public IWSrtMapOnKSSet \
           < Element, Key, ElementOps, \
             GKSSet < Element, Key, ElementOps > > { \
public: \
  GSrtMap (INumber n = 100) : \
    IWSrtMapOnKSSet \
      < Element, Key, ElementOps, \
        GKSSet < Element, Key, ElementOps > > (n) {} \
};



#ifdef ICL_NO_INLINE
#undef inline
#else
#include <ismkss.inl>
#endif

#ifndef __TEMPINC__
#include <ismkss.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
