/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>


// ************************* IWSrtRelOnKSBag **************************

template < class Element, class Key, class ElementOps, class Base >
inline IOrderedCursor < Element >&
IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
baseCursor (ICursor& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class Key, class ElementOps, class Base >
inline IOrderedCursor < Element > const&
IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
baseCursor (ICursor const& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class Key, class ElementOps, class Base >
inline IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
IWSrtRelOnKSBag (INumber n)
: ivBase (n)
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
IWSrtRelOnKSBag (IWSrtRelOnKSBag
                  < Element, Key, ElementOps, Base > const& collection)
: ivBase (collection.ivBase)
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IWSrtRelOnKSBag < Element, Key, ElementOps, Base >&
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
operator= (IWSrtRelOnKSBag < Element, Key,
                             ElementOps, Base > const& collection)
{ ivBase.operator= (collection.ivBase);
  return *this;
}

template < class Element, class Key, class ElementOps, class Base >
inline IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
~IWSrtRelOnKSBag ()
{
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
add (Element const& element)
{ return ! locateOrAdd (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
add (Element const& element, ICursor &cursor)
{ return ! locateOrAdd (element, cursor);
}

template <class Element, class Key, class ElementOps, class Base>
inline void IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
addAllFrom (IWSrtRelOnKSBag < Element, Key, ElementOps, Base >
            const& collection)
{
#ifndef INO_CHECKS
  ICHECK (this != &collection,
          IIdenticalCollectionException, IIdenticalCollectionText)
#endif
  Cursor cursor (collection);
  forCursor (cursor) {
    add (collection.elementAt (cursor));
  }
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline Element& IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
elementAt (ICursor const& cursor)
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
removeAt (ICursor& cursor)
{ ivBase.removeAt (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
removeAll (IBoolean (*predicate) (Element const&, void*), void* env)
{ return ivBase.removeAll (predicate, env);
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
replaceAt (ICursor const& cursor, Element const& element)
{ ivBase.replaceAt (baseCursor (cursor), element);
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class Key, class ElementOps, class Base >
inline INumber IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class Key, class ElementOps, class Base >
inline IWSrtRelOnKSBagCursor < Element, Key, ElementOps, Base >*
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
newCursor () const
{ Cursor* result = new Cursor (*this);
  ICHECK (result != 0,
          IOutOfCollectionMemory, IOutOfCollectionMemoryText)
  return result;
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element &, void*),
               void* environment)
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
allElementsDo (IIterator <Element>& iterator)
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
contains (Element const& element) const
{ Cursor cursor (*this);
  return locate (element, cursor);
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
containsAllFrom (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
                 const& collection) const
{ Cursor cursor (collection);
  IBoolean result = True;
  forCursor (cursor) {
    if (! contains (collection.elementAt (cursor))) {
      result = False;
      break;
    }
  }
  return result;
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
locate (Element const& element, ICursor& cursor) const
{ for (locateElementWithKey (ivElementOps.key (element), cursor);
       cursor.isValid ();
       locateNextElementWithKey (ivElementOps.key (element), cursor)) {
    if (ivElementOps.equal (elementAt (cursor), element))
      return True;
  }
  return False;
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
locateNext (Element const& element, ICursor& cursor) const
{ Element const& atC = elementAt (cursor);
  if (ivElementOps.keyOps.compare
        (ivElementOps.key (element), ivElementOps.key (atC)) <= 0) {
    cursor.invalidate ();
    return False;
  }
  else
    return locate (element, cursor);
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
locateOrAdd (Element const& element)
{ Cursor dummy (*this);
  return locateOrAdd (element, dummy);
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
locateOrAdd (Element const& element, ICursor& cursor)
{ IBoolean result = locate (element, cursor);
  if (! result) {
    ivBase.add (element, baseCursor (cursor));
  }
  return result;
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
remove (Element const& element)
{ Cursor cursor (*this);
  IBoolean result = locate (element, cursor);
  if (result) {
    ivBase.removeAt (baseCursor ((ICursor&)cursor));
  }
  return result;
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
operator == (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
               const& collection) const
{ IBoolean result =
             numberOfElements () == collection.numberOfElements ();
  if (result) {
    Cursor thisCursor (*this);
    Cursor collectionCursor (collection);

    for (thisCursor.setToFirst (), collectionCursor.setToFirst ();
         result && thisCursor.isValid ();
         thisCursor.setToNext (), collectionCursor.setToNext ()) {
      result = ivElementOps.equal
                 (this->elementAt (thisCursor),
                  collection.elementAt (collectionCursor));
    }
  }
  return result;
}

template <class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
operator != (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
               const& collection) const
{ return ! operator == (collection);
}

template <class Element, class Key, class ElementOps, class Base>
inline void IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
unionWith (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
             const& collection)
{ if (this != &collection)
    addAllFrom (collection);
}

template <class Element, class Key, class ElementOps, class Base>
inline void IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
intersectionWith (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
                    const& collection)
{ if (this != &collection)
  { IWSrtRelOnKSBag < Element, Key,
                      ElementOps, Base > const* env = &collection;
    removeAll (isNotContained, &env);
  }
}

template <class Element, class Key, class ElementOps, class Base>
inline void IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
differenceWith (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
                  const& collection)
{ if (this == &collection)
    removeAll ();
  else
  { IWSrtRelOnKSBag < Element, Key,
                      ElementOps, Base > const* env = &collection;
    removeAll (isContained, &env);
  }
}

template <class Element, class Key, class ElementOps, class Base>
inline void IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
addUnion (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
            const& collection1,
          IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
            const& collection2)
{ unionWith (collection1);
  unionWith (collection2);
}

template <class Element, class Key, class ElementOps, class Base>
inline void IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
addIntersection (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
                   const& collection1,
                 IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
                   const& collection2)
{ if (this == &collection1 || this == &collection2)
    return;
  Cursor cursor (collection1);
  forCursor (cursor) {
    if (collection2.contains (collection1.elementAt (cursor)))
      add (collection1.elementAt (cursor));
  }
}

template <class Element, class Key, class ElementOps, class Base>
inline void IWSrtRelOnKSBag <Element, Key, ElementOps, Base>::
addDifference (IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
                 const& collection1,
               IWSrtRelOnKSBag <Element, Key, ElementOps, Base>
                 const& collection2)
{ if (this == &collection1)
    return;
  else if (this == &collection2)
    unionWith (collection1);
  else {
    Cursor cursor (collection1);
    forCursor (cursor) {
      if (! collection2.contains (collection1.elementAt (cursor)))
        add (collection1.elementAt (cursor));
    }
  }
}

template < class Element, class Key, class ElementOps, class Base >
inline Key const& IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
key (Element const& element) const
{ return ivElementOps.key (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
containsElementWithKey (Key const& key) const
{ return ivBase.containsElementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
containsAllKeysFrom (IWSrtRelOnKSBag
                      < Element, Key, ElementOps, Base > const& c) const
{ return ivBase.containsAllKeysFrom (c.ivBase);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
locateElementWithKey (Key const& key, ICursor &cursor) const
{ return ivBase.locateElementWithKey (key, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
replaceElementWithKey (Element const& element)
{ return ivBase.replaceElementWithKey (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
replaceElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.replaceElementWithKey (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
locateOrAddElementWithKey (Element const& element)
{ return ivBase.locateOrAddElementWithKey (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
locateOrAddElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.locateOrAddElementWithKey
           (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
addOrReplaceElementWithKey (Element const& element)
{ return ivBase.addOrReplaceElementWithKey (element);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
addOrReplaceElementWithKey (Element const& element, ICursor &cursor)
{ return ivBase.addOrReplaceElementWithKey
           (element, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
removeElementWithKey (Key const& key)
{ return ivBase.removeElementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
elementWithKey (Key const& key) const
{ return ivBase.elementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base >
inline Element& IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
elementWithKey (Key const& key)
{ return ivBase.elementWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base>
inline INumber IWSrtRelOnKSBag < Element, Key, ElementOps, Base>::
numberOfElementsWithKey (Key const& key) const
{ return ivBase.numberOfElementsWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base>::
locateNextElementWithKey (Key const& key, ICursor& cursor) const
{ return ivBase.locateNextElementWithKey (key, baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base>
inline INumber IWSrtRelOnKSBag < Element, Key, ElementOps, Base>::
removeAllElementsWithKey (Key const& key)
{ return ivBase.removeAllElementsWithKey (key);
}

template < class Element, class Key, class ElementOps, class Base>
inline INumber IWSrtRelOnKSBag < Element, Key, ElementOps, Base>::
numberOfDifferentKeys() const
{ return ivBase.numberOfDifferentKeys ();
}

template < class Element, class Key, class ElementOps, class Base>
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base>::
setToNextWithDifferentKey (ICursor& cursor) const
{ return ivBase.setToNextWithDifferentKey (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
removeFirst ()
{ ivBase.removeFirst ();
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
removeLast ()
{ ivBase.removeLast ();
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
removeAtPosition (IPosition position)
{ ivBase.removeAtPosition (position);
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
firstElement () const
{ return ivBase.firstElement ();
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
lastElement () const
{ return ivBase.lastElement ();
}

template < class Element, class Key, class ElementOps, class Base >
inline Element const&
IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
elementAtPosition (IPosition position) const
{ return ivBase.elementAtPosition (position);
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
setToLast (ICursor &cursor) const
{ return ivBase.setToLast (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
setToPrevious (ICursor &cursor) const
{ return ivBase.setToPrevious (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline void IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
setToPosition (IPosition position, ICursor &cursor) const
{ ivBase.setToPosition (position, baseCursor (cursor));
}

#ifndef __BIN_COMPAT_BASE_43__
template < class Element, class Key, class ElementOps, class Base >
inline IPosition IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
position (ICursor const& cursor) const
{ return ivBase.position (baseCursor (cursor));
}
#endif

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
isFirst (ICursor const& cursor) const
{ return ivBase.isFirst (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline IBoolean IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
isLast (ICursor const& cursor) const
{ return ivBase.isLast (baseCursor (cursor));
}

template < class Element, class Key, class ElementOps, class Base >
inline long IWSrtRelOnKSBag < Element, Key, ElementOps, Base >::
compare (IWSrtRelOnKSBag < Element, Key,
                           ElementOps, Base > const& collection,
         long (*comparisonFunction)
           (Element const&, Element const&)) const
{ return ivBase.compare (collection.ivBase, comparisonFunction);
}
