/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _ISSKSS_H
#define _ISSKSS_H

#include <iglobals.h>
#include <icursor.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#ifdef ICL_NO_INLINE
#define inline
#endif

template < class Element, class ElementOps, class Base >
class IWSrtSetOnKSSet;

template < class Element, class ElementOps, class Base >
class IWSrtSetOnKSSetCursor :
  public Base::Cursor
{
public:

           IWSrtSetOnKSSetCursor
                      (IWSrtSetOnKSSet
                        < Element, ElementOps, Base > const& c)
           : Base::Cursor (c.ivBase)
           {
           }

};

template < class Element, class ElementOps, class Base >
class IWSrtSetOnKSSet {
protected:

  Base ivBase;

public:


  typedef IWSrtSetOnKSSetCursor< Element, ElementOps, Base > Cursor;

  inline   IWSrtSetOnKSSet  (INumber numberOfElements = 100);

  inline   IWSrtSetOnKSSet  (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline  ~IWSrtSetOnKSSet  ();

  inline
  IBoolean add              (Element const&);

  inline
  IBoolean add              (Element const&, ICursor&);

  inline
  void     addAllFrom       (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  void     addDifference    (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&,
                             IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  void     addIntersection  (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&,
                             IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  void     addUnion         (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&,
                             IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  IBoolean allElementsDo    (IBoolean (*function) (Element&, void*),
                             void* additionalArgument = 0);

  inline
  IBoolean allElementsDo    (IIterator <Element>&);

  inline
  IBoolean allElementsDo    (IBoolean (*function)
                              (Element const&, void*),
                             void* additionalArgument = 0) const;

  inline
  IBoolean allElementsDo    (IConstantIterator <Element>&) const;

  inline
  Element const&
           anyElement       () const;

  inline
  long     compare          (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  inline
  IBoolean contains         (Element const&) const;

  inline
  IBoolean containsAllFrom  (IWSrtSetOnKSSet
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  void     differenceWith   (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  Element const&
           elementAt        (ICursor const&) const;

  inline
  Element& elementAt        (ICursor const&);

  inline
  Element const&
           elementAtPosition (IPosition) const;

  inline
  Element const&
           firstElement     () const;

  inline
  void     intersectionWith (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  IBoolean isBounded        () const;

  inline
  IBoolean isEmpty          () const;

  inline
  IBoolean isFirst          (ICursor const&) const;

  inline
  IBoolean isFull           () const;

  inline
  IBoolean isLast           (ICursor const&) const;

  inline
  Element const&
           lastElement      () const;

  inline
  IBoolean locate           (Element const&, ICursor&) const;

  inline
  IBoolean locateNext       (Element const&, ICursor&) const;

  inline
  IBoolean locateOrAdd      (Element const&);

  inline
  IBoolean locateOrAdd      (Element const&, ICursor&);

  inline
  INumber  maxNumberOfElements () const;

  inline
  INumber  numberOfElements () const;

  inline
  Cursor*  newCursor        () const;

  inline
  IWSrtSetOnKSSet < Element, ElementOps, Base >&
           operator =       (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  inline
  IBoolean operator ==      (IWSrtSetOnKSSet
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  IBoolean operator !=      (IWSrtSetOnKSSet
                              < Element,
                                ElementOps, Base > const&) const;

  inline
  IBoolean remove           (Element const&);

  inline
  void     removeAll        ();

  inline
  INumber  removeAll        (IBoolean (*property)
                              (Element const&, void*),
                             void* additionalArgument = 0);

  inline
  void     removeAt         (ICursor&);

  inline
  void     removeAtPosition (IPosition);

  inline
  void     removeFirst      ();

  inline
  void     removeLast       ();

  inline
  void     replaceAt        (ICursor const&, Element const&);

  inline
  IBoolean setToFirst       (ICursor&) const;

  inline
  IBoolean setToLast        (ICursor&) const;

  inline
  IBoolean setToNext        (ICursor&) const;

  inline
  void     setToPosition    (IPosition, ICursor&) const;

#ifndef __BIN_COMPAT_BASE_43__
  inline
  IPosition     position    (ICursor const&) const;
#endif

  inline
  IBoolean setToPrevious    (ICursor&) const;

  inline
  void     unionWith        (IWSrtSetOnKSSet
                              < Element, ElementOps, Base > const&);

  friend class IWSrtSetOnKSSetCursor< Element, ElementOps, Base >;

  inline
  IBoolean isConsistent     () const;

protected:

  static
  IBoolean isContained      (Element const&, void* env);

  static
  IBoolean isNotContained   (Element const&, void* env);

  // used for cfront support:
  inline
  IOrderedCursor < Element >&
            baseCursor (ICursor&) const;

  inline
  IOrderedCursor < Element > const&
            baseCursor (ICursor const&) const;

};


#define IDefineGSortedSetOnGKeySortedSet(GKSSet, GSrtSet) \
template < class Element, class ElementOps > \
class GSrtSet : \
  public IWSrtSetOnKSSet \
           < Element, ElementOps, \
             GKSSet < Element, Element, \
                      IOpsWithKey < Element, ElementOps > > > { \
public: \
  GSrtSet (INumber n = 100) : \
    IWSrtSetOnKSSet \
      < Element, ElementOps, \
        GKSSet < Element, Element, \
                 IOpsWithKey < Element, ElementOps > > > (n) {} \
};



#ifdef ICL_NO_INLINE
#undef inline
#else
#include <isskss.inl>
#endif

#ifndef __TEMPINC__
#include <isskss.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
