/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#include <ibexcept.h>


// ************************** IWSrtSetOnKSSet **************************

template <class Element, class ElementOps, class Base>
inline IOrderedCursor < Element >&
IWSrtSetOnKSSet <Element, ElementOps, Base>::
baseCursor (ICursor& cursor) const
{
  return (Cursor&) cursor;
}

template <class Element, class ElementOps, class Base>
inline IOrderedCursor < Element > const&
IWSrtSetOnKSSet <Element, ElementOps, Base>::
baseCursor (ICursor const& cursor) const
{
  return (Cursor&) cursor;
}

template < class Element, class ElementOps, class Base >
inline IWSrtSetOnKSSet < Element, ElementOps, Base >::
IWSrtSetOnKSSet (INumber n)
: ivBase (n)
{
}

template < class Element, class ElementOps, class Base >
inline IWSrtSetOnKSSet < Element, ElementOps, Base >::
IWSrtSetOnKSSet (IWSrtSetOnKSSet
                  < Element, ElementOps, Base > const& collection)
: ivBase (collection.ivBase)
{
}

template < class Element, class ElementOps, class Base >
inline IWSrtSetOnKSSet < Element, ElementOps, Base >&
IWSrtSetOnKSSet < Element, ElementOps, Base >::
operator= (IWSrtSetOnKSSet < Element,
                             ElementOps, Base > const& collection)
{ ivBase.operator= (collection.ivBase);
  return *this;
}

template < class Element, class ElementOps, class Base >
inline IWSrtSetOnKSSet < Element, ElementOps, Base >::
~IWSrtSetOnKSSet ()
{
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
add (Element const& element)
{ return ivBase.add (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
add (Element const& element, ICursor &cursor)
{ return ivBase.add (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
addAllFrom (IWSrtSetOnKSSet < Element,
                              ElementOps, Base > const& collection)
{ ivBase.addAllFrom (collection.ivBase);
}

template < class Element, class ElementOps, class Base >
inline Element const& IWSrtSetOnKSSet < Element, ElementOps, Base >::
elementAt (ICursor const& cursor) const
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline Element& IWSrtSetOnKSSet < Element, ElementOps, Base >::
elementAt (ICursor const& cursor)
{ return ivBase.elementAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline Element const& IWSrtSetOnKSSet < Element, ElementOps, Base >::
anyElement () const
{ return ivBase.anyElement ();
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
removeAt (ICursor& cursor)
{ ivBase.removeAt (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline INumber IWSrtSetOnKSSet < Element, ElementOps, Base >::
removeAll (IBoolean (*predicate) (Element const&, void*), void* env)
{ return ivBase.removeAll (predicate, env);
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
replaceAt (ICursor const& cursor, Element const& element)
{ ivBase.replaceAt (baseCursor (cursor), element);
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
removeAll ()
{ ivBase.removeAll ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
isBounded () const
{ return ivBase.isBounded ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWSrtSetOnKSSet < Element, ElementOps, Base >::
maxNumberOfElements () const
{ return ivBase.maxNumberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline INumber IWSrtSetOnKSSet < Element, ElementOps, Base >::
numberOfElements () const
{ return ivBase.numberOfElements ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
isEmpty () const
{ return ivBase.isEmpty ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
isFull () const
{ return ivBase.isFull ();
}

template < class Element, class ElementOps, class Base >
inline IWSrtSetOnKSSetCursor < Element, ElementOps, Base >*
IWSrtSetOnKSSet < Element, ElementOps, Base >::
newCursor () const
{ Cursor* result = new Cursor (*this);
  ICHECK (result != 0,
          IOutOfCollectionMemory, IOutOfCollectionMemoryText)
  return result;
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
setToFirst (ICursor &cursor) const
{ return ivBase.setToFirst (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
setToNext (ICursor &cursor) const
{ return ivBase.setToNext (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element &, void*),
               void* environment)
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IIterator <Element>& iterator)
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IBoolean (*iterationFunction) (Element const&, void*),
               void* environment) const
{ return ivBase.allElementsDo (iterationFunction, environment);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
allElementsDo (IConstantIterator <Element>& iterator) const
{ return ivBase.allElementsDo (iterator);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
isConsistent () const
{ return ivBase.isConsistent ();
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
contains (Element const& element) const
{ return ivBase.containsElementWithKey (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
containsAllFrom (IWSrtSetOnKSSet
                  < Element, ElementOps, Base > const& collection) const
{ return ivBase.containsAllKeysFrom (collection.ivBase);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
locate (Element const& element, ICursor &cursor) const
{ return ivBase.locateElementWithKey (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
locateNext (Element const& element, ICursor &cursor) const
{ return ivBase.locateNextElementWithKey (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
locateOrAdd (Element const& element)
{ return ivBase.locateOrAddElementWithKey (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
locateOrAdd (Element const& element, ICursor &cursor)
{ return ivBase.locateOrAddElementWithKey
           (element, baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
remove (Element const& element)
{ return ivBase.removeElementWithKey (element);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
operator== (IWSrtSetOnKSSet
              < Element, ElementOps, Base > const& collection) const
{ return numberOfElements() == collection.numberOfElements() &&
         containsAllFrom (collection);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
operator!= (IWSrtSetOnKSSet
              < Element, ElementOps, Base > const& collection) const
{ return ! operator== (collection);
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
unionWith (IWSrtSetOnKSSet < Element,
                             ElementOps, Base > const& collection)
{ if (this != &collection)
    addAllFrom (collection);
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
intersectionWith (IWSrtSetOnKSSet
                    < Element, ElementOps, Base > const& collection)
{ if (this != &collection)
  { IWSrtSetOnKSSet < Element,
                      ElementOps, Base > const* env = &collection;
    removeAll (isNotContained, &env);
  }
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
differenceWith (IWSrtSetOnKSSet < Element,
                                  ElementOps, Base > const& collection)
{ if (this == &collection)
    removeAll ();
  else
  { IWSrtSetOnKSSet < Element,
                      ElementOps, Base > const* env = &collection;
    removeAll (isContained, &env);
  }
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
addUnion (IWSrtSetOnKSSet < Element,
                            ElementOps, Base > const& collection1,
          IWSrtSetOnKSSet < Element,
                            ElementOps, Base > const& collection2)
{ unionWith (collection1);
  unionWith (collection2);
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
addIntersection (IWSrtSetOnKSSet
                  < Element, ElementOps, Base > const& collection1,
                 IWSrtSetOnKSSet
                  < Element, ElementOps, Base > const& collection2)
{ if (this == &collection1 || this == &collection2)
    return;
  Cursor cursor (collection1);
  forCursor (cursor) {
    if (collection2.contains (collection1.elementAt (cursor)))
      add (collection1.elementAt (cursor));
  }
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
addDifference (IWSrtSetOnKSSet < Element,
                                 ElementOps, Base > const& collection1,
               IWSrtSetOnKSSet < Element,
                                 ElementOps, Base > const& collection2)
{ if (this == &collection1)
    return;
  else if (this == &collection2)
    unionWith (collection1);
  else {
    Cursor cursor (collection1);
    forCursor (cursor) {
      if (! collection2.contains (collection1.elementAt (cursor)))
        add (collection1.elementAt (cursor));
    }
  }
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
removeFirst ()
{ ivBase.removeFirst ();
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
removeLast ()
{ ivBase.removeLast ();
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
removeAtPosition (IPosition position)
{ ivBase.removeAtPosition (position);
}

template < class Element, class ElementOps, class Base >
inline Element const& IWSrtSetOnKSSet < Element, ElementOps, Base >::
firstElement () const
{ return ivBase.firstElement ();
}

template < class Element, class ElementOps, class Base >
inline Element const& IWSrtSetOnKSSet < Element, ElementOps, Base >::
lastElement () const
{ return ivBase.lastElement ();
}

template < class Element, class ElementOps, class Base >
inline Element const& IWSrtSetOnKSSet < Element, ElementOps, Base >::
elementAtPosition (IPosition position) const
{ return ivBase.elementAtPosition (position);
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
setToLast (ICursor &cursor) const
{ return ivBase.setToLast (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
setToPrevious (ICursor &cursor) const
{ return ivBase.setToPrevious (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline void IWSrtSetOnKSSet < Element, ElementOps, Base >::
setToPosition (IPosition position, ICursor &cursor) const
{ ivBase.setToPosition (position, baseCursor (cursor));
}

#ifndef __BIN_COMPAT_BASE_43__
template < class Element, class ElementOps, class Base >
inline IPosition IWSrtSetOnKSSet < Element, ElementOps, Base >::
position (ICursor const& cursor) const
{ return ivBase.position (baseCursor (cursor));
}
#endif

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
isFirst (ICursor const& cursor) const
{ return ivBase.isFirst (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline IBoolean IWSrtSetOnKSSet < Element, ElementOps, Base >::
isLast (ICursor const& cursor) const
{ return ivBase.isLast (baseCursor (cursor));
}

template < class Element, class ElementOps, class Base >
inline long IWSrtSetOnKSSet < Element, ElementOps, Base >::
compare (IWSrtSetOnKSSet < Element,
                           ElementOps, Base > const& collection,
         long (*comparisonFunction)
           (Element const&, Element const&)) const
{ return ivBase.compare (collection.ivBase, comparisonFunction);
}
