/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _ISTKSEQ_H
#define _ISTKSEQ_H

#include <iglobals.h>
#include <icursor.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#ifdef ICL_NO_INLINE
#define inline
#endif

template < class Element, class ElementOps, class Base >
class IWStackOnSeq;

template < class Element, class ElementOps, class Base >
class IWStackOnSeqCursor :
  public Base::Cursor
{
public:

           IWStackOnSeqCursor
                      (IWStackOnSeq
                        < Element, ElementOps, Base > const& c)
         : Base::Cursor (c.ivBase)
         {
         }

};

template < class Element, class ElementOps, class Base >
class IWStackOnSeq {
protected:

  Base ivBase;

public:


  typedef IWStackOnSeqCursor < Element, ElementOps, Base > Cursor;

  inline   IWStackOnSeq     (INumber numberOfElements = 100);

  inline   IWStackOnSeq     (IWStackOnSeq < Element,
                                            ElementOps, Base > const&);

  inline  ~IWStackOnSeq             ();

  inline
  IBoolean add              (Element const&);

  inline
  IBoolean add              (Element const&, ICursor&);

  inline
  void     addAllFrom       (IWStackOnSeq < Element,
                                            ElementOps, Base > const&);

  inline
  void     addAsLast        (Element const&);

  inline
  void     addAsLast        (Element const&, ICursor&);

  inline
  IBoolean allElementsDo    (IBoolean (*function)
                              (Element const&, void*),
                             void* additionalArgument = 0) const;

  inline
  IBoolean allElementsDo    (IConstantIterator <Element>&) const;

  inline
  Element const&
           anyElement       () const;

  inline
  long     compare          (IWStackOnSeq < Element,
                                            ElementOps, Base > const&,
                             long (*comparisonFunction)
                              (Element const&, Element const&)) const;

  inline
  Element const&
           elementAt        (ICursor const&) const;

  inline
  Element const&
           elementAtPosition (IPosition) const;

  inline
  Element const&
           firstElement     () const;

  inline
  IBoolean isBounded        () const;

  inline
  IBoolean isEmpty          () const;

  inline
  IBoolean isFirst          (ICursor const&) const;

  inline
  IBoolean isLast           (ICursor const&) const;

  inline
  IBoolean isFull           () const;

  inline
  Element const&
           lastElement      () const;

  inline
  INumber  maxNumberOfElements () const;

  inline
  Cursor*  newCursor        () const;

  inline
  INumber  numberOfElements () const;

  inline
  IWStackOnSeq < Element, ElementOps, Base >&
           operator =       (IWStackOnSeq < Element,
                                            ElementOps, Base > const&);

  inline
  void     pop              ();

  inline
  void     pop              (Element&);

  inline
  void     push             (Element const&);

  inline
  void     push             (Element const&, ICursor&);

  inline
  void     removeAll        ();

  inline
  void     removeLast       ();

  inline
  IBoolean setToFirst       (ICursor&) const;

  inline
  IBoolean setToLast        (ICursor&) const;

  inline
  IBoolean setToNext        (ICursor&) const;

  inline
  void     setToPosition    (IPosition, ICursor&) const;

#ifndef __BIN_COMPAT_BASE_43__
  inline
  IPosition     position    (ICursor const&) const;
#endif

  inline
  IBoolean setToPrevious    (ICursor&) const;

  inline
  Element const&
           top              () const;

  friend class IWStackOnSeqCursor < Element, ElementOps, Base >;

  inline
  IBoolean isConsistent     () const;

protected:

  // used for cfront support:
  inline
  IOrderedCursor < Element >&
            baseCursor (ICursor&) const;

  inline
  IOrderedCursor < Element > const&
            baseCursor (ICursor const&) const;

};


#define IDefineGStackOnGSequence(GSeq, GStack) \
template < class Element, class ElementOps > \
class GStack : \
  public IWStackOnSeq \
           < Element, ElementOps, GSeq < Element, ElementOps > > { \
public: \
  GStack (INumber n = 100) : \
    IWStackOnSeq < Element, ElementOps, \
                   GSeq < Element, ElementOps > > (n) {} \
};



#ifdef ICL_NO_INLINE
#undef inline
#else
#include <istkseq.inl>
#endif

#ifndef __TEMPINC__
#include <istkseq.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
