/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/

#ifndef _ITCURSOR_H
#define _ITCURSOR_H

#include <iglobals.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

class ITreeCursor {
public:

  virtual
          ~ITreeCursor ();

  virtual
  IBoolean setToChild (IPosition) = 0;

  virtual
  IBoolean setToParent () = 0;

  virtual
  IBoolean setToRoot () = 0;

  virtual
  IBoolean setToFirstExistingChild () = 0;

  virtual
  IBoolean setToLastExistingChild () = 0;

  virtual
  IBoolean setToNextExistingChild () = 0;

  virtual
  IBoolean setToPreviousExistingChild  () = 0;

  virtual
  IBoolean isValid () const = 0;

  virtual
  void     invalidate () = 0;

  virtual
  IBoolean operator == (ITreeCursor const&) const = 0;

  IBoolean operator != (ITreeCursor const& cursor) const
           { return ! operator== (cursor);
           }
};

template < class Element >
class IElementTreeCursor : public ITreeCursor {
public:

  virtual
  Element const&
           element () const = 0;

};

#pragma info (restore)
#pragma pack ()

#endif
