#ifndef _ITHREAD_INL_
#define _ITHREAD_INL_ 0
/*******************************************************************************
* FILE NAME: ithread.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ithread.hpp.                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1995       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#ifndef _ITHREAD_
  #undef  _ITHREAD_INL_
  #define _ITHREAD_INL_ 1
  #include <ithread.hpp>
#endif

#if _ITHREAD_INL_
  #define inline
#endif

#ifndef IC_MOTIF_FLAGNOP
inline unsigned long IThread :: defaultStackSize ( )
  {
  return IThread::dfltStackSize;
  }
#endif  // IC_MOTIF_FLAGNOP

#ifndef IC_MOTIF_FLAGNOP
inline void IThread :: setDefaultStackSize ( unsigned long newStkSize )
  {
  IThread::dfltStackSize = newStkSize;
  }
#endif  // IC_MOTIF_FLAGNOP

inline void IThread :: setDefaultAutoInitGUI ( Boolean newFlag )
  {
  IThread::dfltAutoInitGUI = newFlag;
  }

#ifndef IC_MOTIF_FLAGNOP
inline long IThread :: defaultQueueSize ( )
  {
  return IThread::dfltQueueSize;
  }
#endif  // IC_MOTIF_FLAGNOP

#ifndef IC_MOTIF_FLAGNOP
inline void IThread :: setDefaultQueueSize ( long newQSize )
  {
  IThread::dfltQueueSize = newQSize;
  }
#endif  // IC_MOTIF_FLAGNOP
#endif // _ITHREAD_INL_
