/********************************************************************************/
/* File:  itk_arry.hpp                                                          */
/* Class: ITypeCodeArray                                                        */
/*                                                                              */
/* Type code for array                                                          */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_ARRY_HPP_
#define _ITK_ARRY_HPP_

#include "itypecod.hpp"
#include <istring.hpp>
#include "dax.hpp"


class EXPORT ITypeCodeArray : public ITypeCode
{

public:

/*------------------------- Constructors ---------------------------------------
| There is 1 way to construct instances of this class.                         |
| parms:                                                                       |
|  pArrayElementTypeI - type of element in array                               |
|  lMaxNumElements  -  max number of array elemenst                            |
|                                                                              |
|    Example of Construction:                                                  |
| ITypeCodeString *pStr = new ITypeCodeString(100);                            |
| ITypeCodeArray  *pArray  = new ITypeCodeArray (pStr,100);                    |
------------------------------------------------------------------------------*/
  ITypeCodeArray (const ITypeCode *pArrayElementTypeI, long lMaxNumElements);
  virtual ~ITypeCodeArray ( );

  // compare 2 typecodes
  Boolean
    operator == (const ITypeCode &a ) const;

  // returns the type of what typecode describes
  TCKind
    kind() const;

  ITypeCodeArray*
    duplicate() const;

  // returns the number of parameters that make up the receiving typecode
  long
    paramCount() const;

  // returns the indexed parameter from the receiving typecode. Index starts at 0.
  IAny
    parameter (long index) const;

private:
  ITypeCodeArray ( const ITypeCodeArray &typeCodeArray );

  ITypeCode *pArrayElementType;
  long lMaxNumberOfElements;

};


#ifndef _ITK_ARRY_INL_
#include "itk_arry.inl"
#endif

#endif
