/********************************************************************************/
/* File:  itk_arry.inl                                                          */
/* Class: ITypeCodeArray                                                        */
/*                                                                              */
/* Type code for array                                                          */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_ARRY_INL_
#define _ITK_ARRY_INL_

#include <iexcbase.hpp>
#ifndef _ITK_ARRY_HPP_
#include "itk_arry.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeArray::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_array);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeArray::kind () const
{
  return tk_array;
}

/********************************************************************************/
/* paramCount                                                                   */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline long
ITypeCodeArray::paramCount() const
{
  return 2;
}


/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeArray*
ITypeCodeArray::duplicate() const
{
   IString strError;
   ITypeCodeArray *pRet = 0;
   if(!(pRet = new ITypeCodeArray(*this)))    // create typecode array
     {
      strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
      IOutOfMemory exc(strError);
      exc.setErrorId(1);
      ITHROW(exc);
     }
  return pRet;
}



#endif
