/********************************************************************************/
/* File:  itk_bool.inl                                                          */
/* Class: ITypeCodeBoolean                                                      */
/*                                                                              */
/* Type code for float value.                                                   */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_BOOL_INL_
#define _ITK_BOOL_INL_

#include <iexcbase.hpp>

#ifndef _ITK_BOOL_HPP_
#include "itk_bool.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeBoolean::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_boolean);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeBoolean::kind () const
{
  return tk_boolean;
}

/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeBoolean*
ITypeCodeBoolean::duplicate () const
{
  IString strError;
  ITypeCodeBoolean *pRet = 0;
  if(!(pRet = new ITypeCodeBoolean))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}


#endif
