/********************************************************************************/
/* File:  itk_doub.inl                                                          */
/* Class: ITypeCodeDouble                                                       */
/*                                                                              */
/* Type code for float value.                                                   */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_DOUB_INL_
#define _ITK_DOUB_INL_

#include <iexcbase.hpp>

#ifndef _ITK_DOUB_HPP_
#include "itk_doub.hpp"
#endif


/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeDouble::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_double);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeDouble::kind () const
{
  return tk_double;
}

/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeDouble*
ITypeCodeDouble::duplicate() const
{
  IString strError;
  ITypeCodeDouble *pRet = 0;
  if(!(pRet = new ITypeCodeDouble))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}


#endif
