/********************************************************************************/
/* File:  itk_enum.hpp                                                          */
/* Class: ITypeCodeEnum                                                         */
/*                                                                              */
/* Type code for enum                                                           */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_ENUM_HPP_
#define _ITK_ENUM_HPP_

#include "itypecod.hpp"
#include <istring.hpp>
#include "dax.hpp"

class PICListElementList;

class EXPORT ITypeCodeEnum : public ITypeCode
{

public:

/*------------------------- Constructors ---------------------------------------
| There is 1 way to construct instances of this class.                         |
| parms:                                                                       |
|  strEnumName - enum name                                                     |
|  lNumElements  - number of elements in ...                                   |
|  ...           - IString strMemberName,     enumerator name                  |
|                 the field above is repeated as needed)                       |
|                                                                              |
|    Example of Construction:                                                  |
| ITypeCodeEnum *pEnum = new ITypeCodeEnum("Cust",2,"Name",                    |
|                            "Addr");                                          |
------------------------------------------------------------------------------*/
  ITypeCodeEnum (const IString &strEnumNameI, long lNumElementsI, ... );
  virtual ~ITypeCodeEnum ( );

  // compare 2 typecodes
  Boolean
    operator == (const ITypeCode &a ) const;

  // returns the type of what typecode describes
  TCKind
    kind() const;

  ITypeCodeEnum*
    duplicate() const;

  long
    paramCount() const;

  IAny
    parameter ( long index ) const;

private:
  ITypeCodeEnum ( const ITypeCodeEnum &typeCodeEnum );

  IString strName;
  long lNumElements;
  PICListElementList *p_elements;           // member List

};


#ifndef _ITK_ENUM_INL_
#include "itk_enum.inl"
#endif

#endif
