/********************************************************************************/
/* File:  itk_enum.inl                                                          */
/* Class: ITypeCodeEnum                                                         */
/*                                                                              */
/* Type code for enum                                                           */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_ENUM_INL_
#define _ITK_ENUM_INL_

#include <iexcbase.hpp>

#ifndef _ITK_ENUM_HPP_
#include "itk_enum.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeEnum::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_enum);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeEnum::kind () const
{
  return tk_enum;
}

/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeEnum*
ITypeCodeEnum::duplicate() const
{
   IString strError;
   ITypeCodeEnum *pRet = 0;
   if(!(pRet = new ITypeCodeEnum(*this)))    // create typecode enum
     {
      strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
      IOutOfMemory exc(strError);
      exc.setErrorId(1);
      ITHROW(exc);
     }
  return pRet;
}



#endif
