/********************************************************************************/
/* File:  itk_floa.inl                                                          */
/* Class: ITypeCodeFloat                                                        */
/*                                                                              */
/* Type code for float value.                                                   */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_FLOA_INL_
#define _ITK_FLOA_INL_

#include <iexcbase.hpp>

#ifndef _ITK_FLOA_HPP_
#include "itk_floa.hpp"
#endif


/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeFloat::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_float);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeFloat::kind () const
{
  return tk_float;
}



/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeFloat*
ITypeCodeFloat::duplicate() const
{
  IString strError;
  ITypeCodeFloat *pRet = 0;
  if(!(pRet = new ITypeCodeFloat))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}


#endif
