/********************************************************************************/
/* File:  itk_long.inl                                                          */
/* Class: ITypeCodeLong                                                         */
/*                                                                              */
/* Type code for Long value.                                                    */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_LONG_INL_
#define _ITK_LONG_INL_

#include <iexcbase.hpp>

#include "iany.hpp"

#ifndef _ITK_LONG_HPP_
#include "itk_long.hpp"
#endif


/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeLong::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_long);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeLong::kind () const
{
  return tk_long;
}



/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline  ITypeCodeLong*
ITypeCodeLong::duplicate() const
{
  IString strError;
  ITypeCodeLong *pRet = 0;
  if(!(pRet = new ITypeCodeLong))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}



#endif


