/********************************************************************************/
/* File:  itk_null.inl                                                          */
/* Class: ITypeCodeNull                                                         */
/*                                                                              */
/* Type code for NULL value.                                                    */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_NULL_INL_
#define _ITK_NULL_INL_

#include <iexcbase.hpp>

#ifndef _ITK_NULL_HPP_
#include "itk_null.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeNull::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_null);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeNull::kind () const
{
  return tk_null;
}


/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeNull*
ITypeCodeNull::duplicate() const
{
  IString strError;
  ITypeCodeNull *pRet = 0;
  if(!(pRet = new ITypeCodeNull))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}


#endif
