/********************************************************************************/
/* File:  itk_shor.hpp                                                          */
/* Class: ITypeCodeObjectRef                                                    */
/*                                                                              */
/* This typecode is used to describe pointer to one of the known to the user    */
/* object (e.g. IUserEnvironment, IDatastoreConnection, etc).  Only name of the */
/* object is provided, as the rest must be known.                               */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_OBJR_HPP_
#define _ITK_OBJR_HPP_

#include "itypecod.hpp"
#include <istring.hpp>

class EXPORT ITypeCodeObjectRef : public ITypeCode
{

public:

  ITypeCodeObjectRef( const IString& className );

  // compare 2 typecodes
  Boolean
    operator == (const ITypeCode &a ) const;

  // returns the type of what typecode describes
  TCKind
    kind() const;

  // returns the number of parameters that make up the receiving typecode
  long
    paramCount() const;

  // returns the indexed parameter from the receiving typecode. Index starts at 0.
  IAny
    parameter (long index) const;

  ITypeCodeObjectRef*
    duplicate() const;

private:
  IString _className;

};


#ifndef _ITK_OBJR_INL_
#include "itk_objr.inl"
#endif

#endif
