/********************************************************************************/
/* File:  itk_shor.inl                                                          */
/* Class: ITypeCodeObjectRef                                                    */
/*                                                                              */
/* Type code for NULL value.                                                    */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_OBJR_INL_
#define _ITK_OBJR_INL_

#include <iexcbase.hpp>
#include "iany.hpp"

#ifndef _ITK_OBJR_HPP_
#include "itk_objr.hpp"
#endif

/********************************************************************************/
/* ITypeCodeObjectRef                                                           */
/*                                                                              */
/* constructor                                                                  */
/********************************************************************************/

inline
ITypeCodeObjectRef::ITypeCodeObjectRef(const IString& className)
:_className(className)
{
}

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeObjectRef::operator == ( const ITypeCode& aTypeCode ) const
{
  if (aTypeCode.kind() == tk_objref)
     if (_className==((ITypeCodeObjectRef&)aTypeCode)._className )
       return true;
  return false;
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeObjectRef::kind () const
{
  return tk_objref;
}

/********************************************************************************/
/* paramCount                                                                   */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline long
ITypeCodeObjectRef::paramCount() const
{
  return 1;
}

/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeObjectRef*
ITypeCodeObjectRef::duplicate() const
{
   IString strError;
   ITypeCodeObjectRef *pRet = 0;
   if(!(pRet = new ITypeCodeObjectRef(_className)))    // create typecode stucture
     {
      strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
      IOutOfMemory exc(strError);
      exc.setErrorId(1);
      ITHROW(exc);
     }
  return pRet;
}

#endif
