/********************************************************************************/
/* File:  itk_seq.inl                                                           */
/* Class: ITypeCodeSequence                                                     */
/*                                                                              */
/* Type code for sequence                                                       */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_SEQ_INL_
#define _ITK_SEQ_INL_

#include <iexcbase.hpp>
#ifndef _ITK_SEQ_HPP_
#include "itk_seq.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeSequence::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_sequence);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeSequence::kind () const
{
  return tk_sequence;
}

/********************************************************************************/
/* paramCount                                                                   */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline long
ITypeCodeSequence::paramCount() const
{
  return 2;
}


/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeSequence*
ITypeCodeSequence::duplicate() const
{
   IString strError;
   ITypeCodeSequence *pRet = 0;
   if(!(pRet = new ITypeCodeSequence(*this)))    // create typecode sequence
     {
      strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
      IOutOfMemory exc(strError);
      exc.setErrorId(1);
      ITHROW(exc);
     }
  return pRet;
}



#endif
