/********************************************************************************/
/* File:  itk_shor.inl                                                          */
/* Class: ITypeCodeShort                                                        */
/*                                                                              */
/* Type code for NULL value.                                                    */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_SHOR_INL_
#define _ITK_SHOR_INL_

#include <iexcbase.hpp>

#ifndef _ITK_SHOR_HPP_
#include "itk_shor.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeShort::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_short);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeShort::kind () const
{
  return tk_short;
}

/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeShort*
ITypeCodeShort::duplicate() const
{
  IString strError;
  ITypeCodeShort *pRet = 0;
  if(!(pRet = new ITypeCodeShort))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}

#endif
