/********************************************************************************/
/* File:  itk_str.hpp                                                           */
/* Class: ITypeCodeString                                                       */
/*                                                                              */
/* Type code for String value                                                   */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_STR_HPP_
#define _ITK_STR_HPP_

#include "itypecod.hpp"

class EXPORT ITypeCodeString : public ITypeCode
{

public:

  ITypeCodeString(long maxLength=0);

  // compare 2 typecodes
  Boolean
    operator == (const ITypeCode &a ) const;

  // returns the type of what typecode describes
  TCKind
    kind() const;

  // returns the number of parameters that make up the receiving typecode
  long
    paramCount() const;

  // returns the indexed parameter from the receiving typecode. Index starts at 0.
  IAny
    parameter (long index) const;

  ITypeCodeString*
    duplicate() const;

private:

  long
    _maxLength;


};


#ifndef _ITK_STR_INL_
#include "itk_str.inl"
#endif

#endif
