/********************************************************************************/
/* File:  itk_str.inl                                                           */
/* Class: ITypeCodeString                                                       */
/*                                                                              */
/* Type code for string value.                                                  */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_STR_INL_
#define _ITK_STR_INL_

#ifndef _ITK_STR_HPP_
#include "itk_str.hpp"
#endif



/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeString::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_string);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeString::kind () const
{
  return tk_string;
}

/********************************************************************************/
/* paramCount                                                                   */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline long
ITypeCodeString::paramCount() const
{
  return 1;
}

/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeString*
ITypeCodeString::duplicate() const
{
  IString strError;
  ITypeCodeString *pRet = 0;
  if(!(pRet = new ITypeCodeString(_maxLength)))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}


#endif
