/********************************************************************************/
/* File:  itk_stru.hpp                                                          */
/* Class: ITypeCodeStruct                                                       */
/*                                                                              */
/* Type code for struct                                                         */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_STRU_HPP_
#define _ITK_STRU_HPP_

#include "itypecod.hpp"
#include <istring.hpp>
#include "dax.hpp"

class PICListElementList;

class EXPORT ITypeCodeStruct : public ITypeCode
{

public:

/*------------------------- Constructors ---------------------------------------
| There is 1 way to construct instances of this class.                         |
| parms:                                                                       |
|  strStructName - structure name                                              |
|  lNumElements  - number of elements in ...                                   |
|  ...           - IString strMemberName, ITypeCode *typeCodeMember,           |
|                 these 2 fields are repeated as needed)                       |
|                                                                              |
|    Example of Construction:                                                  |
| ITypeCodeString *pStr = new ITypeCodeString(100);                            |
| ITypeCodeStruct *pStruct = new ITypeCodeStruct("Animal",2,"Name",            |
|                            pStr);                                            |
------------------------------------------------------------------------------*/
  ITypeCodeStruct (const IString &strStructNameI, long lNumElementsI, ... );
  virtual ~ITypeCodeStruct ( );

  // compare 2 typecodes
  Boolean
    operator == (const ITypeCode &a ) const;

  // returns the type of what typecode describes
  TCKind
    kind() const;

  ITypeCodeStruct*
    duplicate() const;

  long
    paramCount() const;

  IAny
    parameter ( long index ) const;

private:
  ITypeCodeStruct ( const ITypeCodeStruct &typeCodeStruct );

  IString strName;
  long lNumElements;
  PICListElementList *p_elements;           // member List

};


#ifndef _ITK_STRU_INL_
#include "itk_stru.inl"
#endif

#endif
