/********************************************************************************/
/* File:  itk_stru.inl                                                          */
/* Class: ITypeCodeStruct                                                       */
/*                                                                              */
/* Type code for struct                                                         */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_STRU_INL_
#define _ITK_STRU_INL_

#include <iexcbase.hpp>

#ifndef _ITK_STRU_HPP_
#include "itk_stru.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeStruct::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_struct);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeStruct::kind () const
{
  return tk_struct;
}



/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeStruct*
ITypeCodeStruct::duplicate() const
{
   IString strError;
   ITypeCodeStruct *pRet = 0;
   if(!(pRet = new ITypeCodeStruct(*this)))    // create typecode stucture
     {
      strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
      IOutOfMemory exc(strError);
      exc.setErrorId(1);
      ITHROW(exc);
     }
  return pRet;
}



#endif
