/********************************************************************************/
/* File:  itk_tyco.inl                                                          */
/* Class: ITypeCodeTypecode                                                     */
/*                                                                              */
/* Type code for Typecode.                                                      */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_TYCO_INL_
#define _ITK_TYCO_INL_

#include <iexcbase.hpp>

#ifndef _ITK_TYCO_HPP_
#include "itk_tyco.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeTypecode::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_typecode);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeTypecode::kind () const
{
  return tk_typecode;
}

/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeTypecode*
ITypeCodeTypecode::duplicate() const
{
  IString strError;
  ITypeCodeTypecode *pRet = 0;
  if(!(pRet = new ITypeCodeTypecode))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}

#endif
