/********************************************************************************/
/* File:  itk_unio.inl                                                          */
/* Class: ITypeCodeUnion                                                        */
/*                                                                              */
/* Type code for union                                                          */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_UNIO_INL_
#define _ITK_UNIO_INL_

#include <iexcbase.hpp>

#ifndef _ITK_UNIO_HPP_
#include "itk_unio.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeUnion::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_union);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeUnion::kind () const
{
  return tk_union;
}



/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeUnion*
ITypeCodeUnion::duplicate() const
{
   IString strError;
   ITypeCodeUnion *pRet = 0;
   if(!(pRet = new ITypeCodeUnion(*this)))
     {
      strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
      IOutOfMemory exc(strError);
      exc.setErrorId(1);
      ITHROW(exc);
     }
  return pRet;
}



#endif
