/********************************************************************************/
/* File:  itk_usho.inl                                                          */
/* Class: ITypeCodeUShort                                                       */
/*                                                                              */
/* Type code for NULL value.                                                    */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITK_USHO_INL_
#define _ITK_USHO_INL_

#include <iexcbase.hpp>

#ifndef _ITK_USHO_HPP_
#include "itk_usho.hpp"
#endif

/********************************************************************************/
/* operator ==                                                                  */
/*                                                                              */
/* comparison with another ITypeCode                                            */
/********************************************************************************/

inline Boolean
ITypeCodeUShort::operator == ( const ITypeCode& aTypeCode ) const
{
  return (aTypeCode.kind() == tk_ushort);
}

/********************************************************************************/
/* kind                                                                         */
/*                                                                              */
/* return the type of what typecode describes                                   */
/********************************************************************************/

inline ITypeCode::TCKind
ITypeCodeUShort::kind () const
{
  return tk_ushort;
}



/********************************************************************************/
/* duplicate                                                                    */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

inline ITypeCodeUShort*
ITypeCodeUShort::duplicate() const
{
  IString strError;
  ITypeCodeUShort *pRet = 0;
  if(!(pRet = new ITypeCodeUShort))
    {
     strError = ClsEnv::daxMsg(CLSMSG_OUTMEM);
     IOutOfMemory exc(strError);
     exc.setErrorId(1);
     ITHROW(exc);
    }
  return pRet;
}


#endif
