/********************************************************************************/
/* File:  itypecod.hpp                                                          */
/* Class: ITypeCode                                                             */
/*                                                                              */
/* Base class for DAX's implementation of TYPECODE                              */
/********************************************************************************/

/******************************************************************************/
/*                                                                            */
/* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                            */
/* (C) Copyright IBM Corp. 1991, 1995.                                        */
/*  - Licensed Material - Program-Property of IBM - All Rights Reserved.      */
/* US Government Users Restricted Rights - Use, duplication or disclosure     */
/* restricted by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                            */
/******************************************************************************/

#ifndef _ITYPECOD_HPP_
#define _ITYPECOD_HPP_

#include <ivbase.hpp>
#include "dax.hpp"
#include "clsenv.hpp"
#include "clsmsg.hpp"

class IAny;

class EXPORT ITypeCode : public IVBase
{

public:

  enum TCKind {tk_null,  tk_void,  tk_short,  tk_long,    tk_ushort, tk_enum,
               tk_ulong, tk_float, tk_double, tk_boolean, tk_char, tk_string,
               tk_typecode, tk_objref, tk_struct, tk_array, tk_sequence, tk_union };

// returns the type of what typecode describes
  virtual TCKind
    kind() const =0 ;

  ITypeCode();

  virtual ~ITypeCode();

// allocates and returns identical typecode.
  virtual ITypeCode*
      duplicate()const=0;

// returns the number of parameters that make up the receiving typecode
  virtual long
    paramCount()const;

// returns the indexed parameter from the receiving typecode. Index starts at 0.

  virtual IAny
    parameter(long index)const;
};

#endif
