/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVBAG_H_
#define _IVBAG_H_

#include <ibag.h>
#include <ibagbst.h>
#include <ibagsls.h>
#include <ibagsts.h>
#include <ibagsds.h>
#include <ibaghks.h>
#include <irbag.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVBagOnBase;

template < class Element, class Base >
class IVBagOnBaseCursor : public Base::Cursor {
  public:
    IVBagOnBaseCursor (IVBagOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVBagOnBase : public IRBag < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVBagOnBaseCursor < Element, Base >;

public:

  typedef IVBagOnBaseCursor < Element, Base > Cursor;

            IVBagOnBase (INumber n = 100)
            : ivBase (n), IRBag < Element, Base > (base ())
            {
            }

            IVBagOnBase (IVBagOnBase < Element, Base > const& c)
            : IRBag < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVBagOnBase < Element, Base >&
               operator= (IVBagOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGBag : public IVBagOnBase < Element, IGBag < Element, ElementOps > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBag < Element, ElementOps > > Cursor;

            IVGBag (INumber n = 100)
            : IVBagOnBase < Element, IGBag < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVBag : public IVGBag < Element, IECOps < Element > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBag < Element, IECOps < Element > > > Cursor;

            IVBag (INumber n = 100)
            : IVGBag < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGBagOnBSTKeySortedSet : public IVBagOnBase < Element, IGBagOnBSTKeySortedSet < Element, ElementOps > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnBSTKeySortedSet < Element, ElementOps > > Cursor;

            IVGBagOnBSTKeySortedSet (INumber n = 100)
            : IVBagOnBase < Element, IGBagOnBSTKeySortedSet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVBagOnBSTKeySortedSet : public IVGBagOnBSTKeySortedSet < Element, IECOps < Element > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnBSTKeySortedSet < Element, IECOps < Element > > > Cursor;

            IVBagOnBSTKeySortedSet (INumber n = 100)
            : IVGBagOnBSTKeySortedSet < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGBagOnSortedLinkedSequence : public IVBagOnBase < Element, IGBagOnSortedLinkedSequence < Element, ElementOps > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnSortedLinkedSequence < Element, ElementOps > > Cursor;

            IVGBagOnSortedLinkedSequence (INumber n = 100)
            : IVBagOnBase < Element, IGBagOnSortedLinkedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVBagOnSortedLinkedSequence : public IVGBagOnSortedLinkedSequence < Element, IECOps < Element > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnSortedLinkedSequence < Element, IECOps < Element > > > Cursor;

            IVBagOnSortedLinkedSequence (INumber n = 100)
            : IVGBagOnSortedLinkedSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGBagOnSortedTabularSequence : public IVBagOnBase < Element, IGBagOnSortedTabularSequence < Element, ElementOps > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnSortedTabularSequence < Element, ElementOps > > Cursor;

            IVGBagOnSortedTabularSequence (INumber n = 100)
            : IVBagOnBase < Element, IGBagOnSortedTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVBagOnSortedTabularSequence : public IVGBagOnSortedTabularSequence < Element, IECOps < Element > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnSortedTabularSequence < Element, IECOps < Element > > > Cursor;

            IVBagOnSortedTabularSequence (INumber n = 100)
            : IVGBagOnSortedTabularSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGBagOnSortedDilutedSequence : public IVBagOnBase < Element, IGBagOnSortedDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnSortedDilutedSequence < Element, ElementOps > > Cursor;

            IVGBagOnSortedDilutedSequence (INumber n = 100)
            : IVBagOnBase < Element, IGBagOnSortedDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVBagOnSortedDilutedSequence : public IVGBagOnSortedDilutedSequence < Element, IECOps < Element > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnSortedDilutedSequence < Element, IECOps < Element > > > Cursor;

            IVBagOnSortedDilutedSequence (INumber n = 100)
            : IVGBagOnSortedDilutedSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGBagOnHashKeySet : public IVBagOnBase < Element, IGBagOnHashKeySet < Element, ElementOps > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnHashKeySet < Element, ElementOps > > Cursor;

            IVGBagOnHashKeySet (INumber n = 100)
            : IVBagOnBase < Element, IGBagOnHashKeySet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVBagOnHashKeySet : public IVGBagOnHashKeySet < Element, IEHOps < Element > >
{
public:

  typedef IVBagOnBaseCursor < Element, IGBagOnHashKeySet < Element, IEHOps < Element > > > Cursor;

            IVBagOnHashKeySet (INumber n = 100)
            : IVGBagOnHashKeySet < Element, IEHOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

