/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVDEQUE_H_
#define _IVDEQUE_H_

#include <ideque.h>
#include <idquts.h>
#include <idquds.h>
#include <irdeque.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVDequeOnBase;

template < class Element, class Base >
class IVDequeOnBaseCursor : public Base::Cursor {
  public:
    IVDequeOnBaseCursor (IVDequeOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVDequeOnBase : public IRDeque < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVDequeOnBaseCursor < Element, Base >;

public:

  typedef IVDequeOnBaseCursor < Element, Base > Cursor;

            IVDequeOnBase (INumber n = 100)
            : ivBase (n), IRDeque < Element, Base > (base ())
            {
            }

            IVDequeOnBase (IVDequeOnBase < Element, Base > const& c)
            : IRDeque < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }
            IVDequeOnBase < Element, Base >&
               operator= (IVDequeOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGDeque : public IVDequeOnBase < Element, IGDeque < Element, ElementOps > >
{
public:

  typedef IVDequeOnBaseCursor < Element, IGDeque < Element, ElementOps > > Cursor;

            IVGDeque (INumber n = 100)
            : IVDequeOnBase < Element, IGDeque < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVDeque : public IVGDeque < Element, IStdOps < Element > >
{
public:

  typedef IVDequeOnBaseCursor < Element, IGDeque < Element, IStdOps < Element > > > Cursor;

            IVDeque (INumber n = 100)
            : IVGDeque < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGDequeOnTabularSequence : public IVDequeOnBase < Element, IGDequeOnTabularSequence < Element, ElementOps > >
{
public:

  typedef IVDequeOnBaseCursor < Element, IGDequeOnTabularSequence < Element, ElementOps > > Cursor;

            IVGDequeOnTabularSequence (INumber n = 100)
            : IVDequeOnBase < Element, IGDequeOnTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVDequeOnTabularSequence : public IVGDequeOnTabularSequence < Element, IStdOps < Element > >
{
public:

  typedef IVDequeOnBaseCursor < Element, IGDequeOnTabularSequence < Element, IStdOps < Element > > > Cursor;

            IVDequeOnTabularSequence (INumber n = 100)
            : IVGDequeOnTabularSequence < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGDequeOnDilutedSequence : public IVDequeOnBase < Element, IGDequeOnDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVDequeOnBaseCursor < Element, IGDequeOnDilutedSequence < Element, ElementOps > > Cursor;

            IVGDequeOnDilutedSequence (INumber n = 100)
            : IVDequeOnBase < Element, IGDequeOnDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVDequeOnDilutedSequence : public IVGDequeOnDilutedSequence < Element, IStdOps < Element > >
{
public:

  typedef IVDequeOnBaseCursor < Element, IGDequeOnDilutedSequence < Element, IStdOps < Element > > > Cursor;

            IVDequeOnDilutedSequence (INumber n = 100)
            : IVGDequeOnDilutedSequence < Element, IStdOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

