/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVEQSEQ_H_
#define _IVEQSEQ_H_

#include <ireqseq.h>
#include <ieqseq.h>
#include <ieqts.h>
#include <ieqds.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVEqualitySequenceOnBase;

template < class Element, class Base >
class IVEqualitySequenceOnBaseCursor : public Base::Cursor {
  public:
    IVEqualitySequenceOnBaseCursor (IVEqualitySequenceOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVEqualitySequenceOnBase : public IREqualitySequence < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVEqualitySequenceOnBaseCursor < Element, Base >;

public:

  typedef IVEqualitySequenceOnBaseCursor < Element, Base > Cursor;

            IVEqualitySequenceOnBase (INumber n = 100)
            : ivBase (n), IREqualitySequence < Element, Base > (base ())
            {
            }

            IVEqualitySequenceOnBase (IVEqualitySequenceOnBase < Element, Base > const& c)
            : IREqualitySequence < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVEqualitySequenceOnBase < Element, Base >&
               operator= (IVEqualitySequenceOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGEqualitySequence : public IVEqualitySequenceOnBase < Element, IGEqualitySequence < Element, ElementOps > >
{
public:

  typedef IVEqualitySequenceOnBaseCursor < Element, IGEqualitySequence < Element, ElementOps > > Cursor;

            IVGEqualitySequence (INumber n = 100)
            : IVEqualitySequenceOnBase < Element, IGEqualitySequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVEqualitySequence : public IVGEqualitySequence < Element, IEOps < Element > >
{
public:

  typedef IVEqualitySequenceOnBaseCursor < Element, IGEqualitySequence < Element, IEOps < Element > > > Cursor;

            IVEqualitySequence (INumber n = 100)
            : IVGEqualitySequence < Element, IEOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGEqualitySequenceOnTabularSequence : public IVEqualitySequenceOnBase < Element, IGEqualitySequenceOnTabularSequence < Element, ElementOps > >
{
public:

  typedef IVEqualitySequenceOnBaseCursor < Element, IGEqualitySequenceOnTabularSequence < Element, ElementOps > > Cursor;

            IVGEqualitySequenceOnTabularSequence (INumber n = 100)
            : IVEqualitySequenceOnBase < Element, IGEqualitySequenceOnTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVEqualitySequenceOnTabularSequence : public IVGEqualitySequenceOnTabularSequence < Element, IEOps < Element > >
{
public:

  typedef IVEqualitySequenceOnBaseCursor < Element, IGEqualitySequenceOnTabularSequence < Element, IEOps < Element > > > Cursor;

            IVEqualitySequenceOnTabularSequence (INumber n = 100)
            : IVGEqualitySequenceOnTabularSequence < Element, IEOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGEqualitySequenceOnDilutedSequence : public IVEqualitySequenceOnBase < Element, IGEqualitySequenceOnDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVEqualitySequenceOnBaseCursor < Element, IGEqualitySequenceOnDilutedSequence < Element, ElementOps > > Cursor;

            IVGEqualitySequenceOnDilutedSequence (INumber n = 100)
            : IVEqualitySequenceOnBase < Element, IGEqualitySequenceOnDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVEqualitySequenceOnDilutedSequence : public IVGEqualitySequenceOnDilutedSequence < Element, IEOps < Element > >
{
public:

  typedef IVEqualitySequenceOnBaseCursor < Element, IGEqualitySequenceOnDilutedSequence < Element, IEOps < Element > > > Cursor;

            IVEqualitySequenceOnDilutedSequence (INumber n = 100)
            : IVGEqualitySequenceOnDilutedSequence < Element, IEOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

