/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVHEAP_H_
#define _IVHEAP_H_

#include <iheap.h>
#include <iheapts.h>
#include <iheapds.h>
#include <irheap.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVHeapOnBase;

template < class Element, class Base >
class IVHeapOnBaseCursor : public Base::Cursor {
  public:
    IVHeapOnBaseCursor (IVHeapOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVHeapOnBase : public IRHeap < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVHeapOnBaseCursor < Element, Base >;

public:

  typedef IVHeapOnBaseCursor < Element, Base > Cursor;

            IVHeapOnBase (INumber n = 100)
            : ivBase (n), IRHeap < Element, Base > (base ())
            {
            }

            IVHeapOnBase (IVHeapOnBase < Element, Base > const& c)
            : IRHeap < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }
            IVHeapOnBase < Element, Base >&
               operator= (IVHeapOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGHeap : public IVHeapOnBase < Element, IGHeap < Element, ElementOps > >
{
public:

  typedef IVHeapOnBaseCursor < Element, IGHeap < Element, ElementOps > > Cursor;

            IVGHeap (INumber n = 100)
            : IVHeapOnBase < Element, IGHeap < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVHeap : public IVGHeap < Element, IStdOps < Element > >
{
public:

  typedef IVHeapOnBaseCursor < Element, IGHeap < Element, IStdOps < Element > > > Cursor;

            IVHeap (INumber n = 100)
            : IVGHeap < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGHeapOnTabularSequence : public IVHeapOnBase < Element, IGHeapOnTabularSequence < Element, ElementOps > >
{
public:

  typedef IVHeapOnBaseCursor < Element, IGHeapOnTabularSequence < Element, ElementOps > > Cursor;

            IVGHeapOnTabularSequence (INumber n = 100)
            : IVHeapOnBase < Element, IGHeapOnTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVHeapOnTabularSequence : public IVGHeapOnTabularSequence < Element, IStdOps < Element > >
{
public:

  typedef IVHeapOnBaseCursor < Element, IGHeapOnTabularSequence < Element, IStdOps < Element > > > Cursor;

            IVHeapOnTabularSequence (INumber n = 100)
            : IVGHeapOnTabularSequence < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGHeapOnDilutedSequence : public IVHeapOnBase < Element, IGHeapOnDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVHeapOnBaseCursor < Element, IGHeapOnDilutedSequence < Element, ElementOps > > Cursor;

            IVGHeapOnDilutedSequence (INumber n = 100)
            : IVHeapOnBase < Element, IGHeapOnDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVHeapOnDilutedSequence : public IVGHeapOnDilutedSequence < Element, IStdOps < Element > >
{
public:

  typedef IVHeapOnBaseCursor < Element, IGHeapOnDilutedSequence < Element, IStdOps < Element > > > Cursor;

            IVHeapOnDilutedSequence (INumber n = 100)
            : IVGHeapOnDilutedSequence < Element, IStdOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

