/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVKEYBAG_H_
#define _IVKEYBAG_H_

#include <ikeybag.h>
#include <ihshkb.h>
#include <irkeybag.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVKeyBagOnBase;

template < class Element, class Key, class Base >
class IVKeyBagOnBaseCursor : public Base::Cursor {
  public:
    IVKeyBagOnBaseCursor (IVKeyBagOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVKeyBagOnBase : public IRKeyBag < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVKeyBagOnBaseCursor < Element, Key, Base >;

public:

  typedef IVKeyBagOnBaseCursor < Element, Key, Base > Cursor;

            IVKeyBagOnBase (INumber n = 100)
            : ivBase (n), IRKeyBag < Element, Key, Base > (base ())
            {
            }

            IVKeyBagOnBase (IVKeyBagOnBase < Element, Key, Base > const& c)
            : IRKeyBag < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }
            IVKeyBagOnBase < Element, Key, Base >&
               operator= (IVKeyBagOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeyBag : public IVKeyBagOnBase < Element, Key, IGKeyBag < Element, Key, ElementOps > >
{
public:

  typedef IVKeyBagOnBaseCursor < Element, Key, IGKeyBag < Element, Key, ElementOps > > Cursor;

            IVGKeyBag (INumber n = 100)
            : IVKeyBagOnBase < Element, Key, IGKeyBag < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeyBag : public IVGKeyBag < Element, Key, IKEHOps < Element , Key> >
{
public:

  typedef IVKeyBagOnBaseCursor < Element, Key, IGKeyBag < Element, Key, IKEHOps < Element , Key > > > Cursor;

            IVKeyBag (INumber n = 100)
            : IVGKeyBag < Element, Key, IKEHOps < Element , Key> > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGHashKeyBag : public IVKeyBagOnBase < Element, Key, IGHashKeyBag < Element, Key, ElementOps > >
{
public:

  typedef IVKeyBagOnBaseCursor < Element, Key, IGHashKeyBag < Element, Key, ElementOps > > Cursor;

            IVGHashKeyBag (INumber n = 100)
            : IVKeyBagOnBase < Element, Key, IGHashKeyBag < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVHashKeyBag : public IVGHashKeyBag < Element, Key, IKEHOps < Element , Key > >
{
public:

  typedef IVKeyBagOnBaseCursor < Element, Key, IGHashKeyBag < Element, Key, IKEHOps < Element , Key > > > Cursor;

            IVHashKeyBag (INumber n = 100)
            : IVGHashKeyBag < Element, Key, IKEHOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

