/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVKEYSET_H_
#define _IVKEYSET_H_

#include <ikeyset.h>
#include <iksbst.h>
#include <ihshks.h>
#include <ikssls.h>
#include <ikssts.h>
#include <ikssds.h>
#include <irkeyset.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVKeySetOnBase;

template < class Element, class Key, class Base >
class IVKeySetOnBaseCursor : public Base::Cursor {
  public:
    IVKeySetOnBaseCursor (IVKeySetOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVKeySetOnBase : public IRKeySet < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVKeySetOnBaseCursor < Element, Key, Base >;

public:

  typedef IVKeySetOnBaseCursor < Element, Key, Base > Cursor;

            IVKeySetOnBase (INumber n = 100)
            : ivBase (n), IRKeySet < Element, Key, Base > (base ())
            {
            }

            IVKeySetOnBase (IVKeySetOnBase < Element, Key, Base > const& c)
            : IRKeySet < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVKeySetOnBase < Element, Key, Base >&
               operator= (IVKeySetOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySet : public IVKeySetOnBase < Element, Key, IGKeySet < Element, Key, ElementOps > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySet < Element, Key, ElementOps > > Cursor;

            IVGKeySet (INumber n = 100)
            : IVKeySetOnBase < Element, Key, IGKeySet < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeySet : public IVGKeySet < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySet < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVKeySet (INumber n = 100)
            : IVGKeySet < Element, Key, IKCOps < Element , Key> > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySetOnBSTKeySortedSet : public IVKeySetOnBase < Element, Key, IGKeySetOnBSTKeySortedSet < Element, Key, ElementOps > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnBSTKeySortedSet < Element, Key, ElementOps > > Cursor;

            IVGKeySetOnBSTKeySortedSet (INumber n = 100)
            : IVKeySetOnBase < Element, Key, IGKeySetOnBSTKeySortedSet < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeySetOnBSTKeySortedSet : public IVGKeySetOnBSTKeySortedSet < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnBSTKeySortedSet < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVKeySetOnBSTKeySortedSet (INumber n = 100)
            : IVGKeySetOnBSTKeySortedSet < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySetOnSortedLinkedSequence : public IVKeySetOnBase < Element, Key, IGKeySetOnSortedLinkedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnSortedLinkedSequence < Element, Key, ElementOps > > Cursor;

            IVGKeySetOnSortedLinkedSequence (INumber n = 100)
            : IVKeySetOnBase < Element, Key, IGKeySetOnSortedLinkedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeySetOnSortedLinkedSequence : public IVGKeySetOnSortedLinkedSequence < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnSortedLinkedSequence < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVKeySetOnSortedLinkedSequence (INumber n = 100)
            : IVGKeySetOnSortedLinkedSequence < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySetOnSortedTabularSequence : public IVKeySetOnBase < Element, Key, IGKeySetOnSortedTabularSequence < Element, Key, ElementOps > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnSortedTabularSequence < Element, Key, ElementOps > > Cursor;

            IVGKeySetOnSortedTabularSequence (INumber n = 100)
            : IVKeySetOnBase < Element, Key, IGKeySetOnSortedTabularSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVKeySetOnSortedTabularSequence : public IVGKeySetOnSortedTabularSequence < Element, Key, IKCOps < Element , Key> >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVKeySetOnSortedTabularSequence (INumber n = 100)
            : IVGKeySetOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySetOnSortedDilutedSequence : public IVKeySetOnBase < Element, Key, IGKeySetOnSortedDilutedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnSortedDilutedSequence < Element, Key, ElementOps > > Cursor;

            IVGKeySetOnSortedDilutedSequence (INumber n = 100)
            : IVKeySetOnBase < Element, Key, IGKeySetOnSortedDilutedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeySetOnSortedDilutedSequence : public IVGKeySetOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGKeySetOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key> > > Cursor;

            IVKeySetOnSortedDilutedSequence (INumber n = 100)
            : IVGKeySetOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key> > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGHashKeySet : public IVKeySetOnBase < Element, Key, IGHashKeySet < Element, Key, ElementOps > >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGHashKeySet < Element, Key, ElementOps > > Cursor;

            IVGHashKeySet (INumber n = 100)
            : IVKeySetOnBase < Element, Key, IGHashKeySet < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVHashKeySet : public IVGHashKeySet < Element, Key, IKEHOps < Element , Key> >
{
public:

  typedef IVKeySetOnBaseCursor < Element, Key, IGHashKeySet < Element, Key, IKEHOps < Element , Key > > > Cursor;

            IVHashKeySet (INumber n = 100)
            : IVGHashKeySet < Element, Key, IKEHOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

