/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVKSBAG_H_
#define _IVKSBAG_H_

#include <iksbag.h>
#include <iksbsts.h>
#include <iksbsds.h>
#include <irksbag.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVKeySortedBagOnBase;

template < class Element, class Key, class Base >
class IVKeySortedBagOnBaseCursor : public Base::Cursor {
  public:
    IVKeySortedBagOnBaseCursor (IVKeySortedBagOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVKeySortedBagOnBase : public IRKeySortedBag < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVKeySortedBagOnBaseCursor < Element, Key, Base >;

public:

  typedef IVKeySortedBagOnBaseCursor < Element, Key, Base > Cursor;

            IVKeySortedBagOnBase (INumber n = 100)
            : ivBase (n), IRKeySortedBag < Element, Key, Base > (base ())
            {
            }

            IVKeySortedBagOnBase (IVKeySortedBagOnBase < Element, Key, Base > const& c)
            : IRKeySortedBag < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVKeySortedBagOnBase < Element, Key, Base >&
               operator= (IVKeySortedBagOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySortedBag : public IVKeySortedBagOnBase < Element, Key, IGKeySortedBag < Element, Key, ElementOps > >
{
public:

  typedef IVKeySortedBagOnBaseCursor < Element, Key, IGKeySortedBag < Element, Key, ElementOps > > Cursor;

            IVGKeySortedBag (INumber n = 100)
            : IVKeySortedBagOnBase < Element, Key, IGKeySortedBag < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeySortedBag : public IVGKeySortedBag < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedBagOnBaseCursor < Element, Key, IGKeySortedBag < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVKeySortedBag (INumber n = 100)
            : IVGKeySortedBag < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySortedBagOnSortedTabularSequence : public IVKeySortedBagOnBase < Element, Key, IGKeySortedBagOnSortedTabularSequence < Element, Key, ElementOps > >
{
public:

  typedef IVKeySortedBagOnBaseCursor < Element, Key, IGKeySortedBagOnSortedTabularSequence < Element, Key, ElementOps > > Cursor;

            IVGKeySortedBagOnSortedTabularSequence (INumber n = 100)
            : IVKeySortedBagOnBase < Element, Key, IGKeySortedBagOnSortedTabularSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeySortedBagOnSortedTabularSequence : public IVGKeySortedBagOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedBagOnBaseCursor < Element, Key, IGKeySortedBagOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVKeySortedBagOnSortedTabularSequence (INumber n = 100)
            : IVGKeySortedBagOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySortedBagOnSortedDilutedSequence : public IVKeySortedBagOnBase < Element, Key, IGKeySortedBagOnSortedDilutedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVKeySortedBagOnBaseCursor < Element, Key, IGKeySortedBagOnSortedDilutedSequence < Element, Key, ElementOps > > Cursor;

            IVGKeySortedBagOnSortedDilutedSequence (INumber n = 100)
            : IVKeySortedBagOnBase < Element, Key, IGKeySortedBagOnSortedDilutedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVKeySortedBagOnSortedDilutedSequence : public IVGKeySortedBagOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedBagOnBaseCursor < Element, Key, IGKeySortedBagOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVKeySortedBagOnSortedDilutedSequence (INumber n = 100)
            : IVGKeySortedBagOnSortedDilutedSequence < Element, Key , IKCOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

