/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVKSSET_H_
#define _IVKSSET_H_

#include <irksset.h>
#include <iksset.h>
#include <iavlkss.h>
#include <ibstkss.h>
#include <iksssls.h>
#include <iksssts.h>
#include <iksssds.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVKeySortedSetOnBase;

template < class Element, class Key, class Base >
class IVKeySortedSetOnBaseCursor : public Base::Cursor {
  public:
    IVKeySortedSetOnBaseCursor (IVKeySortedSetOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVKeySortedSetOnBase : public IRKeySortedSet < Element , Key , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVKeySortedSetOnBaseCursor < Element, Key , Base >;

public:

  typedef IVKeySortedSetOnBaseCursor < Element, Key , Base > Cursor;

            IVKeySortedSetOnBase (INumber n = 100)
            : ivBase (n), IRKeySortedSet < Element, Key , Base > (base ())
            {
            }

            IVKeySortedSetOnBase (IVKeySortedSetOnBase < Element, Key , Base > const& c)
            : IRKeySortedSet < Element, Key , Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVKeySortedSetOnBase < Element, Key , Base >&
               operator= (IVKeySortedSetOnBase < Element, Key , Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySortedSet : public IVKeySortedSetOnBase < Element, Key , IGKeySortedSet < Element, Key , ElementOps > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element, Key , IGKeySortedSet < Element, Key , ElementOps > > Cursor;

            IVGKeySortedSet (INumber n = 100)
            : IVKeySortedSetOnBase < Element, Key , IGKeySortedSet < Element, Key , ElementOps > > (n)
            {
            }
};

template < class Element, class Key >
class IVKeySortedSet : public IVGKeySortedSet < Element , Key , IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGKeySortedSet < Element , Key, IKCOps < Element , Key > > > Cursor;

            IVKeySortedSet (INumber n = 100)
            : IVGKeySortedSet < Element , Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGAvlKeySortedSet : public IVKeySortedSetOnBase < Element , Key, IGAvlKeySortedSet < Element , Key, ElementOps > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGAvlKeySortedSet < Element , Key, ElementOps > > Cursor;

            IVGAvlKeySortedSet (INumber n = 100)
            : IVKeySortedSetOnBase < Element , Key, IGAvlKeySortedSet < Element , Key, ElementOps > > (n)
            {
            }
};

template < class Element, class Key >
class IVAvlKeySortedSet : public IVGAvlKeySortedSet < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGAvlKeySortedSet < Element , Key, IKCOps < Element , Key > > > Cursor;

            IVAvlKeySortedSet (INumber n = 100)
            : IVGAvlKeySortedSet < Element , Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGBSTKeySortedSet : public IVKeySortedSetOnBase < Element , Key, IGBSTKeySortedSet < Element , Key, ElementOps > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGBSTKeySortedSet < Element , Key, ElementOps > > Cursor;

            IVGBSTKeySortedSet (INumber n = 100)
            : IVKeySortedSetOnBase < Element , Key, IGBSTKeySortedSet < Element , Key, ElementOps > > (n)
            {
            }
};

template < class Element, class Key >
class IVBSTKeySortedSet : public IVGBSTKeySortedSet < Element , Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGBSTKeySortedSet < Element , Key, IKCOps < Element , Key > > > Cursor;

            IVBSTKeySortedSet (INumber n = 100)
            : IVGBSTKeySortedSet < Element , Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySortedSetOnSortedLinkedSequence : public IVKeySortedSetOnBase < Element, Key, IGKeySortedSetOnSortedLinkedSequence < Element , Key, ElementOps > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGKeySortedSetOnSortedLinkedSequence < Element , Key, ElementOps > > Cursor;

            IVGKeySortedSetOnSortedLinkedSequence (INumber n = 100)
            : IVKeySortedSetOnBase < Element , Key, IGKeySortedSetOnSortedLinkedSequence < Element , Key, ElementOps > > (n)
            {
            }
};

template < class Element, class Key >
class IVKeySortedSetOnSortedLinkedSequence : public IVGKeySortedSetOnSortedLinkedSequence < Element , Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element, Key, IGKeySortedSetOnSortedLinkedSequence < Element , Key, IKCOps < Element , Key > > > Cursor;

            IVKeySortedSetOnSortedLinkedSequence (INumber n = 100)
            : IVGKeySortedSetOnSortedLinkedSequence < Element , Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySortedSetOnSortedTabularSequence : public IVKeySortedSetOnBase < Element , Key, IGKeySortedSetOnSortedTabularSequence < Element , Key, ElementOps > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGKeySortedSetOnSortedTabularSequence < Element , Key, ElementOps > > Cursor;

            IVGKeySortedSetOnSortedTabularSequence (INumber n = 100)
            : IVKeySortedSetOnBase < Element , Key, IGKeySortedSetOnSortedTabularSequence < Element , Key, ElementOps > > (n)
            {
            }
};

template < class Element, class Key >
class IVKeySortedSetOnSortedTabularSequence : public IVGKeySortedSetOnSortedTabularSequence < Element , Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGKeySortedSetOnSortedTabularSequence < Element , Key, IKCOps < Element , Key > > > Cursor;

            IVKeySortedSetOnSortedTabularSequence (INumber n = 100)
            : IVGKeySortedSetOnSortedTabularSequence < Element , Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGKeySortedSetOnSortedDilutedSequence : public IVKeySortedSetOnBase < Element , Key, IGKeySortedSetOnSortedDilutedSequence < Element , Key, ElementOps > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGKeySortedSetOnSortedDilutedSequence < Element , Key, ElementOps > > Cursor;

            IVGKeySortedSetOnSortedDilutedSequence (INumber n = 100)
            : IVKeySortedSetOnBase < Element , Key, IGKeySortedSetOnSortedDilutedSequence < Element , Key, ElementOps > > (n)
            {
            }
};

template < class Element, class Key >
class IVKeySortedSetOnSortedDilutedSequence : public IVGKeySortedSetOnSortedDilutedSequence < Element , Key, IKCOps < Element , Key > >
{
public:

  typedef IVKeySortedSetOnBaseCursor < Element , Key, IGKeySortedSetOnSortedDilutedSequence < Element , Key, IKCOps < Element , Key > > > Cursor;

            IVKeySortedSetOnSortedDilutedSequence (INumber n = 100)
            : IVGKeySortedSetOnSortedDilutedSequence < Element , Key, IKCOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

