/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVMAP_H_
#define _IVMAP_H_

#include <imap.h>
#include <imapbst.h>
#include <imapsls.h>
#include <imapsts.h>
#include <imaphks.h>
#include <imapsds.h>
#include <irmap.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVMapOnBase;

template < class Element, class Key, class Base >
class IVMapOnBaseCursor : public Base::Cursor {
  public:
    IVMapOnBaseCursor (IVMapOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVMapOnBase : public IRMap < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVMapOnBaseCursor < Element, Key, Base >;

public:

  typedef IVMapOnBaseCursor < Element, Key, Base > Cursor;

            IVMapOnBase (INumber n = 100)
            : ivBase (n), IRMap < Element, Key , Base > (base ())
            {
            }

            IVMapOnBase (IVMapOnBase < Element, Key, Base > const& c)
            : IRMap < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }
            IVMapOnBase < Element, Key, Base >&
               operator= (IVMapOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGMap : public IVMapOnBase < Element, Key, IGMap < Element, Key, ElementOps > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMap < Element, Key, ElementOps > > Cursor;

            IVGMap (INumber n = 100)
            : IVMapOnBase < Element, Key, IGMap < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVMap : public IVGMap < Element, Key, IEKCOps < Element , Key> >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMap < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVMap (INumber n = 100)
            : IVGMap < Element, Key, IEKCOps < Element , Key> > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGMapOnBSTKeySortedSet : public IVMapOnBase < Element, Key, IGMapOnBSTKeySortedSet < Element, Key, ElementOps > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnBSTKeySortedSet < Element, Key, ElementOps > > Cursor;

            IVGMapOnBSTKeySortedSet (INumber n = 100)
            : IVMapOnBase < Element, Key, IGMapOnBSTKeySortedSet < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVMapOnBSTKeySortedSet : public IVGMapOnBSTKeySortedSet < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnBSTKeySortedSet < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVMapOnBSTKeySortedSet (INumber n = 100)
            : IVGMapOnBSTKeySortedSet < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGMapOnSortedLinkedSequence : public IVMapOnBase < Element, Key, IGMapOnSortedLinkedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnSortedLinkedSequence < Element, Key, ElementOps > > Cursor;

            IVGMapOnSortedLinkedSequence (INumber n = 100)
            : IVMapOnBase < Element, Key, IGMapOnSortedLinkedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVMapOnSortedLinkedSequence : public IVGMapOnSortedLinkedSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnSortedLinkedSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVMapOnSortedLinkedSequence (INumber n = 100)
            : IVGMapOnSortedLinkedSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGMapOnSortedTabularSequence : public IVMapOnBase < Element, Key, IGMapOnSortedTabularSequence < Element, Key, ElementOps > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnSortedTabularSequence < Element, Key, ElementOps > > Cursor;

            IVGMapOnSortedTabularSequence (INumber n = 100)
            : IVMapOnBase < Element, Key, IGMapOnSortedTabularSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVMapOnSortedTabularSequence : public IVGMapOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVMapOnSortedTabularSequence (INumber n = 100)
            : IVGMapOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGMapOnSortedDilutedSequence : public IVMapOnBase < Element, Key, IGMapOnSortedDilutedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnSortedDilutedSequence < Element, Key, ElementOps > > Cursor;

            IVGMapOnSortedDilutedSequence (INumber n = 100)
            : IVMapOnBase < Element, Key, IGMapOnSortedDilutedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVMapOnSortedDilutedSequence : public IVGMapOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVMapOnSortedDilutedSequence (INumber n = 100)
            : IVGMapOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGMapOnHashKeySet : public IVMapOnBase < Element, Key, IGMapOnHashKeySet < Element, Key, ElementOps > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnHashKeySet < Element, Key, ElementOps > > Cursor;

            IVGMapOnHashKeySet (INumber n = 100)
            : IVMapOnBase < Element, Key, IGMapOnHashKeySet < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key>
class IVMapOnHashKeySet : public IVGMapOnHashKeySet < Element, Key, IEKEHOps < Element , Key > >
{
public:

  typedef IVMapOnBaseCursor < Element, Key, IGMapOnHashKeySet < Element, Key, IEKEHOps < Element , Key > > > Cursor;

            IVMapOnHashKeySet (INumber n = 100)
            : IVGMapOnHashKeySet < Element, Key, IEKEHOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

