/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVPRIOQU_H_
#define _IVPRIOQU_H_

#include <iprioqu.h>
#include <ipqusts.h>
#include <ipqusds.h>
#include <irprioqu.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVPriorityQueueOnBase;

template < class Element, class Key, class Base >
class IVPriorityQueueOnBaseCursor : public Base::Cursor {
  public:
    IVPriorityQueueOnBaseCursor (IVPriorityQueueOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVPriorityQueueOnBase : public IRPriorityQueue < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVPriorityQueueOnBaseCursor < Element, Key, Base >;

public:

  typedef IVPriorityQueueOnBaseCursor < Element, Key, Base > Cursor;

            IVPriorityQueueOnBase (INumber n = 100)
            : ivBase (n), IRPriorityQueue < Element, Key, Base > (base ())
            {
              notifyModified();
            }

            IVPriorityQueueOnBase (IVPriorityQueueOnBase < Element, Key, Base > const& c)
            : IRPriorityQueue < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
            }
            IVPriorityQueueOnBase < Element, Key, Base >&
               operator= (IVPriorityQueueOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGPriorityQueue : public IVPriorityQueueOnBase < Element, Key, IGPriorityQueue < Element, Key, ElementOps > >
{
public:

  typedef IVPriorityQueueOnBaseCursor < Element, Key, IGPriorityQueue < Element, Key, ElementOps > > Cursor;

            IVGPriorityQueue (INumber n = 100)
            : IVPriorityQueueOnBase < Element, Key, IGPriorityQueue < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVPriorityQueue : public IVGPriorityQueue < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVPriorityQueueOnBaseCursor < Element, Key, IGPriorityQueue < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVPriorityQueue (INumber n = 100)
            : IVGPriorityQueue < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGPriorityQueueOnSortedTabularSequence : public IVPriorityQueueOnBase < Element, Key, IGPriorityQueueOnSortedTabularSequence < Element, Key, ElementOps > >
{
public:

  typedef IVPriorityQueueOnBaseCursor < Element, Key, IGPriorityQueueOnSortedTabularSequence < Element, Key, ElementOps > > Cursor;

            IVGPriorityQueueOnSortedTabularSequence (INumber n = 100)
            : IVPriorityQueueOnBase < Element, Key, IGPriorityQueueOnSortedTabularSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVPriorityQueueOnSortedTabularSequence : public IVGPriorityQueueOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVPriorityQueueOnBaseCursor < Element, Key, IGPriorityQueueOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVPriorityQueueOnSortedTabularSequence (INumber n = 100)
            : IVGPriorityQueueOnSortedTabularSequence < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGPriorityQueueOnSortedDilutedSequence : public IVPriorityQueueOnBase < Element, Key, IGPriorityQueueOnSortedDilutedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVPriorityQueueOnBaseCursor < Element, Key, IGPriorityQueueOnSortedDilutedSequence < Element, Key, ElementOps > > Cursor;

            IVGPriorityQueueOnSortedDilutedSequence (INumber n = 100)
            : IVPriorityQueueOnBase < Element, Key, IGPriorityQueueOnSortedDilutedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVPriorityQueueOnSortedDilutedSequence : public IVGPriorityQueueOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key > >
{
public:

  typedef IVPriorityQueueOnBaseCursor < Element, Key, IGPriorityQueueOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key > > > Cursor;

            IVPriorityQueueOnSortedDilutedSequence (INumber n = 100)
            : IVGPriorityQueueOnSortedDilutedSequence < Element, Key, IKCOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

