/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVQUEUE_H_
#define _IVQUEUE_H_

#include <iqueue.h>
#include <iquets.h>
#include <iqueds.h>
#include <irqueue.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVQueueOnBase;

template < class Element, class Base >
class IVQueueOnBaseCursor : public Base::Cursor {
  public:
    IVQueueOnBaseCursor (IVQueueOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVQueueOnBase : public IRQueue < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVQueueOnBaseCursor < Element, Base >;

public:

  typedef IVQueueOnBaseCursor < Element, Base > Cursor;

            IVQueueOnBase (INumber n = 100)
            : ivBase (n), IRQueue < Element, Base > (base ())
            {
            }

            IVQueueOnBase (IVQueueOnBase < Element, Base > const& c)
            : IRQueue < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVQueueOnBase < Element, Base >&
               operator= (IVQueueOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGQueue : public IVQueueOnBase < Element, IGQueue < Element, ElementOps > >
{
public:

  typedef IVQueueOnBaseCursor < Element, IGQueue < Element, ElementOps > > Cursor;

            IVGQueue (INumber n = 100)
            : IVQueueOnBase < Element, IGQueue < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVQueue : public IVGQueue < Element, IStdOps < Element > >
{
public:

  typedef IVQueueOnBaseCursor < Element, IGQueue < Element, IStdOps < Element > > > Cursor;

            IVQueue (INumber n = 100)
            : IVGQueue < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGQueueOnTabularSequence : public IVQueueOnBase < Element, IGQueueOnTabularSequence < Element, ElementOps > >
{
public:

  typedef IVQueueOnBaseCursor < Element, IGQueueOnTabularSequence < Element, ElementOps > > Cursor;

            IVGQueueOnTabularSequence (INumber n = 100)
            : IVQueueOnBase < Element, IGQueueOnTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVQueueOnTabularSequence : public IVGQueueOnTabularSequence < Element, IStdOps < Element > >
{
public:

  typedef IVQueueOnBaseCursor < Element, IGQueueOnTabularSequence < Element, IStdOps < Element > > > Cursor;

            IVQueueOnTabularSequence (INumber n = 100)
            : IVGQueueOnTabularSequence < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGQueueOnDilutedSequence : public IVQueueOnBase < Element, IGQueueOnDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVQueueOnBaseCursor < Element, IGQueueOnDilutedSequence < Element, ElementOps > > Cursor;

            IVGQueueOnDilutedSequence (INumber n = 100)
            : IVQueueOnBase < Element, IGQueueOnDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVQueueOnDilutedSequence : public IVGQueueOnDilutedSequence < Element, IStdOps < Element > >
{
public:

  typedef IVQueueOnBaseCursor < Element, IGQueueOnDilutedSequence < Element, IStdOps < Element > > > Cursor;

            IVQueueOnDilutedSequence (INumber n = 100)
            : IVGQueueOnDilutedSequence < Element, IStdOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

