/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVREL_H_
#define _IVREL_H_

#include <irel.h>
#include <irrel.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVRelationOnBase;

template < class Element, class Key, class Base >
class IVRelationOnBaseCursor : public Base::Cursor {
  public:
    IVRelationOnBaseCursor (IVRelationOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVRelationOnBase : public IRRelation < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVRelationOnBaseCursor < Element, Key, Base >;

public:

  typedef IVRelationOnBaseCursor < Element, Key, Base > Cursor;

            IVRelationOnBase (INumber n = 100)
            : ivBase (n), IRRelation < Element, Key, Base > (base ())
            {
              notifyModified();
            }

            IVRelationOnBase (IVRelationOnBase < Element, Key, Base > const& c)
            : IRRelation < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
            }
            IVRelationOnBase < Element, Key, Base >&
               operator= (IVRelationOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGRelation : public IVRelationOnBase < Element, Key, IGRelation < Element, Key, ElementOps > >
{
public:

  typedef IVRelationOnBaseCursor < Element, Key, IGRelation < Element, Key, ElementOps > > Cursor;

            IVGRelation (INumber n = 100)
            : IVRelationOnBase < Element, Key, IGRelation < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVRelation : public IVGRelation < Element, Key, IEKEHOps < Element , Key > >
{
public:

  typedef IVRelationOnBaseCursor < Element, Key, IGRelation < Element, Key, IEKEHOps < Element , Key > > > Cursor;

            IVRelation (INumber n = 100)
            : IVGRelation < Element, Key, IEKEHOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

