/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVSEQ_H_
#define _IVSEQ_H_

#include <iseq.h>
#include <irseq.h>
#include <ilnseq.h>
#include <itbseq.h>
#include <itdseq.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVSequenceOnBase;

template < class Element, class Base >
class IVSequenceOnBaseCursor : public Base::Cursor {
  public:
    IVSequenceOnBaseCursor (IVSequenceOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVSequenceOnBase : public IRSequence < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVSequenceOnBaseCursor < Element, Base >;

public:

  typedef IVSequenceOnBaseCursor < Element, Base > Cursor;

            IVSequenceOnBase (INumber n = 100)
            : ivBase (n), IRSequence < Element, Base > (base ())
            {
            }

            IVSequenceOnBase (IVSequenceOnBase < Element, Base > const& c)
            : IRSequence < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }
            IVSequenceOnBase < Element, Base >&
               operator= (IVSequenceOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGSequence : public IVSequenceOnBase < Element, IGSequence < Element, ElementOps > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGSequence < Element, ElementOps > > Cursor;

            IVGSequence (INumber n = 100)
            : IVSequenceOnBase < Element, IGSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSequence : public IVGSequence < Element, IStdOps < Element > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGSequence < Element, IStdOps < Element > > > Cursor;

            IVSequence (INumber n = 100)
            : IVGSequence < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGLinkedSequence : public IVSequenceOnBase < Element, IGLinkedSequence < Element, ElementOps > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGLinkedSequence < Element, ElementOps > > Cursor;

            IVGLinkedSequence (INumber n = 100)
            : IVSequenceOnBase < Element, IGLinkedSequence < Element, ElementOps > > (n)
            {
            }

};

template < class Element >
class IVLinkedSequence : public IVGLinkedSequence < Element, IStdOps < Element > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGLinkedSequence < Element, IStdOps < Element > > > Cursor;

            IVLinkedSequence (INumber n = 100)
            : IVGLinkedSequence < Element, IStdOps < Element > > (n)
            {
            }

};

template < class Element, class ElementOps >
class IVGTabularSequence : public IVSequenceOnBase < Element, IGTabularSequence < Element, ElementOps > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGTabularSequence < Element, ElementOps > > Cursor;

            IVGTabularSequence (INumber n = 100)
            : IVSequenceOnBase < Element, IGTabularSequence < Element, ElementOps > > (n)
            {
            }

};

template < class Element >
class IVTabularSequence : public IVGTabularSequence < Element, IStdOps < Element > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGTabularSequence < Element, IStdOps < Element > > > Cursor;

            IVTabularSequence (INumber n = 100)
            : IVGTabularSequence < Element, IStdOps < Element > > (n)
            {
            }

};

template < class Element, class ElementOps >
class IVGDilutedSequence : public IVSequenceOnBase < Element, IGDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGDilutedSequence < Element, ElementOps > > Cursor;

            IVGDilutedSequence (INumber n = 100)
            : IVSequenceOnBase < Element, IGDilutedSequence < Element, ElementOps > > (n)
            {
            }

};

template < class Element >
class IVDilutedSequence : public IVGDilutedSequence < Element, IStdOps < Element > >
{
public:

  typedef IVSequenceOnBaseCursor < Element, IGDilutedSequence < Element, IStdOps < Element > > > Cursor;

            IVDilutedSequence (INumber n = 100)
            : IVGDilutedSequence < Element, IStdOps < Element > > (n)
            {
            }

};

#endif

#pragma info (restore)
#pragma pack ()

