/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVSET_H_
#define _IVSET_H_

#include <iset.h>
#include <isetbst.h>
#include <isetsls.h>
#include <isetsds.h>
#include <isethks.h>
#include <isetsts.h>
#include <irset.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVSetOnBase;

template < class Element, class Base >
class IVSetOnBaseCursor : public Base::Cursor {
  public:
    IVSetOnBaseCursor (IVSetOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVSetOnBase : public IRSet < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVSetOnBaseCursor < Element, Base >;

public:

  typedef IVSetOnBaseCursor < Element, Base > Cursor;

            IVSetOnBase (INumber n = 100)
            : ivBase (n), IRSet < Element, Base > (base ())
            {
              notifyModified();
            }

            IVSetOnBase (IVSetOnBase < Element, Base > const& c)
            : IRSet < Element, Base > (base()), ivBase(c.ivBase)
            {
            }
            IVSetOnBase < Element, Base >&
               operator= (IVSetOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGSet : public IVSetOnBase < Element, IGSet < Element, ElementOps > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSet < Element, ElementOps > > Cursor;

            IVGSet (INumber n = 100)
            : IVSetOnBase < Element, IGSet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSet : public IVGSet < Element, IECOps < Element > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSet < Element, IECOps < Element > > > Cursor;

            IVSet (INumber n = 100)
            : IVGSet < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSetOnBSTKeySortedSet : public IVSetOnBase < Element, IGSetOnBSTKeySortedSet < Element, ElementOps > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnBSTKeySortedSet < Element, ElementOps > > Cursor;

            IVGSetOnBSTKeySortedSet (INumber n = 100)
            : IVSetOnBase < Element, IGSetOnBSTKeySortedSet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSetOnBSTKeySortedSet : public IVGSetOnBSTKeySortedSet < Element, IECOps < Element > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnBSTKeySortedSet < Element, IECOps < Element > > > Cursor;

            IVSetOnBSTKeySortedSet (INumber n = 100)
            : IVGSetOnBSTKeySortedSet < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSetOnSortedLinkedSequence : public IVSetOnBase < Element, IGSetOnSortedLinkedSequence < Element, ElementOps > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnSortedLinkedSequence < Element, ElementOps > > Cursor;

            IVGSetOnSortedLinkedSequence (INumber n = 100)
            : IVSetOnBase < Element, IGSetOnSortedLinkedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSetOnSortedLinkedSequence : public IVGSetOnSortedLinkedSequence < Element, IECOps < Element > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnSortedLinkedSequence < Element, IECOps < Element > > > Cursor;

            IVSetOnSortedLinkedSequence (INumber n = 100)
            : IVGSetOnSortedLinkedSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSetOnSortedTabularSequence : public IVSetOnBase < Element, IGSetOnSortedTabularSequence < Element, ElementOps > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnSortedTabularSequence < Element, ElementOps > > Cursor;

            IVGSetOnSortedTabularSequence (INumber n = 100)
            : IVSetOnBase < Element, IGSetOnSortedTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSetOnSortedTabularSequence : public IVGSetOnSortedTabularSequence < Element, IECOps < Element > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnSortedTabularSequence < Element, IECOps < Element > > > Cursor;

            IVSetOnSortedTabularSequence (INumber n = 100)
            : IVGSetOnSortedTabularSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSetOnSortedDilutedSequence : public IVSetOnBase < Element, IGSetOnSortedDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnSortedDilutedSequence < Element, ElementOps > > Cursor;

            IVGSetOnSortedDilutedSequence (INumber n = 100)
            : IVSetOnBase < Element, IGSetOnSortedDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSetOnSortedDilutedSequence : public IVGSetOnSortedDilutedSequence < Element, IECOps < Element > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnSortedDilutedSequence < Element, IECOps < Element > > > Cursor;

            IVSetOnSortedDilutedSequence (INumber n = 100)
            : IVGSetOnSortedDilutedSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSetOnHashKeySet : public IVSetOnBase < Element, IGSetOnHashKeySet < Element, ElementOps > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnHashKeySet < Element, ElementOps > > Cursor;

            IVGSetOnHashKeySet (INumber n = 100)
            : IVSetOnBase < Element, IGSetOnHashKeySet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSetOnHashKeySet : public IVGSetOnHashKeySet < Element, IEHOps < Element > >
{
public:

  typedef IVSetOnBaseCursor < Element, IGSetOnHashKeySet < Element, IEHOps < Element > > > Cursor;

            IVSetOnHashKeySet (INumber n = 100)
            : IVGSetOnHashKeySet < Element, IEHOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

