/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVSRTBAG_H_
#define _IVSRTBAG_H_

#include <irsrtbag.h>
#include <isrtbag.h>
#include <isbbst.h>
#include <isbsls.h>
#include <isbsts.h>
#include <isbsds.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVSortedBagOnBase;

template < class Element, class Base >
class IVSortedBagOnBaseCursor : public Base::Cursor {
  public:
    IVSortedBagOnBaseCursor (IVSortedBagOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVSortedBagOnBase : public IRSortedBag < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVSortedBagOnBaseCursor < Element, Base >;

public:

  typedef IVSortedBagOnBaseCursor < Element, Base > Cursor;

            IVSortedBagOnBase (INumber n = 100)
            : ivBase (n), IRSortedBag < Element, Base > (base ())
            {
            }

            IVSortedBagOnBase (IVSortedBagOnBase < Element, Base > const& c)
            : IRSortedBag < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVSortedBagOnBase < Element, Base >&
               operator= (IVSortedBagOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGSortedBag : public IVSortedBagOnBase < Element, IGSortedBag < Element, ElementOps > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBag < Element, ElementOps > > Cursor;

            IVGSortedBag (INumber n = 100)
            : IVSortedBagOnBase < Element, IGSortedBag < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedBag : public IVGSortedBag < Element, IECOps < Element > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBag < Element, IECOps < Element > > > Cursor;

            IVSortedBag (INumber n = 100)
            : IVGSortedBag < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedBagOnBSTKeySortedSet : public IVSortedBagOnBase < Element, IGSortedBagOnBSTKeySortedSet< Element, ElementOps > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnBSTKeySortedSet < Element, ElementOps > > Cursor;

            IVGSortedBagOnBSTKeySortedSet (INumber n = 100)
            : IVSortedBagOnBase < Element, IGSortedBagOnBSTKeySortedSet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedBagOnBSTKeySortedSet : public IVGSortedBagOnBSTKeySortedSet < Element, IECOps < Element > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnBSTKeySortedSet < Element, IECOps < Element > > > Cursor;

            IVSortedBagOnBSTKeySortedSet (INumber n = 100)
            : IVGSortedBagOnBSTKeySortedSet < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedBagOnSortedLinkedSequence : public IVSortedBagOnBase < Element, IGSortedBagOnSortedLinkedSequence < Element, ElementOps > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnSortedLinkedSequence < Element, ElementOps > > Cursor;

            IVGSortedBagOnSortedLinkedSequence (INumber n = 100)
            : IVSortedBagOnBase < Element, IGSortedBagOnSortedLinkedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedBagOnSortedLinkedSequence : public IVGSortedBagOnSortedLinkedSequence < Element, IECOps < Element > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnSortedLinkedSequence < Element, IECOps < Element > > > Cursor;

            IVSortedBagOnSortedLinkedSequence (INumber n = 100)
            : IVGSortedBagOnSortedLinkedSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedBagOnSortedTabularSequence : public IVSortedBagOnBase < Element, IGSortedBagOnSortedTabularSequence < Element, ElementOps > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnSortedTabularSequence < Element, ElementOps > > Cursor;

            IVGSortedBagOnSortedTabularSequence (INumber n = 100)
            : IVSortedBagOnBase < Element, IGSortedBagOnSortedTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedBagOnSortedTabularSequence : public IVGSortedBagOnSortedTabularSequence < Element, IECOps < Element > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnSortedTabularSequence < Element, IECOps < Element > > > Cursor;

            IVSortedBagOnSortedTabularSequence (INumber n = 100)
            : IVGSortedBagOnSortedTabularSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedBagOnSortedDilutedSequence : public IVSortedBagOnBase < Element, IGSortedBagOnSortedDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnSortedDilutedSequence < Element, ElementOps > > Cursor;

            IVGSortedBagOnSortedDilutedSequence (INumber n = 100)
            : IVSortedBagOnBase < Element, IGSortedBagOnSortedDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedBagOnSortedDilutedSequence : public IVGSortedBagOnSortedDilutedSequence < Element, IECOps < Element > >
{
public:

  typedef IVSortedBagOnBaseCursor < Element, IGSortedBagOnSortedDilutedSequence < Element, IECOps < Element > > > Cursor;

            IVSortedBagOnSortedDilutedSequence (INumber n = 100)
            : IVGSortedBagOnSortedDilutedSequence < Element, IECOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

