/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVSRTMAP_H_
#define _IVSRTMAP_H_

#include <irsrtmap.h>
#include <isrtmap.h>
#include <ismbst.h>
#include <ismsls.h>
#include <ismsts.h>
#include <ismsds.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVSortedMapOnBase;

template < class Element, class Key, class Base >
class IVSortedMapOnBaseCursor : public Base::Cursor {
  public:
    IVSortedMapOnBaseCursor (IVSortedMapOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVSortedMapOnBase : public IRSortedMap < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVSortedMapOnBaseCursor < Element, Key, Base >;

public:

  typedef IVSortedMapOnBaseCursor < Element, Key, Base > Cursor;

            IVSortedMapOnBase (INumber n = 100)
            : ivBase (n), IRSortedMap < Element, Key, Base > (base ())
            {
            }

            IVSortedMapOnBase (IVSortedMapOnBase < Element, Key, Base > const& c)
            : IRSortedMap < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVSortedMapOnBase < Element, Key, Base >&
               operator= (IVSortedMapOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedMap : public IVSortedMapOnBase < Element, Key, IGSortedMap < Element, Key, ElementOps > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMap < Element, Key, ElementOps > > Cursor;

            IVGSortedMap (INumber n = 100)
            : IVSortedMapOnBase < Element, Key, IGSortedMap < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedMap : public IVGSortedMap < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMap < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedMap (INumber n = 100)
            : IVGSortedMap < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedMapOnBSTKeySortedSet : public IVSortedMapOnBase < Element, Key, IGSortedMapOnBSTKeySortedSet < Element, Key, ElementOps > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnBSTKeySortedSet < Element, Key, ElementOps > > Cursor;

            IVGSortedMapOnBSTKeySortedSet (INumber n = 100)
            : IVSortedMapOnBase < Element, Key, IGSortedMapOnBSTKeySortedSet < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedMapOnBSTKeySortedSet : public IVGSortedMapOnBSTKeySortedSet < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnBSTKeySortedSet < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedMapOnBSTKeySortedSet (INumber n = 100)
            : IVGSortedMapOnBSTKeySortedSet < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedMapOnSortedLinkedSequence : public IVSortedMapOnBase < Element, Key, IGSortedMapOnSortedLinkedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnSortedLinkedSequence < Element, Key, ElementOps > > Cursor;

            IVGSortedMapOnSortedLinkedSequence (INumber n = 100)
            : IVSortedMapOnBase < Element, Key, IGSortedMapOnSortedLinkedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedMapOnSortedLinkedSequence : public IVGSortedMapOnSortedLinkedSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnSortedLinkedSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedMapOnSortedLinkedSequence (INumber n = 100)
            : IVGSortedMapOnSortedLinkedSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedMapOnSortedTabularSequence : public IVSortedMapOnBase < Element, Key, IGSortedMapOnSortedTabularSequence < Element, Key, ElementOps > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnSortedTabularSequence < Element, Key, ElementOps > > Cursor;

            IVGSortedMapOnSortedTabularSequence (INumber n = 100)
            : IVSortedMapOnBase < Element, Key, IGSortedMapOnSortedTabularSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedMapOnSortedTabularSequence : public IVGSortedMapOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedMapOnSortedTabularSequence (INumber n = 100)
            : IVGSortedMapOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedMapOnSortedDilutedSequence : public IVSortedMapOnBase < Element, Key, IGSortedMapOnSortedDilutedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnSortedDilutedSequence < Element, Key, ElementOps > > Cursor;

            IVGSortedMapOnSortedDilutedSequence (INumber n = 100)
            : IVSortedMapOnBase < Element, Key, IGSortedMapOnSortedDilutedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedMapOnSortedDilutedSequence : public IVGSortedMapOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedMapOnBaseCursor < Element, Key, IGSortedMapOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedMapOnSortedDilutedSequence (INumber n = 100)
            : IVGSortedMapOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};
#endif

#pragma info (restore)
#pragma pack ()

