/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVSRTREL_H_
#define _IVSRTREL_H_

#include <irsrtrel.h>
#include <isrtrel.h>
#include <isrsts.h>
#include <isrsds.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Key, class Base >
class IVSortedRelationOnBase;

template < class Element, class Key, class Base >
class IVSortedRelationOnBaseCursor : public Base::Cursor {
  public:
    IVSortedRelationOnBaseCursor (IVSortedRelationOnBase < Element, Key, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Key, class Base >
class IVSortedRelationOnBase : public IRSortedRelation < Element , Key, Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVSortedRelationOnBaseCursor < Element, Key, Base >;

public:

  typedef IVSortedRelationOnBaseCursor < Element, Key, Base > Cursor;

            IVSortedRelationOnBase (INumber n = 100)
            : ivBase (n), IRSortedRelation < Element, Key, Base > (base ())
            {
            }

            IVSortedRelationOnBase (IVSortedRelationOnBase < Element, Key, Base > const& c)
            : IRSortedRelation < Element, Key, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVSortedRelationOnBase < Element, Key, Base >&
               operator= (IVSortedRelationOnBase < Element, Key, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedRelation : public IVSortedRelationOnBase < Element, Key, IGSortedRelation < Element, Key, ElementOps > >
{
public:

  typedef IVSortedRelationOnBaseCursor < Element, Key, IGSortedRelation < Element, Key, ElementOps > > Cursor;

            IVGSortedRelation (INumber n = 100)
            : IVSortedRelationOnBase < Element, Key, IGSortedRelation < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedRelation : public IVGSortedRelation < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedRelationOnBaseCursor < Element, Key, IGSortedRelation < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedRelation (INumber n = 100)
            : IVGSortedRelation < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedRelationOnSortedTabularSequence : public IVSortedRelationOnBase < Element, Key, IGSortedRelationOnSortedTabularSequence < Element, Key, ElementOps > >
{
public:

  typedef IVSortedRelationOnBaseCursor < Element, Key, IGSortedRelationOnSortedTabularSequence < Element, Key, ElementOps > > Cursor;

            IVGSortedRelationOnSortedTabularSequence (INumber n = 100)
            : IVSortedRelationOnBase < Element, Key, IGSortedRelationOnSortedTabularSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedRelationOnSortedTabularSequence : public IVGSortedRelationOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedRelationOnBaseCursor < Element, Key, IGSortedRelationOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedRelationOnSortedTabularSequence (INumber n = 100)
            : IVGSortedRelationOnSortedTabularSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

template < class Element, class Key, class ElementOps >
class IVGSortedRelationOnSortedDilutedSequence : public IVSortedRelationOnBase < Element, Key, IGSortedRelationOnSortedDilutedSequence < Element, Key, ElementOps > >
{
public:

  typedef IVSortedRelationOnBaseCursor < Element, Key, IGSortedRelationOnSortedDilutedSequence < Element, Key, ElementOps > > Cursor;

            IVGSortedRelationOnSortedDilutedSequence (INumber n = 100)
            : IVSortedRelationOnBase < Element, Key, IGSortedRelationOnSortedDilutedSequence < Element, Key, ElementOps > > (n)
            {
            }
};

template < class Element , class Key >
class IVSortedRelationOnSortedDilutedSequence : public IVGSortedRelationOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > >
{
public:

  typedef IVSortedRelationOnBaseCursor < Element, Key, IGSortedRelationOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > > > Cursor;

            IVSortedRelationOnSortedDilutedSequence (INumber n = 100)
            : IVGSortedRelationOnSortedDilutedSequence < Element, Key, IEKCOps < Element , Key > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

