/************************************************************************* 
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVSRTSET_H_
#define _IVSRTSET_H_

#include <irsrtset.h>
#include <isrtset.h>
#include <issbst.h>
#include <isssls.h>
#include <isssts.h>
#include <isssds.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVSortedSetOnBase;

template < class Element, class Base >
class IVSortedSetOnBaseCursor : public Base::Cursor {
  public:
    IVSortedSetOnBaseCursor (IVSortedSetOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVSortedSetOnBase : public IRSortedSet < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVSortedSetOnBaseCursor < Element, Base >;

public:

  typedef IVSortedSetOnBaseCursor < Element, Base > Cursor;

            IVSortedSetOnBase (INumber n = 100)
            : ivBase (n), IRSortedSet < Element, Base > (base ())
            {
            }

            IVSortedSetOnBase (IVSortedSetOnBase < Element, Base > const& c)
            : IRSortedSet < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }

            IVSortedSetOnBase < Element, Base >&
               operator= (IVSortedSetOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGSortedSet : public IVSortedSetOnBase < Element, IGSortedSet < Element, ElementOps > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSet < Element, ElementOps > > Cursor;

            IVGSortedSet (INumber n = 100)
            : IVSortedSetOnBase < Element, IGSortedSet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedSet : public IVGSortedSet < Element, IECOps < Element > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSet < Element, IECOps < Element > > > Cursor;

            IVSortedSet (INumber n = 100)
            : IVGSortedSet < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedSetOnBSTKeySortedSet : public IVSortedSetOnBase < Element, IGSortedSetOnBSTKeySortedSet < Element, ElementOps > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnBSTKeySortedSet < Element, ElementOps > > Cursor;

            IVGSortedSetOnBSTKeySortedSet (INumber n = 100)
            : IVSortedSetOnBase < Element, IGSortedSetOnBSTKeySortedSet < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedSetOnBSTKeySortedSet : public IVGSortedSetOnBSTKeySortedSet < Element, IECOps < Element >
>
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnBSTKeySortedSet < Element, IECOps < Element > > > Cursor;

            IVSortedSetOnBSTKeySortedSet (INumber n = 100)
            : IVGSortedSetOnBSTKeySortedSet < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedSetOnSortedLinkedSequence : public IVSortedSetOnBase < Element, IGSortedSetOnSortedLinkedSequence < Element, ElementOps > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnSortedLinkedSequence < Element, ElementOps > > Cursor;

            IVGSortedSetOnSortedLinkedSequence (INumber n = 100)
            : IVSortedSetOnBase < Element, IGSortedSetOnSortedLinkedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedSetOnSortedLinkedSequence : public IVGSortedSetOnSortedLinkedSequence < Element, IECOps < Element > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnSortedLinkedSequence < Element, IECOps < Element > > > Cursor;

            IVSortedSetOnSortedLinkedSequence (INumber n = 100)
            : IVGSortedSetOnSortedLinkedSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedSetOnSortedTabularSequence : public IVSortedSetOnBase < Element, IGSortedSetOnSortedTabularSequence < Element, ElementOps > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnSortedTabularSequence < Element, ElementOps > > Cursor;

            IVGSortedSetOnSortedTabularSequence (INumber n = 100)
            : IVSortedSetOnBase < Element, IGSortedSetOnSortedTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedSetOnSortedTabularSequence : public IVGSortedSetOnSortedTabularSequence < Element, IECOps < Element > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnSortedTabularSequence < Element, IECOps < Element > > > Cursor;

            IVSortedSetOnSortedTabularSequence (INumber n = 100)
            : IVGSortedSetOnSortedTabularSequence < Element, IECOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGSortedSetOnSortedDilutedSequence : public IVSortedSetOnBase < Element, IGSortedSetOnSortedDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnSortedDilutedSequence < Element, ElementOps > > Cursor;

            IVGSortedSetOnSortedDilutedSequence (INumber n = 100)
            : IVSortedSetOnBase < Element, IGSortedSetOnSortedDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVSortedSetOnSortedDilutedSequence : public IVGSortedSetOnSortedDilutedSequence < Element, IECOps < Element > >
{
public:

  typedef IVSortedSetOnBaseCursor < Element, IGSortedSetOnSortedDilutedSequence < Element, IECOps < Element > > > Cursor;

            IVSortedSetOnSortedDilutedSequence (INumber n = 100)
            : IVGSortedSetOnSortedDilutedSequence < Element, IECOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

