/*************************************************************************
  IBM C/C++ Tools Version 3.00 - Collection Class Library
 (C) Copyright IBM Corporation 1992 ,1995, Licensed Program-Property of
 IBM.  All Rights Reserved.  US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with
 IBM Corp.
 *************************************************************************/


#ifndef _IVSTACK_H_
#define _IVSTACK_H_

#include <istack.h>
#include <istkts.h>
#include <istkds.h>
#include <irstack.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

template < class Element, class Base >
class IVStackOnBase;

template < class Element, class Base >
class IVStackOnBaseCursor : public Base::Cursor {
  public:
    IVStackOnBaseCursor (IVStackOnBase < Element, Base > const& c)
    : Base::Cursor (c.ivBase)
    {
    }
  };

template < class Element, class Base >
class IVStackOnBase : public IRStack < Element , Base >
{
  Base ivBase;

  Base& base () { return ivBase; }

  friend class IVStackOnBaseCursor < Element, Base >;

public:

  typedef IVStackOnBaseCursor < Element, Base > Cursor;

            IVStackOnBase (INumber n = 100)
            : ivBase (n), IRStack < Element, Base > (base ())
            {
            }

            IVStackOnBase (IVStackOnBase < Element, Base > const& c)
            : IRStack < Element, Base > (base()), ivBase(c.ivBase)
            {
              notifyModified();
            }
            IVStackOnBase < Element, Base >&
               operator= (IVStackOnBase < Element, Base > const& c)
            { ivBase = c.ivBase;
              notifyModified();
              return *this;
            }
};

template < class Element, class ElementOps >
class IVGStack : public IVStackOnBase < Element, IGStack < Element, ElementOps > >
{
public:

  typedef IVStackOnBaseCursor < Element, IGStack < Element, ElementOps > > Cursor;

            IVGStack (INumber n = 100)
            : IVStackOnBase < Element, IGStack < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVStack : public IVGStack < Element, IStdOps < Element > >
{
public:

  typedef IVStackOnBaseCursor < Element, IGStack < Element, IStdOps < Element > > > Cursor;

            IVStack (INumber n = 100)
            : IVGStack < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGStackOnTabularSequence : public IVStackOnBase < Element, IGStackOnTabularSequence < Element, ElementOps > >
{
public:

  typedef IVStackOnBaseCursor < Element, IGStackOnTabularSequence < Element, ElementOps > > Cursor;

            IVGStackOnTabularSequence (INumber n = 100)
            : IVStackOnBase < Element, IGStackOnTabularSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVStackOnTabularSequence : public IVGStackOnTabularSequence < Element, IStdOps < Element > >
{
public:

  typedef IVStackOnBaseCursor < Element, IGStackOnTabularSequence < Element, IStdOps < Element > > > Cursor;

            IVStackOnTabularSequence (INumber n = 100)
            : IVGStackOnTabularSequence < Element, IStdOps < Element > > (n)
            {
            }
};

template < class Element, class ElementOps >
class IVGStackOnDilutedSequence : public IVStackOnBase < Element, IGStackOnDilutedSequence < Element, ElementOps > >
{
public:

  typedef IVStackOnBaseCursor < Element, IGStackOnDilutedSequence < Element, ElementOps > > Cursor;

            IVGStackOnDilutedSequence (INumber n = 100)
            : IVStackOnBase < Element, IGStackOnDilutedSequence < Element, ElementOps > > (n)
            {
            }
};

template < class Element >
class IVStackOnDilutedSequence : public IVGStackOnDilutedSequence < Element, IStdOps < Element > >
{
public:

  typedef IVStackOnBaseCursor < Element, IGStackOnDilutedSequence < Element, IStdOps < Element > > > Cursor;

            IVStackOnDilutedSequence (INumber n = 100)
            : IVGStackOnDilutedSequence < Element, IStdOps < Element > > (n)
            {
            }
};

#endif

#pragma info (restore)
#pragma pack ()

