#if (defined(__IBMC__) || defined(__IBMCPP__))
#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( none )
#endif
#pragma info( restore )
#endif

#ifndef __math_h
   #define __math_h

   #ifdef __cplusplus
      extern "C" {
   #endif

   #ifndef  _LNK_CONV
      #ifdef _M_I386
         #define _LNK_CONV   _Optlink
      #else
         #define _LNK_CONV
      #endif
   #endif

   #ifndef _IMPORT
      #ifdef __IMPORTLIB__
         #define _IMPORT _Import
      #else
         #define _IMPORT
      #endif
   #endif

   /********************************************************************/
   /*  <math.h> header file                                            */
   /*                                                                  */
   /*  IBM VisualAge C++ for OS/2, Version 3.00                        */
   /*  (C) Copyright IBM Corp. 1991, 1995.                             */
   /*  - Licensed Material - Program-Property of IBM                   */
   /*  - All rights reserved                                           */
   /*                                                                  */
   /********************************************************************/

   extern const double _infinity;
   #define HUGE_VAL    _infinity

   /* function prototypes */

   double _IMPORT _LNK_CONV atan2( double, double );
   double _IMPORT _LNK_CONV ceil( double );
   double _IMPORT _LNK_CONV cosh( double );
   double _IMPORT _LNK_CONV exp( double );
   double _IMPORT _LNK_CONV floor( double );
   double _IMPORT _LNK_CONV fmod( double, double );
   double _IMPORT _LNK_CONV frexp( double, int * );
   double _IMPORT _LNK_CONV ldexp( double, int );
   double _IMPORT _LNK_CONV log( double );
   double _IMPORT _LNK_CONV log10( double );
   double _IMPORT _LNK_CONV modf( double, double * );
   double _IMPORT _LNK_CONV pow( double, double );
   double _IMPORT _LNK_CONV sinh( double );
   double _IMPORT _LNK_CONV tanh( double );

   #if (defined( _FP_INLINE ))

      double _Builtin __fabs ( double );
      double _Builtin __fsin ( double );
      double _Builtin __fcos ( double );
      double _Builtin __fptan ( double );
      double _Builtin __fpatan ( double );
      double _Builtin __facos ( double );
      double _Builtin __fasin ( double );
      double _Builtin __fsqrt ( double );

      #ifdef __cplusplus
         inline double _LNK_CONV fabs( double x ) { return __fabs  ( x ); }
         inline double _LNK_CONV sin ( double x ) { return __fsin  ( x ); }
         inline double _LNK_CONV cos ( double x ) { return __fcos  ( x ); }
         inline double _LNK_CONV tan ( double x ) { return __fptan ( x ); }
         inline double _LNK_CONV atan( double x ) { return __fpatan( x ); }
         inline double _LNK_CONV acos( double x ) { return __facos ( x ); }
         inline double _LNK_CONV asin( double x ) { return __fasin ( x ); }
         inline double _LNK_CONV sqrt( double x ) { return __fsqrt ( x ); }
      #else
         #define sin( x )       __fsin( (x) )
         #define cos( x )       __fcos( (x) )
         #define tan( x )       __fptan( (x) )
         #define atan( x )      __fpatan( (x) )
         #define acos( x )      __facos( (x) )
         #define asin( x )      __fasin( (x) )
         #define sqrt( x )      __fsqrt( (x) )
         #define fabs( x )      __fabs( (x) )
      #endif
   #else

      double _IMPORT _LNK_CONV fabs( double );
      double _IMPORT _LNK_CONV asin( double );
      double _IMPORT _LNK_CONV acos( double );
      double _IMPORT _LNK_CONV atan( double );
      double _IMPORT _LNK_CONV sin( double );
      double _IMPORT _LNK_CONV cos( double );
      double _IMPORT _LNK_CONV tan( double );
      double _IMPORT _LNK_CONV sqrt( double );

   #endif

   #ifndef __ANSI__
      double _IMPORT _LNK_CONV _erf( double );
      double _IMPORT _LNK_CONV _erfc( double );
      double _IMPORT _LNK_CONV _gamma( double );
      double _IMPORT _LNK_CONV _hypot( double, double );
      double _IMPORT _LNK_CONV _j0( double );
      double _IMPORT _LNK_CONV _j1( double );
      double _IMPORT _LNK_CONV _jn( int, double );
      double _IMPORT _LNK_CONV _y0( double );
      double _IMPORT _LNK_CONV _y1( double );
      double _IMPORT _LNK_CONV _yn( int, double );
      double _IMPORT _LNK_CONV erf( double );
      double _IMPORT _LNK_CONV erfc( double );
      double _IMPORT _LNK_CONV gamma( double );
      double _IMPORT _LNK_CONV hypot( double, double );
      double _IMPORT _LNK_CONV j0( double );
      double _IMPORT _LNK_CONV j1( double );
      double _IMPORT _LNK_CONV jn( int, double );
      double _IMPORT _LNK_CONV y0( double );
      double _IMPORT _LNK_CONV y1( double );
      double _IMPORT _LNK_CONV yn( int, double );

    #if (defined(__IBMC__) || defined(__IBMCPP__))
      #pragma map( erf, "_erf" )
      #pragma map( erfc, "_erfc" )
      #pragma map( gamma, "_gamma" )
      #pragma map( hypot, "_hypot" )
      #pragma map( j0, "_j0" )
      #pragma map( j1, "_j1" )
      #pragma map( jn, "_jn" )
      #pragma map( y0, "_y0" )
      #pragma map( y1, "_y1" )
      #pragma map( yn, "_yn" )
    #else
      #pragma Alias( erf, "_erf" )
      #pragma Alias( erfc, "_erfc" )
      #pragma Alias( gamma, "_gamma" )
      #pragma Alias( hypot, "_hypot" )
      #pragma Alias( j0, "_j0" )
      #pragma Alias( j1, "_j1" )
      #pragma Alias( jn, "_jn" )
      #pragma Alias( y0, "_y0" )
      #pragma Alias( y1, "_y1" )
      #pragma Alias( yn, "_yn" )
    #endif

      #ifndef __SAA_L2__
         extern const long double _LHUGE_VAL;
         #define _LHUGE _LHUGE_VAL
      #endif

      #if  defined(__EXTENDED__)

         #define HUGE   HUGE_VAL

         #define DOMAIN           1       /* argument domain error */
         #define SING             2       /* argument singularity */
         #define OVERFLOW         3       /* overflow range error */
         #define UNDERFLOW        4       /* underflow range error */
         #define TLOSS            5       /* total loss of precision */
         #define PLOSS            6       /* partial loss of precision */
         #define UNKNOWN          7       /* unknown error probably caused by */
                                          /* changing the 80387 control word */

          #if (!defined(__cplusplus) || defined(__C_complex))
           struct complex
               {
               double x,y;             /* real and imaginary parts */
               };

           double      _IMPORT _LNK_CONV _cabs( struct complex );
          #endif

          #pragma info( none )
          #define _cabs( z ) _hypot( (z).x, (z).y )
          #define cabs( a ) _cabs( a )
          #pragma info( restore )

         struct exception
            {
            int type;               /* exception type - see below */
            char *name;             /* name of function where error occured */
            double arg1;            /* first argument to function */
            double arg2;            /* second argument (if any) to function */
            double retval;          /* value to be returned by function */
            };

         /* _matherr is defined by the user */

         int _matherr( struct exception * );
         int  matherr( struct exception * );

         #pragma map( matherr, "_matherr" )

         long double _LNK_CONV _atold( const char * );

      #endif

   #endif

   #ifdef __cplusplus
      }
   #endif

#endif

#if (defined(__IBMC__) || defined(__IBMCPP__))
#pragma info( none )
#ifndef __CHKHDR__
   #pragma info( restore )
#endif
#pragma info( restore )
#endif
